﻿
; --------------------------------
; this is an on-screen demo, not an introduction.
; you don't HAVE to understand the code.
; --------------------------------

EnableExplicit

XIncludeFile "sgx.pbi"     ; include normal version
;XIncludeFile "sgx_.pbi"   ; include development version


InitSprite()
InitMouse()
InitKeyboard()

OpenConsole("sgx demo console")

Global ww=1000
Global wh=700
Global hWin
Global style
Global event, em
Global quit
Global id
Global time
Global refreshed

style | #PB_Window_ScreenCentered
style | #PB_Window_SystemMenu
style | #PB_Window_MinimizeGadget

If 01
  hWin=OpenWindow(0, 50,100,ww,wh, "sgx demo",style) :: AddKeyboardShortcut(0,#PB_Shortcut_Escape,10)
  OpenWindowedScreen( hWin, 0,0,ww,wh, 0,0,0)
  ResizeWindow(0, WindowX(0)+200, #PB_Ignore, #PB_Ignore, #PB_Ignore)
Else
  OpenScreen(ww,wh,32,"",#PB_Screen_NoSynchronization)
  SetFrameRate(999)
EndIf

Global currentColor, pickedColor, colorAlpha, x, y
Global paletteSprite
Global winColorPicker
Global spriteGadgetColorPicker
Global alphaTrackbarColorPicker
Global someSprite
Global button_sgx_debugInfos
Global button_resizable
Global button_refreshAll
Global button_disableSome

;sgx_lowbudgetDistortion = 0.2
;sgx_lowbudgetDistortColors = 0

; load some designs
Global *lowbudget.sgxS_Design = sgxLoadDesign("lowbudget")
sgxLoadDesign("sgxDesigns\blue")
sgxLoadDesign("sgxDesigns\grey")
sgxLoadDesign("sgxDesigns\ice")
sgxLoadDesign("sgxDesigns\next")
sgxLoadDesign("sgxDesigns\outdoor")

; load a design and assign our custom draw callbacks (defined in a separate file)
Global *customDraw.sgxS_Design = sgxLoadDesign("lowbudget")
XIncludeFile "sgxDoc/16customDraw2_callbacks.pbi"
*customDraw\onBeginDraw = @myOnBeginDraw()
*customDraw\onEndDraw = @myOnEndDraw()

currentColor = *lowbudget\basecolor

someSprite = LoadSprite(#PB_Any, "sgxDoc\img\load.png")
TransparentSpriteColor(someSprite, $ffffff)

Declare createElements()

createElements()

Repeat
  ExamineMouse()
  ExamineKeyboard()
  
  ;{ pb window events
  If IsWindow(0)
    Repeat
      event=WindowEvent()
      em=EventMenu()
      Select event
        Case #PB_Event_CloseWindow
          quit = #True
        Case #PB_Event_Menu
          Select em
          Case 10
            quit = #True
          EndSelect
      EndSelect
    Until Not event
  EndIf
  ;}
  
  sgxExamine()
  
  ;{ handle color picker events
  If (sgx(spriteGadgetColorPicker) And sgx(alphaTrackbarColorPicker)) And (sgx(spriteGadgetColorPicker)\leftdown Or sgx(alphaTrackbarColorPicker)\changed)
    
    ; color picked
    If sgx(spriteGadgetColorPicker)\leftdown
      StartDrawing(SpriteOutput(sgx(spriteGadgetColorPicker)\state))
        x = sgx_m\x-sgx(spriteGadgetColorPicker)\x
        y = sgx_m\y-sgx(spriteGadgetColorPicker)\y
        pickedColor = currentColor
        If x>=0 And x<OutputWidth() And y>=0 And y<OutputHeight()
          pickedColor = Point(x, y)
        EndIf
      StopDrawing()
      ; change rgb, keep alpha value
      currentColor = RGBA(Red(pickedColor), Green(pickedColor), Blue(pickedColor), Alpha(currentColor))
    EndIf
    
    ; alpha changed
    If sgx(alphaTrackbarColorPicker)\changed
      colorAlpha = sgx(alphaTrackbarColorPicker)\state
      If colorAlpha < 40
        colorAlpha = 40
      EndIf
      ; change alpha value, keep rgb
      currentColor = RGBA(Red(currentColor), Green(currentColor), Blue(currentColor), colorAlpha)
    EndIf
    
    ; update design and it's elements
    *lowbudget\basecolor = currentColor
    sgxRefreshDesign(*lowbudget)
    For sgxEach(id)
      If sgx(id)\design = *lowbudget
        sgxRefresh(id)
      EndIf
    Next
    ; our spriteGadget's sprite is not affected by design transparency but by element transparency.
    sgxSetAlpha(Alpha(currentColor), spriteGadgetColorPicker)
  EndIf ;}
  
  refreshed = 0
  For sgxEach(id)
    ;If sgx(id)\hover          : PrintN("id "+id+": hover")      : EndIf
    If sgx(id)\leftclick      : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": leftclick")      : EndIf
    If sgx(id)\leftdown       : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": leftdown")      : EndIf
    If sgx(id)\lefthold       : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": lefthold")      : EndIf
    If sgx(id)\leftup         : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": leftup")      : EndIf
    If sgx(id)\rightclick     : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": rightclick")      : EndIf
    If sgx(id)\rightdown      : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": rightdown")      : EndIf
    If sgx(id)\rightup        : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": rightup")      : EndIf
    If sgx(id)\changed        : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": changed: "+sgx(id)\changed+" (state:"+sgx(id)\state+")")      : EndIf
    If sgx(id)\resized        : PrintN("id "+id+" ["+sgx_getTypeString(id)+"]"+": resized")      : EndIf
    If sgx(id)\refreshed      : refreshed + 1  : EndIf
  Next
  If refreshed      : PrintN(""+refreshed+" elements refreshed")
  EndIf
  
  If sgx(button_sgx_debugInfos)\changed
    If sgx(button_sgx_debugInfos)\state
      sgx_debugInfos = 1
    Else
      sgx_debugInfos = 0
    EndIf
  EndIf
  
  If sgx(button_resizable)\changed
    If sgx(button_resizable)\state
      For sgxEach(id)
        sgxSetResizable(id, #True)
      Next
    Else
      For sgxEach(id)
        sgxSetResizable(id, #False)
      Next
    EndIf
  EndIf
  
  If sgx(button_refreshAll)\leftup
    time = ElapsedMilliseconds()
    sgxRefreshAll()
    time = ElapsedMilliseconds() - time
    sgxSetText(button_refreshAll, "refresh all ("+time+"ms)")
    PrintN(">>>>> ms : " + time)
  EndIf
  
  If sgx(button_disableSome)\changed
    If sgx(button_disableSome)\state
      For sgxEach(id)
        If id <> button_disableSome
          If Random(1)
            sgxSetDisabled(id, #True)
          Else
            sgxSetResizable(id, #False)
          EndIf
        EndIf
      Next
    Else
      For sgxEach(id)
        sgxSetDisabled(id, #False)
      Next
    EndIf
  EndIf
  
  For sgxEach(id)
    If sgx(id)\leftup And sgx(id)\text = "QUIT"
      quit = #True
    EndIf
  Next
  
  sgxDisplay()
  
  ; make screenshot, open it, quit program
  If KeyboardPushed(#PB_Key_F12)
    SaveSprite( GrabSprite(#PB_Any,0,0,ScreenWidth(),ScreenHeight()), "screenshot.bmp") : Delay(500) : RunProgram("screenshot.bmp") :End
  EndIf
  
  FlipBuffers()
  ClearScreen($333333)
  ;Delay(10)
Until quit Or KeyboardPushed(#PB_Key_Escape)



Procedure createElements()
  
  ; #############################################################
  
  ;{ ---- create some elements for each design
  
  Protected x, y, txt.s, txt2.s, tablestyle, title.s
  Protected w1,w2,w3,t,bt,ed,tx,co,ch,tr,ar
  x = 0
  y = 0
  
  txt = ""
  txt + "a simple text" + #LF$ + "editing component" + #LF$
  txt + "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy" + #LF$
  txt + "eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam" + #LF$
  txt + "voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet" + #LF$
  txt + "clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit" + #LF$
  txt + "amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam" + #LF$
  txt + "nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed" + #LF$
  txt + "diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet" + #LF$
  txt + "clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet."
  
  FirstElement(sgxDesign())
  sgxSetDesign(sgxDesign())
  sgxCursor(1)
  
  ForEach sgxDesign()
    sgxSetDesign(sgxDesign())
    
    If sgxDesign()\name = "sgxDesigns\next"
      sgxSetAlpha(150)
    Else
      sgxSetAlpha(255)
    EndIf
    
    If sgxDesign() = *lowbudget
      button_sgx_debugInfos = sgxButton(-1, 200,4,  96,22, "sgx_debugInfos", #sgxStateOff)
      button_resizable      = sgxButton(-1, 300,4,  96,22, "resizable", #sgxStateOff)
      button_refreshAll     = sgxButton(-1, 400,4,  96,22, "refresh all", #sgxStateNone)
      button_disableSome    = sgxButton(-1, 500,4,  96,22, "disable some", #sgxStateOff)
      sgxTip(button_sgx_debugInfos, "activate some onscreen debugging")
      sgxTip(button_resizable, "make all elements resizable")
      sgxTip(button_refreshAll, "measure refresh time (better without debugger)")
      sgxTip(button_disableSome, "disable some elements")
    EndIf
  
    ;tablestyle | #sgxStyleNoBG
    tablestyle | #sgxStyleGrid
    tablestyle | #sgxStyleFitCellW
    tablestyle | #sgxStyleFitCellH
    
    title = sgxDesign()\name
    txt2 = txt
    If sgxDesign() = *lowbudget
      title = "design: " + title
    ElseIf sgxDesign() = *customDraw
      title = "CUSTOM DRAW"
      x + 80
    EndIf
    
    w1 = sgxWin(-1, 20+x, 40+y, 153,458, title)
      t = sgxTable(-1, 10, 25, 1,20, 6, tablestyle)
        bt = sgxCellAssign(0,0, sgxButton(-1, 0,0,  50,20, "QUIT") )
        ed = sgxCellAssign(0,1, sgxEdit(-1, 0,0, 120,60, txt) )
        tx = sgxCellAssign(0,2, sgxText(-1, 0,0,  -1,-1, "static text", #sgxStyleHoverThin) )
        co = sgxCellAssign(0,3, sgxCombo(-1, 0,0,  80,16, "entry one"+#LF$+"entry two"+#LF$+"entry three"+#LF$+"entry four") )
        ch = sgxCellAssign(0,4, sgxCheckbox(-1, 0,0,15,15, #sgxStateOff, "a checkbox") )
        ch = sgxCellAssign(0,5, sgxCheckbox(-1, 0,0,15,15, #sgxStateOn, "a checkbox") )
        ch = sgxCellAssign(0,6, sgxCheckbox(-1, 0,0,15,15, #sgxStateOn, "a checkbox", #sgxAlignCheckboxTextLeft) )
        tr = sgxCellAssign(0,7, sgxScrollbar(-1, 0,0, 80,12, 16,10, 1000) )
        tr = sgxCellAssign(0,8, sgxTrackbar(-1, 0,0, 80,12, 10,16, 1000) )
        bt = sgxCellAssign(0,9, sgxButton(-1, 0,0,  50,20, "button", #sgxStateNone) )
        bt = sgxCellAssign(0,10, sgxButton(-1, 0,0,  50,20, "toggle button", #sgxStateOn) )
        bt = sgxCellAssign(0,11, sgxButton(-1, 0,0,  50,25, "sprite button", #sgxStateNone, someSprite) )
        bt = sgxCellAssign(0,12, sgxSpriteGadget(-1, 0,0, someSprite) )
      sgxCloseLevel()
      
      w2 = sgxWin(-1, 90, 120, 150,100, "radio group example")
        bt = sgxButton(-1, 10,25, 130,20, "YES", #sgxStateOn)           : sgxSetGroup(bt, 123)
        bt = sgxButton(-1, 10,50, 130,20, "NO", #sgxStateOff)           : sgxSetGroup(bt, 123)
        ch = sgxCheckbox(-1, 10,75,15,15, #sgxStateOff, "i don't care") : sgxSetGroup(ch, 123)
      sgxCloseLevel()
    sgxCloseLevel()
    
    If sgxDesign() = *customDraw
      sgxTip(w1, "you can do all the" + #LF$ + "drawing yourself on" + #LF$ + "a per-element basis" + #LF$ + "using custom draw" + #LF$ + "callbacks." + #LF$)
    EndIf
    
    x + 110
    If Not y
      y = 50
    Else
      y = 0
    EndIf
  Next
  ;}
  ;  ----
  
  ; #############################################################
  
  ;{ ----  color picker
  Protected r,g,b, i,k,stage
  ;  create color picker sprite
  paletteSprite = CreateSprite(#PB_Any,256,256)
  StartDrawing(SpriteOutput(paletteSprite))
    ; we start with red
    r=255 :: g=0 :: b=0
    For i=0 To 255
      ; get color for current x-position
      Select stage
      Case 0 : g+6 : If g>255 :g=255:stage+1: EndIf ; in the first sixth of width we increase green from 0 to 255
      Case 1 : r-6 : If r<0   :r=0  :stage+1: EndIf ; in the second sixth we decrease red from 255 to 0
      Case 2 : b+6 : If b>255 :b=255:stage+1: EndIf ; ..change other components to get more combinations
      Case 3 : g-6 : If g<0   :g=0  :stage+1: EndIf
      Case 4 : r+6 : If r>255 :r=255:stage+1: EndIf
      Case 5 : b-6 : If b<0   :b=0  :stage+1: EndIf
      EndSelect
      ; draw the color in different brightness along y-axis
      For k=0 To 255
        Plot(i,k,sgx_fade(RGB(r,g,b),k*2000/255-1000))
      Next
    Next
  StopDrawing()
  
  sgxSetDesign(*lowbudget)
  
  ; color picker
  winColorPicker = sgxWin(-1, 600,400, 290,280, "change color/transparency of 'lowbudget'")
    spriteGadgetColorPicker = sgxSpriteGadget(-1, 4,20, paletteSprite)
    alphaTrackbarColorPicker = sgxTrackbar(-1, 270,24, 10,SpriteHeight(paletteSprite)-8, 16,10, 255)
    sgxSetState(alphaTrackbarColorPicker, Alpha(currentColor))
  sgxCloseLevel()
  
  ;} 
  ;  ----
  
  ; #############################################################
  
  sgxWin(-1, 50, 520, 200,160, "window")
    sgxText(-1, 10,25, 180,-1, "below is an sgxArea which gives"+#LF$+"you events without being visible:", #sgxStyleHoverThin)
    sgxArea(-1, 10,70, 180,80)
  sgxCloseLevel()
  
  sgxSetFont(LoadFont(#PB_Any, "Comic Sans MS", 16))
  
  sgxWin(-1, 210, 620, 260,75, "window")
    sgxText(-1, 10,35, -1,-1, "used another font here")
  sgxCloseLevel()
  
  sgxSetFont(sgxStdFont)
  
  sgxWin(-1, 320, 510, 260,145, " ")
    sgxText(-1, 10,25, 240,-1, "text elements",                #sgxStyleHoverThin, 2, #sgxAlignTextRight)
    sgxText(-1, 10,50, 240,-1, "support different alignments", 0, 3, #sgxAlignTextCenter)
    sgxText(-1, 10,75, 165,-1, "and styles as well as multiple lines, automatic wordwrap and justified text", #sgxStyleHoverThin, 8, #sgxAlignTextJustifySpaces, #True)
  sgxCloseLevel()
  
EndProcedure



; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 9
; Folding = s
; Executable = demo.exe
; CompileSourceDirectory