
XIncludeFile "_sgx_includer.pbi"

; -------------------------------------
; this example provides a GUI to test:
;    - sgxSetWinAnimStyle()
;    - sgxAnimTime
; wich change the behaviour of:
;    - sgxPresentWin()
;    - sgxMinimizeWin()
;    - sgxRestoreWin()
;    - sgxCloseWin()
; -------------------------------------

Declare addWindow()
Declare updateAnimTime()
Declare updateAnimationStyles()

Enumeration
  #RadioGroup1
  #RadioGroup2
EndEnumeration

InitSprite()
InitMouse()
InitKeyboard()

OpenWindowedScreen( OpenWindow(0, 200,100, 800,600, "esc:quit"),  0,0, 800,600, 0,0,0)

design=sgxLoadDesign("../sgxDesigns/blue")

; we set some default transparence
sgxSetAlpha(150)

cur=sgxCursor(-1)
sgxText(-1, 10,5, 700,15, "press 'present window' to test combinations of animation styles for animation types. (close windows by rightclicking the close button)")

quitButton=sgxButton(-1, 10,30, 200,25, "quit")
addButton=sgxButton(-1, 220,30, 200,25, "present window")


; -----------------------------------------------
; animation time controls
sgxWin(-1, 440,30, 258,35)
  animTime=sgxTrackbar(-1, 6,10, 100,10, 10,20, 3000)
  animTimeLabel=sgxText(-1, 120,6, 130,20, "", #sgxStyleThin)
sgxCloseLevel()
sgxSetState(animTime, sgxAnimTime)
updateAnimTime()

; -----------------------------------------------
; style controls for 'presenting'
sgxWin(-1, 10,70, 260,125)
  sgxText(-1, 10,5, 240,20, "presenting")
  pre_alpha=sgxButton(-1, 10,30, 240,25, "#sgxAnimFade", #sgxStateOff)
  pre_sizeW=sgxButton(-1, 10,60, 240,25, "#sgxAnimSizeW", #sgxStateOff)
  pre_sizeH=sgxButton(-1, 10,90, 240,25, "#sgxAnimSizeH", #sgxStateOff)
sgxCloseLevel()

sgxSetState(pre_alpha, #True)
sgxSetState(pre_sizeW, #True)
sgxSetState(pre_sizeH, #True)

; -----------------------------------------------
; style controls for 'closing'
sgxWin(-1, 280,70, 260,125)
  sgxText(-1, 10,5, 240,20, "closing")
  clo_alpha=sgxButton(-1, 10,30, 240,25, "#sgxAnimFade", #sgxStateOff)
  clo_sizeW=sgxButton(-1, 10,60, 240,25, "#sgxAnimSizeW", #sgxStateOff)
  clo_sizeH=sgxButton(-1, 10,90, 240,25, "#sgxAnimSizeH", #sgxStateOff)
sgxCloseLevel()

sgxSetState(clo_alpha, #True)
sgxSetState(clo_sizeW, #True)
sgxSetState(clo_sizeH, #True)

; -----------------------------------------------
; style controls for 'minimize'
sgxWin(-1, 10,205, 260,175)
  sgxText(-1, 10,5, 240,20, "minimizing")
  min_alpha    =sgxButton(-1, 10, 30, 240,25, "#sgxAnimFade", #sgxStateOff)
  min_roll     =sgxButton(-1, 10, 80, 240,25, "#sgxAnimRoll", #sgxStateOff)
  min_zoom     =sgxButton(-1, 10,110, 240,25, "#sgxAnimZoom", #sgxStateOff)
  min_noResize =sgxButton(-1, 10,140, 240,25, "no resize/move", #sgxStateOff)
sgxCloseLevel()
; roll and zoom are exclusive, so we use a radio group
sgxSetGroup(min_roll, #RadioGroup1)
sgxSetGroup(min_zoom, #RadioGroup1)
sgxSetGroup(min_noResize, #RadioGroup1)

sgxSetState(min_alpha, #True)
sgxSetState(min_roll, #True)

; -----------------------------------------------
; style controls for 'restore'
sgxWin(-1, 280,205, 260,175)
  sgxText(-1, 10,5, 240,20, "restoring")
  res_alpha    =sgxButton(-1, 10, 30, 240,25, "#sgxAnimFade", #sgxStateOff)
  res_roll     =sgxButton(-1, 10, 80, 240,25, "#sgxAnimRoll", #sgxStateOff)
  res_zoom     =sgxButton(-1, 10,110, 240,25, "#sgxAnimZoom", #sgxStateOff)
  res_noResize =sgxButton(-1, 10,140, 240,25, "no resize/move", #sgxStateOff)
sgxCloseLevel()
; roll and zoom are exclusive, so we use a radio group
sgxSetGroup(res_roll, #RadioGroup2)
sgxSetGroup(res_zoom, #RadioGroup2)
sgxSetGroup(res_noResize, #RadioGroup2)

sgxSetState(res_alpha, #True)
sgxSetState(res_roll, #True)

; update animation config from buttons' states
updateAnimationStyles()

Repeat
  ExamineMouse()
  ExamineKeyboard()
  
  ; pb window events
  If IsWindow(0)
    Repeat
      event=WindowEvent()
      Select event
        Case #PB_Event_CloseWindow
          quit = #True
      EndSelect
    Until Not event
  EndIf
  
  sgxExamine()
  
  If sgx(quitButton)\leftclick
    quit = #True
  EndIf
  If (sgx(addButton)\leftclick)
      addWindow()
  EndIf
  If (sgx(animTime)\changed)
    updateAnimTime()
  EndIf
  ; if (for simplicity) any button has been clicked then update animation config
  For sgxEach(id)
    If (sgx(id)\type = #sgxTypeButton Or sgx(id)\type = #sgxTypeButtonToggle) And sgx(id)\leftclick
      updateAnimationStyles()
    EndIf
  Next
  
  sgxDisplay()
  
  FlipBuffers()
  ClearScreen($333333)
  Delay(5)
Until quit Or KeyboardReleased(#PB_Key_Escape)






Procedure addWindow()
  win1=sgxWin(-1, 10+Random(1*500), 400+Random(1*100), 220,130, "window title")
    bt=sgxButton(-1, 10,30, 200,20, "button 1")
    ; (test restoring of child visibility)
    ; sgxSetShow(bt, #False)
    tb=sgxTrackbar(-1, 10,60, 200,20, 10,20, 99)
    tx=sgxText(-1, 10, 90, 200, -1, "ertg qe5z wru etzij rtj rtzj etzjh"+#LF$+"ertg qe5z wru etzij rtj", #sgxStyleHoverThin)
    win2=sgxWin(-1, 180+Random(0*50), 20+Random(0*50), 180,60, "child window")
      bt2=sgxButton(-1, 10,30, 160,20, "button")
    sgxCloseLevel()
  sgxCloseLevel()
  sgxPresentWin(win1)
EndProcedure

Procedure updateAnimTime()
  Shared animTime, animTimeLabel
  sgxAnimTime = sgx(animTime)\state
  sgxSetText(animTimeLabel, "sgxAnimTime: "+Str(sgxAnimTime))
EndProcedure

Procedure updateAnimationStyles()
  Shared min_alpha, min_roll, min_zoom
  Shared res_alpha, res_roll, res_zoom
  Shared clo_alpha, clo_sizeW, clo_sizeH
  Shared pre_alpha, pre_sizeW, pre_sizeH
  
  style = 0
  If sgx(min_alpha)\state
    style | #sgxAnimFade
  EndIf
  If sgx(min_roll)\state
    style | #sgxAnimRoll
  ElseIf sgx(min_zoom)\state
    style | #sgxAnimZoom
  EndIf
  sgxSetWinAnimStyle(#sgxWinStateMinimizing, style)
  
  style = 0
  If sgx(res_alpha)\state
    style | #sgxAnimFade
  EndIf
  If sgx(res_roll)\state
    style | #sgxAnimRoll
  ElseIf sgx(res_zoom)\state
    style | #sgxAnimZoom
  EndIf
  sgxSetWinAnimStyle(#sgxWinStateRestoring, style)
  
  style = 0
  If sgx(clo_alpha)\state
    style | #sgxAnimFade
  EndIf
  If sgx(clo_sizeW)\state
    style | #sgxAnimSizeW
  EndIf
  If sgx(clo_sizeH)\state
    style | #sgxAnimSizeH
  EndIf
  sgxSetWinAnimStyle(#sgxWinStateClosing, style)
  
  style = 0
  If sgx(pre_alpha)\state
    style | #sgxAnimFade
  EndIf
  If sgx(pre_sizeW)\state
    style | #sgxAnimSizeW
  EndIf
  If sgx(pre_sizeH)\state
    style | #sgxAnimSizeH
  EndIf
  sgxSetWinAnimStyle(#sgxWinStatePresenting, style)
  
EndProcedure

; IDE Options = PureBasic 5.42 LTS (Windows - x64)
; CursorPosition = 162
; FirstLine = 147
; Folding = -
; CompileSourceDirectory