
XIncludeFile "_sgx_includer.pbi"

InitSprite()
InitMouse()
InitKeyboard()

ww=600
wh=400
OpenWindowedScreen( OpenWindow(0, 1,1, ww,wh,"..", #PB_Window_BorderLess | #PB_Window_ScreenCentered), 0,0,ww,wh,0,0,0)

; the simplest way to give transparency to all your sgx elements is
; to use sgxSetAlpha() with a single parameter to set the default
; element alpha before creating your elements. to change the alpha
; of a single element use the element id as a second parameter.
; 
; for the design 'lowbudget' you can specify an alternative design
; basecolor at sgxLoadDesign() including the alpha value. for
; 'lowbudget' that basecolor (including alpha channel) is applied
; to all design components and also element text etc. for other designs
; the basecolor only influences text and thin borders.
; 
; if you use the alpha channel in the design image files you could
; have different transparency for different areas of the background
; for example, or make only the borders transparent in the parts
; image.
; 
; note that the alpha value of the design images and colors do get
; blended with the element alpha value used at display. so an element
; with alpha 255 will still be tranparent if the design is transparent
; and vice versa.
; also note that a basecolor of opaque white $ffffffff will evaluate
; to -1 on 32bit systems so that the default color is being used instead.
;
; another way of influencing transparency is by modifying the alpha
; channel of the element sprites via a custom drawing callback which
; is shown in another example.

design_lowbudget=sgxLoadDesign("lowbudget")
design_lowbudget_mod=sgxLoadDesign("lowbudget", RGBA(0,0,255,200))
design_ice=sgxLoadDesign("..\sgxDesigns\ice")
If Not (design_lowbudget And design_lowbudget_mod And design_ice)
  MessageRequester("error","can't load design")
  End
EndIf

; standard lowbudget without transparency
sgxSetDesign(design_lowbudget)
cur = sgxCursor(-1)
exit = sgxButton(-1, 10,30, 100,30, "quit")

; use images with alpha channel
sgxSetDesign(design_ice)
w1 = sgxWin(-1, 90,25, 220,70, "alpha channel")
  b1 = sgxButton(-1, 10,30, 200,30, "from design images")
sgxCloseLevel()

; use default alpha and element alpha
sgxSetDesign(design_lowbudget)
sgxSetAlpha(150)
w2 = sgxWin(-1, 180,40, 220,70, "changed default element alpha")
  b2 = sgxButton(-1, 10,30, 200,30, "changed element alpha")
  sgxSetAlpha(255, b2) ; <- change alpha only of button element
sgxCloseLevel()
sgxSetAlpha(255) ; <- reset default alpha

; use basecolor
sgxSetDesign(design_lowbudget_mod)
w3 = sgxWin(-1, 280,55, 220,70, "alpha from design basecolor")
  b3 = sgxButton(-1, 10,30, 200,30, "specified at loadDesign()")
sgxCloseLevel()

; live change of element alpha (done in mainloop)
sgxSetDesign(design_lowbudget)
w4 = sgxWin(-1, 380,70, 220,70, "fading")
  t = sgxText(-1, 10,30, 200,-1, "element alpha change does not"+#LF$+"need an element refesh", #sgxStyleHoverThin)
sgxCloseLevel()
  

Repeat
  ExamineMouse()
  ExamineKeyboard()
  
  ; pb window events
  Repeat
    event=WindowEvent()
    Select event
      Case #PB_Event_CloseWindow
        quit = #True
    EndSelect
  Until Not event
  
  sgxExamine()
  
  If sgx(exit)\leftclick
    quit = #True
  EndIf
  
  alpha = alpha + 4 - 255*Bool(alpha > 255) ; <- add 4 to alpha per frame and reset it if its > 255
  sgxSetAlpha(alpha, w4)
  
  sgxDisplay()

  FlipBuffers()
  ClearScreen($002222)
  Delay(5)
Until quit Or KeyboardPushed(#PB_Key_Escape)



; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 36
; FirstLine = 15
; HideErrorLog
; CompileSourceDirectory