


;{ #################### sgx

;**
;* sgx is a screen-gadget library for PureBasic programmers to create and manage simple GUI-elements 
;* in a fullscreen or windowed screen. _
;* _
;* it's available as sourcecode to be included in your projects. it's currently only available for 
;* Windows Operating Systems (though the code is pretty straight PB code). there are two 
;* versions: a single-file version that only contains the necessary files to just use sgx and 
;* a multi-file version in case you want to make changes to the sgx code, including the gimp files 
;* for the image files and some tools to build a single-file version from that. _
;* _
;* with this library you can create simple GUI objects statically or dynamically of different 
;* type and appearance, modify them, display them easily, examine user actions and process events. 
;* sgx elements are accessed by ID (index-like, starting with index 1). the appearance is defined by 
;* designs, whereas you can create own designs with sets of images (there is also an instant design 
;* "lowbudget" which does not need any image files). currently there is no event queue, you will 
;* recognize events by checking for fields of your sgx elements. _
;* _
;* currently available gadget types: _
;* - <a href=#f_sgxcursor>sgxCursor</a> _
;* - <a href=#f_sgxbutton>sgxButton</a> (including toggle buttons and buttons with a user sprite) _
;* - <a href=#f_sgxtext>sgxText</a> _
;* - <a href=#f_sgxcheckbox>sgxCheckbox</a> _
;* - <a href=#f_sgxcombo>sgxCombo</a> _
;* - <a href=#f_sgxscrollbar>sgxScrollbar</a> _
;* - <a href=#f_sgxtrackbar>sgxTrackbar</a> _
;* - <a href=#f_sgxedit>sgxEdit</a> _
;* - <a href=#f_sgxwin>sgxWin</a> _
;* - <a href=#f_sgxtable>sgxTable</a> _
;* - <a href=#f_sgxspritegadget>sgxSpriteGadget</a> _
;* - <a href=#f_sgxarea>sgxArea</a> _
;* - <a href=#f_sgxsetgroup>option gadgets / radio buttons are available through grouping</a> _
;* _
;* _
;* the documentation includes _
;* - a quick start (sgxDoc\sgx.html) _
;* - a full reference (sgxDoc\sgxDocFull.html) _
;* - a smaller reference (sgxDoc\sgxDoc.html) without sgx internals (some links to sgx internals may not work in that
;* document thought!) _
;* - examples in the directory 'sgxDoc\' _
;* - _README.TXT contains further informations _
;* _
;* the references are rather technical, so use the quickstart and the examples to get the basic mechanics of sgx. _
;* _
;* _
;* all global identifiers start with "sgx.." or "*sgx.." or "#sgx.." _
;* globals, functions, macros, constants (#..) and pointer (*..) starting with "sgx_.." (with an underscore) as are 
;* basically used internally. _
;* structures (sgxS_..) are also basically used internally but the documentation of <a href=#s_sgxs_gadget>sgxS_GADGET</a> 
;* for example might be usefull nonetheless. _
;* constants are only documented by the documentation of the functions etc. whith which they are to be used. _
;* sgx uses implicit integer type definitions, so don't change the default type before including sgx. _
;* if you used DisableDebugger before including sgx you should repeat it after the include statement because the debugger
;* will be enabled. _
;* _
;* _
;* thanks to the PureBasic team and the community / the forums. _
;* _
;* [this document was blithely generated with jaPBdoc :) ] _


; heeere
; Procedure dummy()
;   ProcedureReturn 0
; EndProcedure
; Macro DrawText(x,y,t,fc=0,bc=0)
;   dummy()
; EndMacro



;  *** SGX ***

UsePNGImageDecoder()

;OpenConsole("sgx console")

;EnableExplicit

XIncludeFile "sgx_ll.pbi"
XIncludeFile "sgx_define.pbi"
XIncludeFile "sgx_access.pbi"
XIncludeFile "sgx_misc.pbi"
XIncludeFile "sgx_lowbudget.pbi"
XIncludeFile "sgx_design.pbi"
XIncludeFile "sgx_compose.pbi"
XIncludeFile "sgx_draw.pbi"
XIncludeFile "sgx_examine.pbi"
XIncludeFile "sgx_display.pbi"

;DisableExplicit

;}
;  #################### end sgx



; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 89
; FirstLine = 65
; Folding = -
; CompileSourceDirectory