﻿



;-# MACROS / PROC ###############################################################


;  ---------------- MACRO: sgx()
;
; there are two versions: for debugger and without.
;
; this macro has its own sourcefile to get autocompletion of sgx element structure
; fields via dummy 'Dim sgx.sgxS_GADGET(0)' working in the other sourcefiles. structure
; field autocompletion won't work in the same sourcefile as where this macro is
; defined but in files which include it. this also means it won't work inside the
; single-file version (sgx.pbi).
; also adding this file to the pb project will break autocompletion for structure
; fields.

CompilerIf #PB_Compiler_Debugger
  
  Import "Debugger.lib"
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
      sgx_err(error.p-ascii) As "_PB_DEBUGGER_SendError@4"
    CompilerElse
      sgx_err(error.p-ascii) As "PB_DEBUGGER_SendError"
    CompilerEndIf  
  EndImport
  
  ;** sgx_cb
  ;* wrapper used in the macro <a href=#f_sgx>sgx</a> if compiled with debugger. will through an error on invalid indices.
  Procedure sgx_cb(index)
    If (index>=0) And (index<=sgx_CURRENT_MAX_DYNAMIC_GADGETS)
      ;If *sgxID(index)
        ProcedureReturn index
      ;Else
      ;  sgx_err("sgx element invalid: sgx("+Str(index)+")")
      ;EndIf
    Else
      sgx_err("sgx array index out of bounds: sgx("+Str(index)+")")
    EndIf
    ; return at least the valid 0 index so checking 'sgx(id)' will work (accessing structure fields won't though!)
    ProcedureReturn 0
  EndProcedure
  
  ; (see CompilerElse section)
  Macro sgx(index)
    *sgxID(sgx_cb(index))
  EndMacro
  
;  ----------------
CompilerElse
  
  ;** sgx_err
  ;* used to throw sgx errors when compiled with debugger.
  Macro sgx_err(_message_)
    ;empty dummy (see PB_DEBUGGER_SendError import above)
  EndMacro
  
  ;** sgx
  ;* use this macro to access the structure of your sgx elements. _
  ;* _
  ;* if you try to access invalid sgx objects you might get one of the following errors: _
  ;* (use Menu > Debugger > Callstack to find out where the error might have been caused) _
  ;* <pre>
  ;* <span></span>; this will cause an error: _
  ;* <span></span>;Debug sgx(-123)\text   ; "[ERROR] sgx array index out of bounds: sgx(-123)" _
  ;* <span></span> _
  ;* <span></span>; this will cause an error if we did not create an element with this ID: _
  ;* <span></span>;Debug sgx(345)\text     ; "[ERROR] Pointer is null." _
  ;* <span></span> _
  ;* <span></span>; this will NOT cause an error since the index is ok and we check if that element exists: _
  ;* <span></span>If sgx(345) _
  ;* <span></span>  ; but we might not get here _
  ;* <span></span>  Debug sgx(345)\text _
  ;* <span></span>EndIf 
  ;* <pre>
  ;** .index : ID of a valid and existing sgx element (if structure fields will be accessed), where index <b></b>
  ;*           can be in the range of 1 .. sgx_CURRENT_MAX_DYNAMIC_GADGETS. you can check if 
  ;*           the ID is valid by a nonzero value of 'sgx(index)' (without structure field access). 
  Macro sgx(index)
    *sgxID(index)
  EndMacro
  
CompilerEndIf
;  ----------------





; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 23
; FirstLine = 12
; Folding = --
; UseMainFile = demo.pb
; CompileSourceDirectory