
; this example shows a more complete version of the callbacks, handling most of the cases so that the design
; is basically replaced by our own drawing.
; for a general description of the callbacks see documentation of sgxS_Design.

EnableExplicit

XIncludeFile "_sgx_includer.pbi"

; our actual callback functions are defined in a separate
; file because they are also used by 'demo.pb'
XIncludeFile "16customDraw2_callbacks.pbi"


InitSprite()
InitMouse()
InitKeyboard()

Global event, quit
Global ww=800
Global wh=600
OpenWindowedScreen( OpenWindow(0, 1,1, ww,wh,"..", #PB_Window_BorderLess | #PB_Window_ScreenCentered), 0,0,ww,wh,0,0,0)

Global *design.sgxS_Design = sgxLoadDesign("..\sgxDesigns\next")
If Not *design
  MessageRequester("error","can't load design")
  End
EndIf

; we assign our callbacks to the design
*design\onBeginDraw = @myOnBeginDraw()
*design\onEndDraw = @myOnEndDraw()

Define bQuit, table
Define someSprite

sgxCursor(-1)

someSprite = LoadSprite(#PB_Any, "img\load.png")
TransparentSpriteColor(someSprite, $ffffff)

; we just create some elements of each type
sgxWin(-1, 150, 50, 153,492, "title")
  table = sgxTable(-1, 10, 25, 1,20, 6, #sgxStyleFitCellW)
    bQuit = sgxCellAssign(0,0, sgxButton(-1, 0,0,  50,20, "QUIT") )
    sgxCellAssign(0,1, sgxEdit(-1, 0,0, 120,60, "sgxEdit"+#LF$+"element") )
    sgxCellAssign(0,2, sgxText(-1, 0,0,  -1,-1, "text", #sgxStyleHover) )
    sgxCellAssign(0,3, sgxCombo(-1, 0,0,  80,20, "entry one"+#LF$+"entry two"+#LF$+"entry three"+#LF$+"entry four") )
    sgxCellAssign(0,4, sgxCheckbox(-1, 0,0,15,15, #sgxStateOff, "a checkbox") )
    sgxCellAssign(0,5, sgxCheckbox(-1, 0,0,15,15, #sgxStateOn, "a checkbox") )
    sgxCellAssign(0,6, sgxCheckbox(-1, 0,0,15,15, #sgxStateOn, "a checkbox", #sgxAlignCheckboxTextLeft) )
    sgxCellAssign(0,7, sgxScrollbar(-1, 0,0, 80,12, 16,10, 1000) )
    sgxCellAssign(0,8, sgxTrackbar(-1, 0,0, 80,12, 10,16, 1000) )
    sgxCellAssign(0,9, sgxButton(-1, 0,0,  50,20, "button", #sgxStateNone) )
    sgxCellAssign(0,10, sgxButton(-1, 0,0,  50,20, "disabled", #sgxStateNone) )
    sgxCellAssign(0,11, sgxButton(-1, 0,0,  50,20, "toggle button", #sgxStateOn) )
    sgxCellAssign(0,12, sgxButton(-1, 0,0,  50,25, "sprite button", #sgxStateNone, someSprite) )
    sgxCellAssign(0,13, sgxSpriteGadget(-1, 0,0, someSprite) )
  sgxCloseLevel()
sgxCloseLevel()

sgxSetDisabled(sgxCellId(table, 0,10), #True)

Repeat
  ExamineMouse()
  ExamineKeyboard()
  
  ; pb window events
  Repeat
    event=WindowEvent()
    Select event
      Case #PB_Event_CloseWindow
        quit = #True
    EndSelect
  Until Not event
  
  sgxExamine()
  
  If sgx(bQuit) And sgx(bQuit)\leftup
    quit = #True
  EndIf
  
  sgxDisplay()
  
  FlipBuffers()
  ClearScreen($002222)
  Delay(5)
Until quit Or KeyboardPushed(#PB_Key_Escape)



; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 1
; HideErrorLog
; CompileSourceDirectory