


;** sgxDisplay
;* display all sgx element on screen.
;* only DisplayTransparentSprite() is used.
Procedure sgxDisplay()
  Static id, id2
  Static startpos
  Static endpos
  Static length
  Static temp
  Static x ,y
  Static display
  Static *it.sgx_llS_elem ; use Protected when using recursion!
  
  
  ; display as layered
  
  sgx_llIteratorRecursive(*it,*sgxLayeredView)
    If sgx(*it\id)\type = #sgxTypeWin And sgx(*it\id)\state = #sgxWinStateMinimized ; no minimized
    ;ElseIf sgx(sgxGetTopLevel(*it\id))\state = #sgxWinStateMinimized                ; no childs of minimized
    Else
      sgxDisplayID(*it\id)
    EndIf
  sgx_llNextRecursive(*it)
  
  
  ; display minimized
  
  sgx_llIteratorRecursive(*it,*sgxLayeredView)
    If sgx(*it\id)\type=#sgxTypeWin And sgx(*it\id)\state = #sgxWinStateMinimized
      sgxDisplayID(*it\id)
    EndIf
  sgx_llNextRecursive(*it)
  
  
  ;display tips
  
  sgx_llIteratorRecursive(*it,*sgxLayeredView)
    If sgx(*it\id)\tip And sgx(*it\id)\tip\show = 1
      ;{ calculate tip position from mouse
      x = sgx_m\x+20
      y = sgx_m\y+5
      ; display tip to the left if no space to the right
      If x > sgx_dimensions\w - sgx(*it\id)\tip\w
        x = sgx_m\x - sgx(*it\id)\tip\w - 10
      EndIf
      ; display tip above if no space beneath
      If y > sgx_dimensions\h - sgx(*it\id)\tip\h
        y = sgx_m\y - sgx(*it\id)\tip\h - 10
      EndIf
      ;}
      DisplayTransparentSprite(sgx(*it\id)\tip\spr, x,y)
    EndIf
  sgx_llNextRecursive(*it)
  
  
  ; debug: display hovered element info box and mouse position
  If sgx_debugInfos
    Static txt.s, txtw, txth, xpos, ypos
    xpos = sgx_m\x
    ypos = sgx_m\y
    id = sgxGetElementAt(xpos, ypos)
    StartDrawing(ScreenOutput())
      If id <> -1
        DrawingMode(#PB_2DDrawing_Outlined)
        Box(sgx(id)\x, sgx(id)\y, sgx(id)\w, sgx(id)\h, $ffffff)
        
        DrawingFont(FontID(sgx_fontMonoSmall))
        txt = ""
        txt + "mouse in element: "+Str(sgx_m\x - sgx(id)\x)+","+Str(sgx_m\y - sgx(id)\y) + #LF$ + #LF$
        txt + sgxDebugElem(id, #True)
        txtw = sgx_textWidthLF(txt)
        txth = TextHeight("X") * (CountString(txt, #LF$) + 1)
        If (xpos-40-txtw) > 0
          xpos = xpos-40-txtw ; display left
        Else
          xpos + 40 ; display right
        EndIf
        If ypos+(20+txth) > sgx_dimensions\h
          ypos - txth
        Else
          ypos + 20
        EndIf
        DrawingMode(#PB_2DDrawing_Default)
        Box(xpos, ypos, txtw, txth, $666666)
        DrawingMode(#PB_2DDrawing_Transparent)
        sgx_drawTextLF(xpos, ypos, txt, $dddddd)
      EndIf
      
      ; display mouse position
      DrawingFont(FontID(sgx_fontMonoSmall))
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawText(sgx_m\x+20, sgx_m\y, ""+sgx_m\x+","+sgx_m\y)
      
    StopDrawing()
    
  EndIf
  
  ;display mouse cursor
  sgxDisplayCursor()
  
EndProcedure


;** sgxDisplayCursor
;* display the sgx mouse cursor on screen. under normal circumstances you don't have to call this function. _
;* usefull if you want to overdraw/display something after you called sgxDisplay() but still want the mouse cursor to be visible, so you can redraw the cursor with this function after your drawing operations. _
Procedure sgxDisplayCursor()
  If  sgx_m\cursor <> -1 And sgx(sgx_m\cursor)\show
    DisplayTransparentSprite( sgx(sgx_m\cursor)\spr[#sgx_GadgetSprNormal], sgx_m\x, sgx_m\y    )
  EndIf
EndProcedure

;** sgxDisplayID
;* display an sgx element on screen.
;* only DisplayTransparentSprite() is used.
;** .id : ID of the sgx element to be displayed
Procedure sgxDisplayID(id);, offsetx=0, offsety=0)
  Static offsetX, alpha, i, k, x, y
  
  If sgx(id)\show=0
    ProcedureReturn ;
  Else
    
    Select sgx(id)\type
        
        ;- Button
      Case #sgxTypeButton ;{
        If sgx(id)\leftdown And id <> sgx_resizing
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprPushed], 0+sgx(id)\x, 0+sgx(id)\y, sgx(id)\alpha    )
        ElseIf sgx(id)\hover
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        EndIf
        ; user sprite
        If IsSprite( sgx(id)\spr[#sgx_GadgetSprNormal2] )
          If sgx(id)\disabled
            alpha = sgx(id)\alpha / 2
          Else
            alpha = sgx(id)\alpha
          EndIf
          If sgx(id)\leftdown And id <> sgx_resizing
            ; margin is the text offset when 'pushed' and is stored during refresh, because offset can be
            ; deactivated by a custom drawing callback via #sgxDrawTextNoOffset
            DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2], sgx(id)\x+sgx(id)\x2+sgx(id)\margin, sgx(id)\y+sgx(id)\y2+sgx(id)\margin, alpha    )
          Else
            DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2], sgx(id)\x+sgx(id)\x2  , sgx(id)\y+sgx(id)\y2, alpha    )
          EndIf
        EndIf
        ;}

      
      ;- ToggleButton
    Case #sgxTypeButtonToggle ;{
      If sgx(id)\state=1 ; toggled
        If sgx(id)\hover
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHoverPushed],   sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprPushed], sgx(id)\x,  sgx(id)\y, sgx(id)\alpha    )
        EndIf
      Else
        If sgx(id)\hover
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        EndIf
      EndIf
      ; user sprite
      If IsSprite( sgx(id)\spr[#sgx_GadgetSprNormal2] )
        If sgx(id)\disabled
          alpha = sgx(id)\alpha / 2
        Else
          alpha = sgx(id)\alpha
        EndIf
        If sgx(id)\state=1 ; toggled
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2], sgx(id)\x+sgx(id)\x2+1, sgx(id)\y+sgx(id)\y2+1, alpha    ) ; +1 = same as text offset for pushed
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2], sgx(id)\x+sgx(id)\x2  , sgx(id)\y+sgx(id)\y2, alpha    )
        EndIf
      EndIf
      ;}

      
      ;- Checkbox
    Case #sgxTypeCheckbox ;{
      
      If sgx(id)\hover
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover],  sgx(id)\x + sgx(id)\x2,  sgx(id)\y + sgx(id)\y2, sgx(id)\alpha    )
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal],  sgx(id)\x + sgx(id)\x2,  sgx(id)\y + sgx(id)\y2, sgx(id)\alpha    )
      EndIf
      ; 'checked' part
      If sgx(id)\state
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprChecked],  sgx(id)\x,  sgx(id)\y,  sgx(id)\alpha  )
      EndIf
      ;}
  
      
      ;- Scrollbar/Trackbar
    Case #sgxTypeScrollbarVer, #sgxTypeTrackbarVer, #sgxTypeScrollbarHor, #sgxTypeTrackbarHor ;{
      If sgx(id)\hover Or sgx_focusCatchedBy=id
        ; bar
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover],  sgx(id)\x , sgx(id)\y, sgx(id)\alpha   )
        ; knob
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover2], sgx(id)\x+sgx(id)\x2, sgx(id)\y+sgx(id)\y2, sgx(id)\alpha  )
      Else
        ; bar
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x , sgx(id)\y, sgx(id)\alpha   )
        ; knob
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2],sgx(id)\x+sgx(id)\x2, sgx(id)\y+sgx(id)\y2, sgx(id)\alpha  )
      EndIf
      ;}
  
      
      ;- Edit
    Case #sgxTypeEdit ;{
      If sgx(id)\hover Or id=sgx_editing
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        If id=sgx_editing And ( (sgx_ems/200)%2 Or KeyboardPushed(#PB_Key_All) )
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprTextCursor], sgx(id)\x + sgx(id)\x2 + sgx(id)\textcursor\x-1 + sgx_textCursorClippingOffset\x, sgx(id)\y + sgx(id)\y2 + sgx(id)\textcursor\y + sgx_textCursorClippingOffset\y, sgx(id)\alpha )
        EndIf
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      EndIf
      ;}
  
      
      ;- Window
    Case #sgxTypeWin ;{
      ; note: some window states get sorted out in sgxDisplay() already
      If id=sgxActiveWin Or id=sgx_focusCatchedBy ;Or sgxIsParentage(id, sgx_activeWin)
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprPushed], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      ElseIf sgx(id)\hover Or sgx_IsParentage(id, sgxActiveWin)
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      EndIf
      
      ;close gadget
      If sgx(id)\state <> #sgxWinStateMinimized  And  sgx(id)\width  And   sgx(id)\w > sgx(id)\width  And  sgx(id)\h > sgx(id)\width
        If sgx_MousehoverClosebutton(id) And (Not sgx(id)\disabled)
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover2], sgx(id)\x+sgx(id)\sys0\x1, sgx(id)\y+sgx(id)\sys0\y1, sgx(id)\alpha )
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal2], sgx(id)\x+sgx(id)\sys0\x1, sgx(id)\y+sgx(id)\sys0\y1, sgx(id)\alpha )
        EndIf
      EndIf
      ;}
    
      
      ;- Table
    Case #sgxTypeTable ;{
      If sgx(id)\hover
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      EndIf
      ;}
    
      
      ;- Sprite
    Case #sgxTypeSpriteGadget ;{
      If IsSprite(sgx(id)\state)
        If sgx(id)\disabled
          DisplayTransparentSprite( sgx(id)\state, sgx(id)\x,sgx(id)\y, sgx(id)\alpha / 2   )
        Else
          DisplayTransparentSprite( sgx(id)\state, sgx(id)\x,sgx(id)\y, sgx(id)\alpha   )
        EndIf
      EndIf
      ;}
    
      
      ;- Combo
    Case #sgxTypeCombo ;{
      If sgx(id)\max=1
        ; the open combo
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprPushed], sgx(id)\x,  sgx(id)\y, sgx(id)\alpha    )
        If sgx(id)\hover
          ; highlight the hovered entry
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover2], sgx(id)\x, sgx(id)\y+(sgx_m\y-sgx(id)\y)/sgx(id)\h2*sgx(id)\h2, sgx(id)\alpha    )
        EndIf
      Else
        If sgx(id)\hover
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        Else
          DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
        EndIf
      EndIf
      ;}
    
      
      ;- Text
    Case #sgxTypeText ;{
      If sgx(id)\hover And sgx(id)\style & #sgxStyleHover
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprHover], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprNormal], sgx(id)\x, sgx(id)\y, sgx(id)\alpha    )
      EndIf
      ;}
    
    
    EndSelect
    
    
    ; display resize gadget (for windows only if in normal state; combos only if not opened)
    If sgx(id)\resizable  And  (sgx(id)\type <> #sgxTypeWin Or sgx(id)\state=#sgxWinStateNormal)  And  (sgx(id)\type <> #sgxTypeCombo Or sgx(id)\max<>1)
      If sgx_MousehoverResize(id) And (Not sgx(id)\disabled)
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprResize],  sgx(id)\x + sgx(id)\w - sgx_resizeGadgetSize,  sgx(id)\y + sgx(id)\h - sgx_resizeGadgetSize,  sgx(id)\alpha/2    )
      Else
        DisplayTransparentSprite( sgx(id)\spr[#sgx_GadgetSprResize],  sgx(id)\x + sgx(id)\w - sgx_resizeGadgetSize,  sgx(id)\y + sgx(id)\h - sgx_resizeGadgetSize,  sgx(id)\alpha/4    )
      EndIf
    EndIf
    
    
    ; debug: display element frame
    If sgx_debugInfos
      If id = sgxTopID Or sgx_debugInfos = 2
        StartDrawing(ScreenOutput())
          DrawingMode(#PB_2DDrawing_Outlined)
          If sgx(id)\type = #sgxTypeCheckbox
            Box( sgx(id)\x + sgx(id)\x2,  sgx(id)\y + sgx(id)\y2,  sgx(id)\w2, sgx(id)\h2, $66ff66)
          ElseIf sgx(id)\type & (#sgxTypeScrollbar|#sgxTypeTrackbar)
            Box( sgx(id)\x + sgx(id)\x2,  sgx(id)\y + sgx(id)\y2,  sgx(id)\w2, sgx(id)\h2, $66ff66)
          ElseIf sgx(id)\type = #sgxTypeWin
            Box( sgx(id)\x + sgx(id)\sys0\x1,  sgx(id)\y + sgx(id)\sys0\y1,  sgx(id)\sys0\x2 - sgx(id)\sys0\x1,  sgx(id)\sys0\y2 - sgx(id)\sys0\y1, $66ff66)
          ElseIf sgx(id)\type = #sgxTypeCombo And sgx(id)\max=1
            Box( sgx(id)\x,  sgx(id)\y+(sgx_m\y-sgx(id)\y)/sgx(id)\h2*sgx(id)\h2,  sgx(id)\w, sgx(id)\h2, $66ff66)
          ElseIf sgx(id)\type = #sgxTypeTable  ;And  Not sgx(id)\style & #sgxStyleNoBG  ; (hidden anyway)
            ; ver lines |
            For i=0 To sgx(id)\table\w-2
              x = PeekL( sgx(id)\table\gridx + i*SizeOf(Long) )
              Line(sgx(id)\x + x, sgx(id)\y, 1, sgx(id)\h, $66ff66)
            Next
            ; hor lines --
            For k=0 To sgx(id)\table\h-2
              y = PeekL( sgx(id)\table\gridy + k*SizeOf(Long) )
              Line(sgx(id)\x, sgx(id)\y + y, sgx(id)\w, 1, $66ff66)
            Next
          EndIf
          If id = sgxTopID
            Box(sgx(id)\x, sgx(id)\y, sgx(id)\w, sgx(id)\h, $ffffff)
          ElseIf sgx_debugInfos = 2
            Box(sgx(id)\x, sgx(id)\y, sgx(id)\w, sgx(id)\h, $aaaaaa)
          EndIf
        StopDrawing()
      EndIf
    EndIf
    
    
  EndIf
EndProcedure







; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 146
; FirstLine = 125
; Folding = ---
; UseMainFile = demo.pb
; Executable = sgxDemo.exe
; CompileSourceDirectory