﻿




;-# DECLARE ###############################################################
;{

; (don't use this as an overview, since it will be incomplete)

Declare sgxLoadDesign(design.s="lowbudget", basecolor=-1)
Declare sgxRefreshDesign(*design.sgxS_Design)

Declare sgxCursor(id)
Declare sgxButton(id, x, y, w, h, text.s, toggle=#sgxStateNone , sprNr=-1, x2=5, y2=5)
Declare sgxCheckbox(id, x, y, w, h, checked=#sgxStateOff, text.s="", align=#sgxAlignCheckboxTextRight)
Declare sgxScrollbar(id, x, y, w, h, w2, h2, max, state=0, style=0)
Declare sgxEdit(id, x, y, w, h, text.s="", maxLines=-1)
Declare sgxWin(id, x, y, w, h, text.s="", style=0)
Declare sgxTip(id, text.s)
Declare sgxCombo(id, x, y, w, h, text.s="")

Declare sgxRefresh(id, mode=#sgx_refreshNormalWithTip)
Declare sgxRefreshAll()
Declare sgx_DrawCursor(id, sprType)
Declare sgx_DrawButton(id, sprType)
Declare sgx_DrawCheckbox(id, sprType)
Declare sgx_DrawScrollbar(id, sprType)
Declare sgx_DrawEdit(id, sprType, updateMetricsOnly=#False, moveTextpos=#False, scrollToCursor=#True)
Declare sgx_DrawWin(id, sprType)
Declare sgx_DrawTip(id)
Declare sgx_DrawResizeGadget(id)
Declare sgx_DrawCombo(id, sprType)
Declare sgx_DrawText(id, sprType)
Declare sgx_DrawDisabled(id, sprType)

Declare sgx_Fill(*design.sgxS_Design, x, y, w, h, sprType)

Declare sgxExamine( mousex=-1, mousey=-1 )
Declare sgxDisplay();onlyOfParent=-1)
Declare sgxDisplayID(id)
Declare sgxDisplayCursor()
Declare sgxMoveOnTop(id)
Declare sgxGetElementAt(x, y)
Declare sgxGetTopLevel(id)
Declare sgx_GetGadgetX(id)
Declare sgx_GetGadgetY(id)
Declare sgx_updateToParentPos(id)
Declare sgxMove(id, x, y, relative=#True)
Declare sgx_MoveChildsOf(id)
Declare sgx_IsParentage(parent, child)
Declare sgxAddToRadioGroup(id, groupID)
Declare sgxGetGroup(id)
Declare sgxFree(id)
Declare sgxFreeChildsOf(parent)
Declare sgx_RestoreWin(id)
Declare sgx_RefreshWinBar()
Declare sgxSetCurrentParent(id)
Declare sgxSetAlpha(alpha, id=-1, recursive=#False)
Declare sgx_animate(id, *animation.sgxS_Animation)
Declare sgx_HideChildsOf(parent, show=#False, ignoreWindows=#True)
Declare sgxSetState(id, state, handleRadioGroups=#True, *changed.sgxS_ListWrapper=0)

;}
; #








;** sgxNew
;* create a new sgx object. _
;* returns the ID of that newly created object, or 0 if creation failed. _
;* you should use the compose functions like <a href=#f_sgxbutton>sgxButton</a> etc. to create actual sgx elements. _
;** .id : the ID to be used for the new object, where id can be in the range of 1 .. sgx_LIMIT_STATIC_GADGETS, 
;*        <span></span> or -1 to dynamically generate an ID. _
;*        if the ID is already in use, the according element is freed (including childs) and replaced.
Procedure sgxNew(id)
  
  CompilerIf #PB_Compiler_Debugger
    If *sgx_CurrentDesign = 0
      sgx_err("there is no current design")
    EndIf
    
    If id=0
      sgx_err("id 0 should not be used for valid sgx object. start by id 1 instead")
    ElseIf id > sgx_LIMIT_STATIC_GADGETS
      sgx_err("id too big (" + Str(id) + "). see documentation for #sgxMaxStaticGagdets")
    ElseIf id < -1
      sgx_err("id is negative (" + Str(id) + ").")
    EndIf
  CompilerEndIf
  
  If id = -1
    sgx_CURRENT_MAX_DYNAMIC_GADGETS + 1
    ReDim *sgxID.sgxS_GADGET(sgx_CURRENT_MAX_DYNAMIC_GADGETS)
    id = sgx_CURRENT_MAX_DYNAMIC_GADGETS
  ElseIf id > 0  And  id <= sgx_LIMIT_STATIC_GADGETS  And  id > sgx_CURRENT_MAX_STATIC_GADGETS
    sgx_CURRENT_MAX_STATIC_GADGETS = id
  EndIf
  
  If sgx(id)
    sgxFree(id)
  EndIf
  sgx(id) = AllocateMemory(SizeOf(sgxS_GADGET))
  
  ; the array sgx(id)\spr[] will contain zeros now wich might be valid sprite IDs generally and IsSprite() would say
  ; fine, but it's not valid as a gadget sprite. sgx will check for non-zero values before IsSprite() and
  ; sgx_FreeSpriteChecked() won't free sprites with id 0.
  
  ; (*obsolete*)
  ; init sprites with -1 to not interfere with possibly used constant 0 as sprite id ouside of sgx.
  ;sgx(id)\spr[0] = -1
  ;sgx(id)\spr[1] = -1
  ;sgx(id)\spr[2] = -1
  ;[...]
  
  If sgx(id)
    sgxNumberOfElements + 1
    ProcedureReturn id
  Else
    ProcedureReturn 0
  EndIf
EndProcedure


;** sgx_isInElement
;* checks if the specified absolute screen position is within the element's dimensions.
Procedure sgx_isInElement(id, x, y)
  If sgx(id)\type = #sgxTypeCheckbox
    ProcedureReturn Bool( x>=(sgx(id)\x+sgx(id)\x2) And x<(sgx(id)\x+sgx(id)\x2+sgx(id)\w2) And y>=(sgx(id)\y+sgx(id)\y2) And y<(sgx(id)\y+sgx(id)\y2+sgx(id)\h2) )
  Else
    ProcedureReturn Bool( x>=sgx(id)\x And x<(sgx(id)\x+sgx(id)\w) And y>=sgx(id)\y And y<(sgx(id)\y+sgx(id)\h) )
  EndIf
EndProcedure


;** sgx_MousehoverClosebutton
;* checks if the mouse position is within the dimensions of the element's close button (windows only).
Macro sgx_MousehoverClosebutton(id)
  ( sgx_m\x>(sgx(id)\x+sgx(id)\sys0\x1) And sgx_m\x<sgx(id)\x+sgx(id)\sys0\x2 And sgx_m\y>sgx(id)\y+sgx(id)\sys0\y1 And sgx_m\y<sgx(id)\y+sgx(id)\sys0\y2 )
EndMacro


;** sgx_MousehoverResize
;* checks if the mouse position is within the dimensions of the element's resize button in hte bottom right corner.
Procedure sgx_MousehoverResize(id)
  Static x,y
  ; get mouse cursor distance from bottom right element corner, [-2,-1] for example.
  x = sgx_m\x - (sgx(id)\x + sgx(id)\w)
  y = sgx_m\y - (sgx(id)\y + sgx(id)\h)
  ; the "x+y < size" simulates a triangular area
  If x<0 And y<0 And (-x + -y) < sgx_resizeGadgetSize
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure


;** sgx_FreeImageChecked
;* frees the image with the passed number if it's a valid PB image. used for easy recreation of images. _
;* images with id 0 will not be freed even if they are valid images, because sgx uses #PB_Any and interprets
;* 0 as uninitialized.
;** .img : a variable containing the PB image number. the variable will be set to -1 after freeing the image, so you cannot use this macro with constants for example.
Macro sgx_FreeImageChecked(img)
  ;If img=0
  ;  sgxERROR("develinfo: an internal sgx image shouldn't be 0")
  ;EndIf
  If img And IsImage(img)
    FreeImage(img)
  EndIf
  img = -1 ; works with variables passed only (not constants) !
EndMacro


;** sgx_FreeSpriteChecked
;* frees the sprite with the passed number if it's a valid PB sprite. used for easy recreation of sprites. _
;* sprites with id 0 will not be freed even if they are valid sprites, because sgx uses #PB_Any and interprets
;* 0 as uninitialized.
;** .spr : a variable containing the PB sprite number. the variable will be set to -1 after freeing the sprite, so you cannot use this macro with constants for example.
Macro sgx_FreeSpriteChecked(spr)
  ;If spr=0
  ;  sgxERROR("develinfo: an internal sgx sprite shouldn't be 0")
  ;EndIf
  If spr And IsSprite(spr)
    FreeSprite(spr)
  EndIf
  spr = -1 ; works with variables passed only (not with constants) !
EndMacro


;** sgx_SkipUnused
;* skips the gap of irrelevant IDs between the currently highest used static ID and the first dynamic one. used for more efficient element traversal for example in <a href=#f_sgxeach>sgxEACH</a>.
;** .iterator : the identifier used as ID in the loop.
Macro sgx_SkipUnused(iterator)
  If iterator = sgx_CURRENT_MAX_STATIC_GADGETS+1
    iterator = sgx_LIMIT_STATIC_GADGETS
  EndIf
EndMacro


;** sgxInBounds
;* returns #True if 'index' is within bounds of the basic sgx element array, otherwise it returns #False. _
;* a return value of '#True' does not say anything about the existence or validity of a possible element at that position.
;** .index : the index that is to be checked.
Macro sgxInBounds(index)
  Bool( (index>=0) And (index<=sgx_CURRENT_MAX_DYNAMIC_GADGETS) )
EndMacro


;** sgx_SetParentList
;* used in <a href=#f_sgxsetcurrentparent>sgxSetCurrentParent</a> to keep *sgx_CurrentParent (the current parent tree node) in sync with sgx_CurrentParent (the current parent ID).
Procedure sgx_SetParentList(id)
  If id = -1
    *sgx_CurrentParent = *sgxLayeredView
  Else
    *sgx_CurrentParent = sgx(id)\treeElem\node
  EndIf
EndProcedure


;** sgxSetCurrentParent
;* set the parent for coming creations of new sgx elements. _
;* needed if you want to add childs later.
;* calls of this function in combination with <a href=#f_sgxcloselevel>sgxCloseLevel</a> should not be nested.
;** .id : ID of the element to become the current parent
Procedure sgxSetCurrentParent(id)
  If id <> sgx_CurrentParent
    sgx_CurrentParent = id
    sgx_SetParentList(id)
  EndIf
EndProcedure


;** sgxSetParent
;* sets or changes the parent of an sgx element. _
;* used at element creation and also in <a href=#f_sgxcellassign>sgxCellAssign</a>. _
;* the child is not automatically repositioned, use <a href=#f_sgxmove>sgxMove</a> if necessary.
;** .id     : ID of the child element which parent is to be changed.
;** .parent : ID of the element to become the new parent
Procedure sgxSetParent(id, parent)
  Protected *node.sgx_llS_list
  
  ; remove the tree element from its current parent's node but preserve it's own childs (the node of the treeElem)
  *node = sgx_llDelElem(sgx(id)\treeElem, #True)
  
  sgx(id)\parent=parent
  
  If parent <> -1
    ; initialize the parent's child list if not done
    If sgx(parent)\hasChilds = 0
      sgx(parent)\hasChilds = 1
      sgx(parent)\treeElem\node.sgx_llnew ; <-- list constructor
      
      ; update *sgx_CurrentParent from 0 to our newly created node
      ; note: we can not simply use sgxSetCurrentParent(parent) here because
      ; the condition 'If id <> sgx_CurrentParent' inside that function would
      ; fail and thus *sgx_CurrentParent would remain 0.
      sgx_SetParentList(parent)
    EndIf
  EndIf
  
  ; add the element to the parent's element tree node.
  If parent = -1
    ; add the element to *sgxLayeredView (the root node)
    ; this happens if sgx elements are created normally as top level childs, or if
    ; the parent is changed later to top level, independent from the current parent.
    sgx(id)\treeElem=sgx_llAdd(*sgxLayeredView, id)
    sgx_llReplaceElemNode(sgx(id)\treeElem, *node) ; restore the childs list
  ElseIf parent = sgx_CurrentParent
    ; this happens if sgx elements are created normally as the current parent's child.
    ; here *sgx_CurrentParent is the actually the same as the parent's node in the Else
    ; branch but i kept this separate to be clear.
    sgx(id)\treeElem=sgx_llAdd(*sgx_CurrentParent, id)
    sgx_llReplaceElemNode(sgx(id)\treeElem, *node) ; restore the childs list
  Else
    ; this happens if the parent is changed later, independent from the current parent.
    sgx(id)\treeElem=sgx_llAdd(sgx(parent)\treeElem\node, id)
    sgx_llReplaceElemNode(sgx(id)\treeElem, *node) ; restore the childs list
  EndIf
EndProcedure


;** sgxEach
;* use this macro to iterate through the elements. the order in which the elements are iterated is undefined. _
;* usage example: _
;* <pre>
;* ;Define id  ; needed if EnableExplicit is used _
;* _
;* For sgxEach(id) _
;* <span></span>  Debug sgx(id)\text _
;* Next _
;* </pre>
;** .it : choose your iterator variable here that will contain the ID of the sgx elements. this variable is used in the for/next loop as is and must have been declared previously if EnableExplicit is used.
Macro sgxEach(it)
  it=1 To sgx_CURRENT_MAX_DYNAMIC_GADGETS
    sgx_SkipUnused(it)
    If Not sgx(it)
      Continue
    EndIf
EndMacro






































;-# MISC PROC ###############################################################





;** sgxMoveOnTop
;* make an sgx window (#sgxTypeWin) active and foreground or move an element above its siblings. if the element is not a window then the parent window will be activated additionally.
;** .id : the ID of the sgx element
Procedure sgxMoveOnTop(id)
  Protected done
  
  ; reset possible window focus for top level elements
  If sgx(id)\parent = -1 And sgxActiveWin
    sgxActiveWin = -1
  EndIf
  
  While id <> -1
    ;If sgx(id)\type = #sgxTypeWin  ;Or  sgx(id)\type = #sgxTypeTable
      sgx_llmoveend(sgx(id)\treeElem)
      If sgx(id)\type = #sgxTypeWin  And  Not done
        ; activate only the direct parent window, not the topmost parent window
        done=1
        sgxActiveWin = id
      EndIf
    ;EndIf
    id=sgx(id)\parent
  Wend
EndProcedure


;** sgx_PushBuildRefresh
;* temporarily changes the value of sgx_BuildRefresh.
Procedure sgx_PushBuildRefresh(state)
  If ListSize(sgx_BuildRefreshStack())
    LastElement(sgx_BuildRefreshStack())
  EndIf
  AddElement( sgx_BuildRefreshStack() )
  If state
    sgx_BuildRefresh = 1
  Else
    sgx_BuildRefresh = 0
  EndIf
  sgx_BuildRefreshStack() = sgx_BuildRefresh
EndProcedure


;** sgx_PopBuildRefresh
;* restores sgx_BuildRefresh to the previous value.
Procedure sgx_PopBuildRefresh()
  If ListSize(sgx_BuildRefreshStack())
    LastElement(sgx_BuildRefreshStack())
    DeleteElement(sgx_BuildRefreshStack())
    LastElement(sgx_BuildRefreshStack())
    If ListSize(sgx_BuildRefreshStack())
      sgx_BuildRefresh = sgx_BuildRefreshStack()
    Else
      sgx_BuildRefresh = 1
    EndIf
  EndIf
EndProcedure


;** sgxGetElementAt
;* returns the ID of the topmost sgx element at the given position on screen, or -1 if no sgx element is found there. passive elements are ignored.
;** .x : x-position on screen in pixels
;** .y : y-position on screen in pixels
Procedure sgxGetElementAt(x, y)
  Protected ret=-1
  Protected id
  sgx_llIteratorRecursive(Protected *it, *sgxLayeredView)
    If sgx(*it\id)\show  And  (Not sgx(*it\id)\passive)
      If sgx_isInElement(*it\id, x, y)
        ret = *it\id
      EndIf
    EndIf
    sgx_llNextRecursive(*it)
  ProcedureReturn ret
EndProcedure


;** sgxGetTopLevel
;* returns the ID of the topmost parent.
;** .id : ID of child element. if this element does not have parents, it is the top level itself and thus returned.
Procedure sgxGetTopLevel(id)
  While sgx(id)\parent <> -1
    id = sgx(id)\parent
  Wend
  ProcedureReturn id
EndProcedure


;** sgxMove
;* change the position of an sgx element. _
;* the positioning is either in absolute screen coordinates or in absolute toParent coordinates. _
;* if you want to position the element relative to its own current position (by offset) you would calculate the offset as follows (both methods would have the same effect): _
;* <pre> 
;* ; moves the element 10 pixels to the right as well as down by specifiying toParent coordinates. _
;* sgxMove(id, sgx(id)\xToParent+10, sgx(id)\yToParent+10); _
;* _
;* ; moves the element 10 pixels to the right as well as down, using absolute screen coordinates. it's toParent-position will be updated accordingly. _
;* sgxMove(id, sgx(id)\x+10, sgx(id)\y+10, #False); _
;* </pre> 
;** .id : ID of the sgx element to be moved
;** .x  : new x-position relative to parent element
;** .y  : new y-position relative to parent element
;** .relative  : by default (#True) the element will be positioned relative to it's parent. specify #False if x/y are absolute screen coordinates.
Procedure sgxMove(id, x, y, relative=#True)
  Static parent
  
  If relative
    ; set realitve position
    sgx(id)\xToParent = x
    sgx(id)\yToParent = y
    ; update absolute position
    sgx(id)\x=sgx_GetGadgetX(id)
    sgx(id)\y=sgx_GetGadgetY(id)
  Else
    ; set absolute position
    sgx(id)\x=x
    sgx(id)\y=y
    ; update relative position
    sgx_updateToParentPos(id)
  EndIf
  
  ; handle child positions
  sgx_MoveChildsOf(id)
  
EndProcedure


;** sgx_updateToParentPos
;* updates the element's to-parent-position if it's absolute screen position has been modified.
;** .id : ID of the sgx element.
Procedure sgx_updateToParentPos(id)
  If sgx(id)\parent <> -1
    sgx(id)\xToParent = sgx(id)\x - sgx(sgx(id)\parent)\x
    sgx(id)\yToParent = sgx(id)\y - sgx(sgx(id)\parent)\y
  Else
    sgx(id)\xToParent = sgx(id)\x
    sgx(id)\yToParent = sgx(id)\y
  EndIf
EndProcedure

;** sgxSetDisabled
;* disable or enable an sgx element. _
;* if the disabled/enabled state changes then the element will be refreshed. _
;** .id : ID of the sgx element to be disabled or enabled
;** .disabled  : #True (default) to disable the element or #False to enable it. _
Procedure sgxSetDisabled(id, disabled=#True)
  If sgx(id)
    If (Not sgx(id)\disabled And disabled)  Or  (sgx(id)\disabled And Not disabled)
      If disabled
        sgx(id)\disabled = 1
      Else
        sgx(id)\disabled = 0
      EndIf
      If id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
      If id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
      If id = sgx_resizing       : sgx_resizing       = -1 : EndIf
      If id = sgx_moving         : sgx_moving         = -1 : EndIf
      If id = sgx_editing        : sgx_editing        = -1 : EndIf
      sgxRefresh(id)
    EndIf
  EndIf
EndProcedure


;** sgxResize
;* change the size of an sgx element. _
;* sgxTable elements determine their size by their childs and cannot be resized directly.
;* sgxCheckbox elements resize only their knob (w,h) but their overall size (w2,h2) might be influenced by this too. _
;** .id : ID of the sgx element to be resized
;** .w  : the new width. one of these values: _
;*        - a positive value > 0 for an explicit width. _
;*        - a value of -2 to ignore that parameter and not change the width or to use the automatic size adjustment as specified at creation for elements which support it. _
;*        - a value of -1 to explicitly use automatic size adjustment for elements which support it. _
;** .h  : the new height. one of these values: _
;*        - a positive value > 0 for an explicit height. _
;*        - a value of -2 to ignore that parameter and not change the height or to use the automatic size adjustment as specified at creation for elements which support it. _
;*        - a value of -1 to explicitly use automatic size adjustment for elements which support it. _
Procedure sgxResize(id, w, h)
  Static wPrev, hPrev, wNew, hNew
  Static topmostTable, parent
  Static dw, dh, fw.f, fh.f, switched, tmp
  
  If sgx(id) And sgx(id)\type <> #sgxTypeTable ; (skip tables)
    wPrev = sgx(id)\w
    hPrev = sgx(id)\h
    
    ; 'ignore' parameter
    If w = -2
      If sgx(id)\origW = -1
        w = -1
      Else
        w = sgx(id)\w
      EndIf
    EndIf
    If h = -2
      If sgx(id)\origH = -1
        h = -1
      Else
        h = sgx(id)\h
      EndIf
    EndIf
    
    ; handle auto size for buttons with sprite
    If sgx(id)\type = #sgxTypeButton Or sgx(id)\type = #sgxTypeButtonToggle
      If w = -1
        If IsSprite(sgx(id)\spr[#sgx_GadgetSprNormal2])
          w = SpriteWidth (sgx(id)\spr[#sgx_GadgetSprNormal2]) + 2 * sgx(id)\x2 + 1
        Else
          ; at least get a safe size if no valid sprite
          w = 1
        EndIf
      EndIf
      If h = -1
        If IsSprite(sgx(id)\spr[#sgx_GadgetSprNormal2])
          h = SpriteHeight(sgx(id)\spr[#sgx_GadgetSprNormal2]) + 2 * sgx(id)\y2 + 1
        Else
          ; at least get a safe size if no valid sprite
          h = 1
        EndIf
      EndIf
      
    ElseIf sgx(id)\type = #sgxTypeText
      ; restore text that might have been modified by auto word wrap
      If sgx(id)\auto & #sgx_AutoNL
        sgx(id)\text = sgx(id)\origText
      EndIf
      ; set auto flags
      If (w=-1 Or h=-1)
        If w=-1
          sgx(id)\auto | #sgx_AutoW
          ; auto word wrap is only supported for fixed width
          sgx(id)\auto & ~#sgx_AutoNL
        Else
          sgx(id)\auto & ~#sgx_AutoW
        EndIf
        If h=-1
          sgx(id)\auto | #sgx_AutoH
        Else
          sgx(id)\auto & ~#sgx_AutoH
        EndIf
      EndIf
      If w>0
        ; remove possible auto width flag if fixed width is specified
        sgx(id)\auto & ~#sgx_AutoW
      EndIf
      If h>0
        ; remove possible auto height flag if fixed height is specified
        sgx(id)\auto & ~#sgx_AutoH
      EndIf
      
    ElseIf w=-1 Or h=-1
      sgx_err("automatic size adjustment with -1 is not supported for this element type: sgx("+Str(id)+").")
    EndIf
    
    If (w = -1 Or w > 0) And (h = -1 Or h > 0)
      If w <> wPrev  Or  w = -1  Or  h <> hPrev  Or  h = -1
        If sgx(id)\type & (#sgxTypeScrollbar|#sgxTypeTrackbar)
          
          ; detect change between from/to horizontal/vertical
          switched = #False
          ; (was ver and is hor) or (was hor and is ver)
          If ((hPrev > wPrev) And Not (h > w))  Or  (Not (hPrev > wPrev) And (h > w))
            switched = #True
          EndIf
          
          ; ; keep ratio between knob size and overall size
          ;If Not switched
          ;  fw = w / wPrev   ; ratio 'new width' / 'old width' ..
          ;  fh = h / hPrev
          ;  sgx(id)\w2 * fw  ; ..is also applied to 'knob width'
          ;  sgx(id)\h2 * fh
          ;Else
          ;  ; if switched then..
          ;  fw = w / hPrev   ; ..ratio 'new width' / 'old height' ..
          ;  fh = h / wPrev
          ;  sgx(id)\w2 * fh
          ;  sgx(id)\h2 * fw  ; ..is also applied to 'old knob height'
          ;  ; and knob size is swapped
          ;  tmp = sgx(id)\w2
          ;  sgx(id)\w2 = sgx(id)\h2
          ;  sgx(id)\h2 = tmp
          ;EndIf
          
          ; ensure valid knob size for later CreateSprite()
          If sgx(id)\w2 < 1
            sgx(id)\w2 = 1
          EndIf
          If sgx(id)\h2 < 1
            sgx(id)\h2 = 1
          EndIf
          
          sgx(id)\w = w
          sgx(id)\h = h
        Else
          sgx(id)\w = w
          sgx(id)\h = h
        EndIf
        sgx(id)\origW = w
        sgx(id)\origH = h
        sgxRefresh(id)
        If sgx(id)\type & (#sgxTypeScrollbar|#sgxTypeTrackbar)
          ; correcting knob position
          sgxSetState(id, sgx(id)\state)
        EndIf
        
        ; check if size changed
        If sgx(id)\w <> wPrev Or sgx(id)\h <> hPrev
          ; prepare event triggering
          AddElement(sgx_pendingEvents())
          sgx_pendingEvents()\id = id
          sgx_pendingEvents()\resized = 1
        EndIf
        
        ; refresh the topmost parent table we may find
        topmostTable = -1
        parent = sgx(id)\parent
        While parent <> -1
          If sgx(parent)\type = #sgxTypeTable
            topmostTable = parent
          EndIf
          parent = sgx(parent)\parent
        Wend
        If topmostTable <> -1
          ; refesh the table and possible sub tables
          sgxRefresh(topmostTable, #sgx_refreshNormalWithChildsOfTables)
        EndIf
        
      EndIf
    EndIf
  EndIf
EndProcedure


;** sgx_MoveChildsOf
;* updates the position of child elements if their parent element has moved, keeping their to-parent-position. _
;* child windows are not moved if their parent window moves, but instead their to-parent-position is updated accordingly. _
;* called in <a href=#f_sgxmove>sgxMove</a> And recursively whithin itself.
;** .id : ID of the sgx element which childs are to be repositioned.
Procedure sgx_MoveChildsOf(id)
  Static parent
  If sgx(id)\hasChilds
    sgx_llIterator(Protected *it, sgx(id)\treeElem\node)
    
      ; don't move child windows at all, only update their toParent-position
      If sgx(*it\id)\type = #sgxTypeWin
        parent = sgx(*it\id)\parent
        If parent <> -1
          sgx(*it\id)\xToParent = sgx(*it\id)\x - sgx(parent)\x
          sgx(*it\id)\yToParent = sgx(*it\id)\y - sgx(parent)\y
        EndIf
      Else
        
        ; move other childs using their toParent-position
        sgx(*it\id)\x = sgx_GetGadgetX(*it\id)
        sgx(*it\id)\y = sgx_GetGadgetY(*it\id)
        
        ; handle the child's childs
        If sgx(*it\id)\hasChilds
          sgx_MoveChildsOf(*it\id)
        EndIf
      EndIf
    sgx_llNext(*it)
  EndIf
EndProcedure


;** sgx_GetGadgetX
;* returns (and is used to update) the elements absolute position on screen (x, y) together with <a href=#f_sgx_getgadgety>sgx_GetGadgetY</a> by summarizing all to-parent-positions up the parent hierarchy. _
;** .id : ID of the sgx element.
Procedure sgx_GetGadgetX(id)
  Static ret
  Static parent
  ret = sgx(id)\xToParent
  parent = sgx(id)\parent
  While parent <> -1
    ret + sgx(parent)\xToParent
    parent = sgx(parent)\parent
  Wend
  ProcedureReturn ret
EndProcedure


;** sgx_GetGadgetY
;* returns (and is used to update) the elements absolute position on screen (x, y) together with <a href=#f_sgx_getgadgetx>sgx_GetGadgetX</a> by summarizing all to-parent-positions up the parent hierarchy. _
;** .id : ID of the sgx element.
Procedure sgx_GetGadgetY(id)
  Static ret
  Static parent
  ret = sgx(id)\yToParent
  parent = sgx(id)\parent
  While parent <> -1
    ret + sgx(parent)\yToParent
    parent = sgx(parent)\parent
  Wend
  ProcedureReturn ret
EndProcedure


;** sgxCloseLevel
;* call this function when you finished the creation of a window or table and it's childs. _
;* note that this function will always set the current parent to its own parent and NOT necessarily to the value
;* it had before a call of <a href=#f_sgxsetcurrentparent>sgxSetCurrentParent</a>.
;** .closeAllLevels : if set to #True, there will be no current parent after the call and new creations will be global. _
;* if set to #False (default), the above parent level will be the new current parent.
Procedure sgxCloseLevel(closeAllLevels=#False)
  If sgx_CurrentParent <> -1
    If sgx(sgx_CurrentParent)\type = #sgxTypeTable
      sgxRefresh(sgx_CurrentParent, #sgx_refreshNormalWithChildsOfTables)
      sgx_PopBuildRefresh()
    EndIf
    sgxSetCurrentParent(sgx(sgx_CurrentParent)\parent)
    
    If closeAllLevels = #True
      While sgx_CurrentParent <> -1
        sgxCloseLevel()
      Wend
    EndIf
  EndIf
EndProcedure


;** sgx_IsParentage
;* returns #True if 'parent' is found anywhere up the parent hierarchy of 'child', otherwise returns #False. _
;* used to highlight parent windows as hovered if one of their child windows is the active window.
;** .parent : the parent elements ID to be searched for.
;** .child  : the child elements ID.
Procedure sgx_IsParentage(parent, child)
  Static tempParent

  If sgxInBounds(parent) And sgxInBounds(child)
    tempParent = sgx(child)\parent
    While tempParent <> -1
      If tempParent = parent 
        ProcedureReturn #True
      EndIf
      tempParent = sgx(tempParent)\parent
    Wend
  EndIf
  ProcedureReturn #False
EndProcedure


;** sgx_getTypeString
;* returns a string informing about the type of an sgx element for debugging purposes.
;** .id : ID of the sgx element.
Procedure.s sgx_getTypeString(id)
  If sgx(id)
    Select sgx(id)\type
      Case #sgxTypeCursor       : ProcedureReturn "cursor"
      Case #sgxTypeButton       : ProcedureReturn "button"
      Case #sgxTypeButtonToggle : ProcedureReturn "buttonToggle"
      Case #sgxTypeSpriteGadget : ProcedureReturn "spriteGadet"
      Case #sgxTypeCheckbox     : ProcedureReturn "checkbox"
      Case #sgxTypeCombo        : ProcedureReturn "combo"
      Case #sgxTypeText         : ProcedureReturn "text"
      Case #sgxTypeEdit         : ProcedureReturn "edit"
      Case #sgxTypeScrollbarHor : ProcedureReturn "scrollbarHor"
      Case #sgxTypeScrollbarVer : ProcedureReturn "scrollbarVer"
      Case #sgxTypeTrackbarHor  : ProcedureReturn "trackbarHor"
      Case #sgxTypeTrackbarVer  : ProcedureReturn "trackbarVer"
      Case #sgxTypeTable        : ProcedureReturn "table"
      Case #sgxTypeWin          : ProcedureReturn "window"
      Case #sgxTypeArea         : ProcedureReturn "area"
      Default                   : ProcedureReturn "?"
    EndSelect
  EndIf
  ProcedureReturn "-"
EndProcedure


;** sgxDebugElem
;* returns a string with information about the element's attributes.
;** .id : ID of the sgx element.
;** .multiline : #False (default) to return a single line. #True to format with newlines (#LF$ / Chr(10)).
Procedure.s sgxDebugElem(id, multiline=#False)
  Protected ret.s, lf.s, text.s
  lf = ""
  If multiline
    lf = #LF$
  EndIf
  ret = ""
  ret + "[id=" + Str(id) + ", " + sgx_getTypeString(id) + "] " + lf
  ret + "(x,y=" + sgx(id)\x + "," + sgx(id)\y + ") " + lf
  ret + "(w,h=" + sgx(id)\w + "," + sgx(id)\h + ") " + lf
  ret + "(xToParent,yToParent=" + sgx(id)\xToParent + "," + sgx(id)\yToParent + ") " + lf
  ret + "(x2,y2=" + sgx(id)\x2 + "," + sgx(id)\y2 + ") " + lf
  ret + "(w2,h2=" + sgx(id)\w2 + "," + sgx(id)\h2 + ") " + lf
  ret + "(alpha=" + sgx(id)\alpha + ") " + lf
  ret + "(state=" + sgx(id)\state + ") " + lf
  ret + "(show=" + sgx(id)\show + ") " + lf
  ret + "(disabled=" + sgx(id)\disabled + ") " + lf
  ret + "(passive=" + sgx(id)\passive + ") " + lf
  text = Left(sgx(id)\text,100)
  If Len(text) > 20
    text = Left(text,20) + ".."
  EndIf
  ret + "(text=" + ReplaceString(text,#LF$,"\n") + ") " ; + lf
  ProcedureReturn ret
EndProcedure


;** sgxDebugTree
;* returns a string with information about the elements attributes and their hierarchy.
;** .id : -1 (default) to debug the whole element hierarchy. specify an element ID to only debug that element
;*        <span></span> and its childs recursively.
Procedure.s sgxDebugTree(id = -1)
  Protected ret.s
  Protected *list.sgx_llS_list
  Static level

  If id = -1
    ret = "[*sgxLayeredView]" + #LF$
    *list = *sgxLayeredView
  ElseIf sgxInBounds(id) And sgx(id)
    ret = LSet("",(level)*2,".")
    ret + sgxDebugElem(id)
    ret + #LF$
    *list = sgx(id)\treeElem\node
  Else
    ret = "sgxDebugTree: invalid id: " + Str(id) + #LF$
  EndIf
  
  If *list
    level+1
    sgx_llIterator(Protected *it, *list)
      ret + sgxDebugTree(*it\id)
    sgx_llNext(*it)
    level-1
  EndIf
  
  ProcedureReturn ret
EndProcedure


;** sgxSetFont
;* set the font for coming creations of new sgx elements.
;** .font : a valid PB #Font. if you pass sgxStdFont or an invalid font then the current font will be reset to the default.
Procedure sgxSetFont(font)
  If IsFont(font)
    sgx_CurrentFontID = FontID(font)
  Else
    sgx_CurrentFontID = FontID(sgxStdFont)
  EndIf
EndProcedure


;** sgxSetGroup
;* add an sgx element to a radio group. _
;* checkboxes and/or toggle buttons can be grouped using this function so that if one element gets checked/pushed, all
;* others will be unchecked/untoggled. _
;* those elements can still be unchecked via righclick per default setting of variable sgxRightclickUnset, so that no 
;* element in that group would be checked/pushed. _
;* see also <a href=#f_sgxgetgroup>sgxGetGroup</a>.
;** .id      : ID of the sgx element to be added
;** .groupID : any number. use same numbers for elements you want to group
Procedure sgxSetGroup(id, groupID)
  ForEach sgxGroups()
    If sgxGroups()\id=id
      DeleteElement(sgxGroups())
    EndIf
  Next
  AddElement(sgxGroups())
  sgxGroups()\id = id
  sgxGroups()\groupID = groupID
EndProcedure


;** sgxGetGroup
;* returns the groupID of an sgx element, or -1 if the element does not belong to a radio group. _
;* see also <a href=#f_sgxsetgroup>sgxSetGroup</a>.
;** .id : ID of the sgx element to be inquired
Procedure sgxGetGroup(id)
  ForEach sgxGroups()
    If sgxGroups()\id = id
      ProcedureReturn sgxGroups()\groupID
    EndIf
  Next
  ProcedureReturn -1
EndProcedure


;** sgxSetDimensions
;* tell sgx about the screen dimensions you use. _
;* this isn't necessary if a screen has been opened before the first call of <a href=#f_sgxloaddesign>sgxLoadDesign</a>.
;** .width  : screenwidth
;** .height : screenheight
Procedure sgxSetDimensions(width, height)
  sgx_dimensions\w = width
  sgx_dimensions\w = height
EndProcedure


;** sgxFree
;* free / delete an sgx element, including childs. the ID of the element and all its child element IDs will become invalid.
;** .id : ID of the sgx element to be freed
Procedure sgxFree(id)
  Protected i
  Protected parent
  If sgx(id)
    
    ;free childs
    If sgx(id)\hasChilds
      For i=0 To sgx_CURRENT_MAX_DYNAMIC_GADGETS
        sgx_SkipUnused(i)
        If sgx(i)  And  sgx(i)\parent = id
          sgxFree(i)
        EndIf
      Next
      sgx(id)\hasChilds = 0
    EndIf
    
    ; the freed children should have removed themself from the node actually, so it should be empty already
    If sgx(id)\treeElem And sgx(id)\treeElem\node
      sgx_llClearList(sgx(id)\treeElem\node)
      FreeMemory(sgx(id)\treeElem\node)
      sgx(id)\treeElem\node = 0;
    EndIf
    
    ;free gadget sprites
    For i=0 To 4
      If i = #sgx_GadgetSprNormal2  And  (sgx(id)\type = #sgxTypeButton Or sgx(id)\type = #sgxTypeButtonToggle)
        ; dont't free user sprites
        Continue
      EndIf
      sgx_FreeSpriteChecked(sgx(id)\spr[i])
    Next
    
    ;free tip sprite and memory
    If sgx(id)\tip
      sgx_FreeSpriteChecked(sgx(id)\tip\spr)
      FreeMemory(sgx(id)\tip)
      sgx(id)\tip = 0
    EndIf
    
    ;free table data
    If sgx(id)\table
      If sgx(id)\table\cells
        FreeMemory(sgx(id)\table\cells)
        sgx(id)\table\cells=0
      EndIf
      If sgx(id)\table\gridx
        FreeMemory(sgx(id)\table\gridx)
        sgx(id)\table\gridx=0
      EndIf
      If sgx(id)\table\gridy
        FreeMemory(sgx(id)\table\gridy)
        sgx(id)\table\gridy=0
      EndIf
      FreeMemory(sgx(id)\table)
      sgx(id)\table = 0
    EndIf
    
    ;remove entries in sgxGroups()
    ForEach sgxGroups()
      If sgxGroups()\id = id
        DeleteElement(sgxGroups())
      EndIf
    Next
    
    ;clean environment
    If sgx_CurrentParent = id
      sgxSetCurrentParent( sgx(id)\parent )
    EndIf
    
    If id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
    If id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
    If id = sgx_resizing       : sgx_resizing       = -1 : EndIf
    If id = sgx_moving         : sgx_moving         = -1 : EndIf
    If id = sgx_editing        : sgx_editing        = -1 : EndIf
    
    If id = sgx_m\cursor
      sgx_m\cursor = -1
    EndIf
    
    ; remove window from taskbar
    If sgx(id)\type = #sgxTypeWin 
      sgx(id)\state = #sgxWinStateNormal
      sgx_RefreshWinBar()
    EndIf
    
    ; remove the tree list element from its current parent's node and free it (deleting the treeElem will remove it from it's list too)
    sgx_llDelElem(sgx(id)\treeElem)
    sgx(id)\treeElem = 0
    
    ; remove the node of the parent (the parent's child list) if empty and update the hasChilds flag
    parent = sgx(id)\parent
    If parent <> -1
      If Not sgx(parent)\treeElem\node\first
        FreeMemory(sgx(parent)\treeElem\node)
        sgx(parent)\treeElem\node = 0
        sgx(parent)\hasChilds = 0
      EndIf
    Else
      ; the root node *sgxLayeredView stays valid even if
      ; empty and there is no 'hasChilds' on the root level
    EndIf
    
    ; free the basic sgxS_GADGET memory
    FreeMemory(sgx(id))
    sgx(id) = 0
    
    sgxNumberOfElements - 1
  EndIf
EndProcedure


;** sgxFreeChildsOf
;* free / delete all childs of an sgx element, including their own childs.
;** .parent : ID of the sgx element whose childs are to be freed. this parent will remain valid, the IDs of all 
;*            <span></span> child elements will become invald.
Procedure sgxFreeChildsOf(parent)
  Protected id
  For id=0 To sgx_CURRENT_MAX_DYNAMIC_GADGETS
    sgx_SkipUnused(id)
    If sgx(id) And sgx(id)\parent = parent
      sgxFree(id)
    EndIf
  Next
EndProcedure


;** sgx_HideChildsOf
;* hides or shows all childs of an element (but not the element itself) recursively but ignores child windows (per default).
;** .parent        : ID of the element whose childs are to be hidden/shown.
;** .show          : #False (default) to hide the childs, #True to make them visible.
;** .ignoreWindows : #True (default) to not modify child windows. #False if you want to hide/show also child windows (if 'parent' is a window).
Procedure sgx_HideChildsOf(parent, show=#False, ignoreWindows=#True)
  Protected id
  For id=0 To sgx_CURRENT_MAX_DYNAMIC_GADGETS
    sgx_SkipUnused(id)
    If sgx(id)  And  (sgx(id)\parent = parent)  And  (sgx(id)\type <> #sgxTypeWin Or Not ignoreWindows)
      If sgx(id)\hasChilds
        sgx_HideChildsOf(id,show)
      EndIf
      sgx(id)\show = show
    EndIf
  Next
EndProcedure


;** sgxSetShow
;* shows or hides an element. _
;* if you hide a window including its childs and later show it again then previously hidden childs will be all visible and
;* not restored to their actual previous visibility.
;** .id            : ID of the sgx element.
;** .show          : #True to show the element, or #False to hide it.
;** .recursively   : #True (default) to show/hide child elements too recursively. #False to only show/hide the element itself.
;** .ignoreWindows : if parameter 'recursively' is #True then recursion will not traverse into child windows per default (#True). set it to #False for complete recursion including child windows.
Procedure sgxSetShow(id, show, recursively=#True, ignoreWindows=#True)
  Static oldShow
  If sgxInBounds(id) And sgx(id)
    oldShow = sgx(id)\show
    sgx(id)\show = Bool(show)
    ; taskbar refresh for windows
    If sgx(id)\type = #sgxTypeWin  And  oldShow <> sgx(id)\show
      sgx_RefreshWinBar()
    EndIf
    If recursively
      sgx_HideChildsOf(id, sgx(id)\show, ignoreWindows)
    EndIf
  EndIf
EndProcedure



;** sgx_addAnimation
;* add an animation data object to the animation list. _
;* used by <a href=#f_sgxminimizewin>sgxMinimizeWin</a>, <a href=#f_sgxrestorewin>sgxRestoreWin</a>, <a href=#f_sgxclosewin>sgxCloseWin</a> and <a href=#f_sgxpresentwin>sgxPresentWin</a>
;** .id : ID of the element that should be animated.
;** .animationType : #sgxWinStateMinimizing, #sgxWinStateRestoring, #sgxWinStateClosing or #sgxWinStatePresenting.
Procedure sgx_addAnimation(id, animationType)
  If sgx(id)
    AddMapElement(sgx_animations(),Str(id))
    sgx_animations()\startTime = sgx_ems
    sgx_animations()\startX = sgx(id)\x
    sgx_animations()\startY = sgx(id)\y
    sgx_animations()\startW = sgx(id)\w
    sgx_animations()\startH = sgx(id)\h
    sgx_animations()\startAlpha = sgx(id)\alpha
    sgx_animations()\endX = sgx_animations()\startX
    sgx_animations()\endY = sgx_animations()\startY
    sgx_animations()\endW = sgx_animations()\startW
    sgx_animations()\endH = sgx_animations()\startH
    sgx_animations()\endAlpha = sgx_animations()\startAlpha
    
    ; the alpha value of childs of windows may be animated/interpolated
    ; directly between alpha and alpha2 of the element not using this
    ; general animation data
    
    If animationType = #sgxWinStateMinimizing
      
      If sgx_animStyle_minimizing & #sgxAnimFade
        sgx_animations()\endAlpha = 0
      EndIf
      If sgx_animStyle_minimizing & #sgxAnimRoll
        sgx_animations()\endY = sgx_dimensions\h-2-20
      EndIf
      If sgx_animStyle_minimizing & #sgxAnimZoom
        sgx_animations()\endX = sgx_xMinimizedWins
        sgx_animations()\endY = sgx_dimensions\h-2-20
        sgx_animations()\endW = 100
        sgx_animations()\endH = 20
      EndIf
      
    ElseIf animationType = #sgxWinStateRestoring
      
      If sgx_animStyle_restoring & #sgxAnimFade
        sgx_animations()\startAlpha = 0
        sgx_animations()\endAlpha = sgx(id)\alpha2
      Else
        sgx_animations()\startAlpha = sgx(id)\alpha2
        sgx_animations()\endAlpha = sgx(id)\alpha2
      EndIf
      If sgx_animStyle_restoring & #sgxAnimRoll
        sgx_animations()\startX = sgx(id)\x2
        sgx_animations()\startY = sgx_dimensions\h
        sgx_animations()\startW = sgx(id)\w2
        sgx_animations()\startH = sgx(id)\h2
        sgx_animations()\endY = sgx(id)\y2
      ElseIf sgx_animStyle_restoring & #sgxAnimZoom
        sgx_animations()\endX = sgx(id)\x2
        sgx_animations()\endY = sgx(id)\y2
        sgx_animations()\endW = sgx(id)\w2
        sgx_animations()\endH = sgx(id)\h2
      Else
        sgx_animations()\startX = sgx(id)\x2
        sgx_animations()\startY = sgx(id)\y2
        sgx_animations()\startW = sgx(id)\w2
        sgx_animations()\startH = sgx(id)\h2
      EndIf
      
    ElseIf animationType = #sgxWinStateClosing
      
      If sgx_animStyle_closing & #sgxAnimFade
        sgx_animations()\endAlpha = 0
      EndIf
      If sgx_animStyle_closing & #sgxAnimSizeW
        sgx_animations()\endW = 0
      EndIf
      If sgx_animStyle_closing & #sgxAnimSizeH
        sgx_animations()\endH = 0
      EndIf
      
    ElseIf animationType = #sgxWinStatePresenting
      
      If sgx_animStyle_presenting & #sgxAnimFade
        sgx_animations()\startAlpha = 0
        sgx_animations()\endAlpha = sgx(id)\alpha
      Else
        sgx_animations()\startAlpha = sgx(id)\alpha
        sgx_animations()\endAlpha = sgx(id)\alpha
      EndIf
      If sgx_animStyle_presenting & #sgxAnimSizeW
        sgx_animations()\startW = 1
        sgx_animations()\endW = sgx(id)\w
      EndIf
      If sgx_animStyle_presenting & #sgxAnimSizeH
        sgx_animations()\startH = 1
        sgx_animations()\endH = sgx(id)\h
      EndIf
      
    EndIf
  EndIf
EndProcedure


;** sgxMinimizeWin
;* initializes minimizing of window. _
;* the animation might finish immediately.
Procedure sgxMinimizeWin(id)
  Protected *it.sgx_llS_elem
  Static skipNode
  If sgx(id) And sgx(id)\type = #sgxTypeWin And sgx(id)\state = #sgxWinStateNormal
    
    ; backup current properties
    sgx(id)\x2 = sgx(id)\x
    sgx(id)\y2 = sgx(id)\y
    sgx(id)\w2 = sgx(id)\w
    sgx(id)\h2 = sgx(id)\h
    sgx(id)\alpha2 = sgx(id)\alpha
    ; backup child alpha/show individually
    If sgx(id)\hasChilds
      skipNode=#False
      sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
        ; constrain recursion to non-window childs
        If sgx(*it\id)\type = #sgxTypeWin
          skipNode = #True
        Else
          skipNode = #False
          sgx(*it\id)\alpha2 = sgx(*it\id)\alpha
          sgx(*it\id)\show2 = sgx(*it\id)\show
        EndIf
      sgx_llNextRecursive(*it, skipNode)
    EndIf
    
    ; create animation
    sgx_addAnimation(id, #sgxWinStateMinimizing)
    sgx(id)\state = #sgxWinStateMinimizing
    If sgx_animStyle_minimizing = 0
      ; if no animation style then expire the animation immediately
      sgx_animations()\startTime = sgx_ems - sgxAnimTime
    EndIf
    sgx_animate(id, sgx_animations())
    
    ; hide childs if size is animated and if animation has not finished immediately (happens if zero anim styles or a small/zero sgxAnimTime)
    If (sgx_animStyle_minimizing & #sgxAnimZoom) And sgx(id)\state = #sgxWinStateMinimizing
      sgx_HideChildsOf(id)
    EndIf
    
    If id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
    If id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
    If id = sgx_resizing       : sgx_resizing       = -1 : EndIf
    If id = sgx_moving         : sgx_moving         = -1 : EndIf
    ;If id = sgx_editing        : sgx_editing        = -1 : EndIf
  EndIf
EndProcedure


;** sgxRestoreWin
;* initializes restoring of window. _
;* the window's 'resized' event will be triggered when the animation has finished which can be received after 
;* the next call of <a href=#f_sgxexamine>sgxExamine</a>. _
;* the animation might finish immediately.
Procedure sgxRestoreWin(id)
  Protected *it.sgx_llS_elem ; use Protected when using recursion!
  Static skipNode
  If sgx(id) And sgx(id)\type = #sgxTypeWin And sgx(id)\state = #sgxWinStateMinimized
    
    ; set state and restore pos/size
    sgx_addAnimation(id, #sgxWinStateRestoring)
    sgx(id)\state = #sgxWinStateRestoring
    
    ; how restoring begins depends on animation styles
    sgx(id)\x = sgx_animations()\startX
    sgx(id)\y = sgx_animations()\startY
    sgx(id)\w = sgx_animations()\startW
    sgx(id)\h = sgx_animations()\startH
    sgxSetAlpha(sgx_animations()\startAlpha, id, #True)
    
    sgxRefresh(id)
    sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
    sgx_RefreshWinBar()
    sgxActiveWin=id
    
    If sgx_animStyle_restoring = 0
      ; if no animation style then expire the animation immediately
      sgx_animations()\startTime = sgx_ems - sgxAnimTime
    EndIf
    sgx_animate(id, sgx_animations())
    
    ; hide childs if size is animated and if animation has not finished immediately (happens if zero anim styles or a small/zero sgxAnimTime)
    If (sgx_animStyle_restoring & #sgxAnimZoom)  And  sgx(id)\state = #sgxWinStateRestoring
      sgx_HideChildsOf(id)
    Else
      ; otherwise show
      ;sgx_HideChildsOf(id, #True)
      ; restore child show individually
      If sgx(id)\hasChilds
        skipNode=#False
        sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
          ; constrain recursion to non-window childs
          If sgx(*it\id)\type = #sgxTypeWin
            skipNode = #True
          Else
            skipNode = #False
            sgx(*it\id)\show = sgx(*it\id)\show2
          EndIf
        sgx_llNextRecursive(*it, skipNode)
      EndIf
    EndIf
    
  EndIf
EndProcedure


;** sgxCloseWin
;* initializes closing of a window and it's child windows. _
;* the animation might finish immediately in wich case the element and its childs will have been deleted
;* and their IDs become invalid. in that case the returnvalue is 1, otherwise 0.
Procedure sgxCloseWin(id)
  Protected *it.sgx_llS_elem ; use Protected when using recursion!
  Static destroyed
  If sgx(id) And sgx(id)\type = #sgxTypeWin ;And sgx(id)\state = #sgxWinStateNormal
    sgx(id)\state = #sgxWinStateClosing
    sgx_addAnimation(id, #sgxWinStateClosing)
    
    ; backup current properties
    ; (though not used at the moment since the element will die anyway)
    sgx(id)\x2 = sgx(id)\x
    sgx(id)\y2 = sgx(id)\y
    sgx(id)\w2 = sgx(id)\w
    sgx(id)\h2 = sgx(id)\h
    sgx(id)\alpha2 = sgx(id)\alpha
    ; backup child alpha/show individually
    If sgx(id)\hasChilds
      sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
        sgx(*it\id)\alpha2 = sgx(*it\id)\alpha
        sgx(*it\id)\show2 = sgx(*it\id)\show
      sgx_llNextRecursive(*it)
    EndIf
    
    ; withdraw focus..
    If id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
    If id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
    If id = sgx_resizing       : sgx_resizing       = -1 : EndIf
    If id = sgx_moving         : sgx_moving         = -1 : EndIf
    If id = sgx_editing        : sgx_editing        = -1 : EndIf
    ; ..also from childs
    If sgx(id)\hasChilds
      sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
        If *it\id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
        If *it\id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
        If *it\id = sgx_resizing       : sgx_resizing       = -1 : EndIf
        If *it\id = sgx_moving         : sgx_moving         = -1 : EndIf
        If *it\id = sgx_editing        : sgx_editing        = -1 : EndIf
      sgx_llNextRecursive(*it)
    EndIf
    
    If sgx_animStyle_closing = 0
      ; if no animation style then expire the animation immediately
      sgx_animations()\startTime = sgx_ems - sgxAnimTime
    EndIf
    destroyed = sgx_animate(id, sgx_animations())
    
    ; animation might have finished immediately (happens if zero anim styles or a small/zero sgxAnimTime)
    If Not destroyed
      
      ; hide childs if size is animated
      If (sgx_animStyle_closing & #sgxAnimSize)
        sgx_HideChildsOf(id)
      EndIf
      
      ; close child windows as well
      If sgx(id)\hasChilds
        sgx_llIterator(*it, sgx(id)\treeElem\node)
          If sgx(*it\id)  And  (sgx(*it\id)\type = #sgxTypeWin)  ;And  (sgx(*it\id)\state = #sgxWinStateNormal)
            sgxCloseWin(*it\id)
          EndIf
        sgx_llNext(*it)
      EndIf
      
    Else
      ; tell the caller the element has been destroyed
      ProcedureReturn 1
    EndIf
  EndIf
  ProcedureReturn 0
EndProcedure


;** sgxPresentWin
;* initializes presenting of a window and it's child windows. _
;* the window's 'resized' event will be triggered when the animation has finished which can be received after 
;* the next call of <a href=#f_sgxexamine>sgxExamine</a>. _
;* the animation might finish immediately.
Procedure sgxPresentWin(id)
  Protected *it.sgx_llS_elem ; use Protected when using recursion!
  Protected skipNode
  
  If sgx(id) And sgx(id)\type = #sgxTypeWin And sgx(id)\state = #sgxWinStateNormal
    sgx(id)\state = #sgxWinStatePresenting
    sgx_addAnimation(id, #sgxWinStatePresenting)
    
    ; backup current properties
    sgx(id)\x2 = sgx(id)\x
    sgx(id)\y2 = sgx(id)\y
    sgx(id)\w2 = sgx(id)\w
    sgx(id)\h2 = sgx(id)\h
    sgx(id)\alpha2 = sgx(id)\alpha
    ; backup child alpha/show individually
    If sgx(id)\hasChilds
      sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
        skipNode=#False
        ; constrain recursion to non-window childs (child windows handled later)
        If sgx(*it\id)\type = #sgxTypeWin
          skipNode = #True
        Else
          skipNode = #False
          ; backup alpha
          sgx(*it\id)\alpha2 = sgx(*it\id)\alpha
          
          ; backup 'show' only if window (and childs) has not been hidden (i.e. after creation for later presenting)
          If sgx(id)\show
            sgx(*it\id)\show2 = sgx(*it\id)\show
          Else
            ; other wise we just backup #True for later restoring of visibility.
            sgx(*it\id)\show2 = #True
          EndIf
        EndIf
      sgx_llNextRecursive(*it, skipNode)
    EndIf
    
    ; how presenting begins depends on animation styles
    sgx(id)\x = sgx_animations()\startX 
    sgx(id)\y = sgx_animations()\startY
    sgx(id)\w = sgx_animations()\startW
    sgx(id)\h = sgx_animations()\startH
    sgxSetAlpha(sgx_animations()\startAlpha, id, #True)
    
    sgxRefresh(id)
    sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
    
    If sgx_animStyle_presenting = 0
      ; if no animation style then expire the animation immediately
      sgx_animations()\startTime = sgx_ems - sgxAnimTime
    EndIf
    
    sgx_animate(id, sgx_animations())
    
    ; hide childs and show window if size is animated and if animation has not finished immediately (happens if zero anim styles or a small/zero sgxAnimTime)
    If sgx_animStyle_presenting & #sgxAnimSize And sgx(id)\state = #sgxWinStatePresenting
      sgx_HideChildsOf(id)
      sgxSetShow(id, #True, #False)
    Else
      ; show element and childs if window is hidden (i.e. has been hidden after creation for later presenting).
      ; if not hidden then keep current visibility including child visibility
      If Not sgx(id)\show
        sgxSetShow(id, #True)
      EndIf
    EndIf
    
    ; present child windows as well
    If sgx(id)\hasChilds
      sgx_llIterator(*it, sgx(id)\treeElem\node)
        If sgx(*it\id)\type = #sgxTypeWin  And  sgx(*it\id)\state = #sgxWinStateNormal
          sgxPresentWin(*it\id)
        EndIf
      sgx_llNext(*it)
    EndIf
    
  EndIf
EndProcedure


;** sgx_RefreshWinBar
;* determines visible minimized windows and repositions them as buttons in the taskbar. _
;* used after a window's state or its visibility has changed for example.
Procedure sgx_RefreshWinBar()
  Static *it.sgx_llS_elem ; use Protected when using recursion!
  sgx_xMinimizedWins = 2
  sgx_llIteratorRecursive(*it, *sgxLayeredView)
    If sgx(*it\id)  And  (sgx(*it\id)\type = #sgxTypeWin)  And  sgx(*it\id)\show  And  (sgx(*it\id)\state = #sgxWinStateMinimized)
      sgxMove(*it\id, sgx_xMinimizedWins, sgx(*it\id)\y, #False)
      sgx_xMinimizedWins + sgx(*it\id)\w + 2
    EndIf
  sgx_llNextRecursive(*it)
EndProcedure


;** sgx_animate
;* animate an element, that is to say, update its attributes according to the currently reach animation progress.  _
;* returns 1 if the element has been destroyed due to a finished closing animation.
;** .id         : ID of the element to be animated
;** .*animation : an animtaion data object from the animation map 'sgx_animations'
Procedure sgx_animate(id, *animation.sgxS_Animation)
  Static time
  Static fraction.f
  Static *it.sgx_llS_elem ; use Protected when using recursion!
  Static skipNode
  
  time = 0
  fraction.f = 0
  
  If *animation
    
    ; time passed since animation start
    time = (sgx_ems - *animation\startTime)
    
    ; how much we have progressed in the animation (0.0 at the beginning, 1.0 when animation time reached sgxAnimTime)
    fraction.f = time/sgxAnimTime
    If fraction > 1
      ; fraction gets much to big if sgxAnimTime is very small or 0, for example time=60ms and sgxAnimTime=1
      fraction = 1
    EndIf
    
    ; ------------------------------------------------------
    ; minimizing window
    If sgx(id)\state = #sgxWinStateMinimizing
      
      ; animate
      If sgx_animStyle_minimizing & #sgxAnimRoll
        sgxMove(id, sgx(id)\x, *animation\startY + fraction * (*animation\endY - *animation\startY), #False )
      ElseIf sgx_animStyle_minimizing & #sgxAnimZoom
        sgx(id)\x = *animation\startX - fraction * (*animation\startX - *animation\endX)
        sgx(id)\y = *animation\startY + fraction * (*animation\endY - *animation\startY)
        
        sgx(id)\w = *animation\startW - fraction * (*animation\startW - *animation\endW)
        If sgx(id)\w < 1
          sgx(id)\w = 1
        EndIf
        sgx(id)\h = *animation\startH - fraction * (*animation\startH - *animation\endH)
        If sgx(id)\h < 1
          sgx(id)\h = 1
        EndIf
        sgxRefresh(id)
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
      EndIf
      If sgx_animStyle_minimizing & #sgxAnimFade
        ;sgxSetAlpha(*animation\startAlpha - fraction * (*animation\startAlpha - *animation\endAlpha), id, #True)
        
        ; animating alpha individually
        sgx(id)\alpha = sgx(id)\alpha2 - fraction * sgx(id)\alpha2
        If sgx(id)\hasChilds
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            skipNode=#False
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = sgx(*it\id)\alpha2 - fraction * sgx(*it\id)\alpha2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
      EndIf
      
      ; finish minimizing
      If time >= sgxAnimTime
        
        ; set state
        sgx(id)\state = #sgxWinStateMinimized
        
        ; withdraw any focus
        If id = sgxActiveWin       : sgxActiveWin       = -1 : EndIf
        If id = sgx_focusCatchedBy : sgx_focusCatchedBy = -1 : EndIf
        If id = sgx_resizing       : sgx_resizing       = -1 : EndIf
        If id = sgx_moving         : sgx_moving         = -1 : EndIf
        If id = sgx_editing        : sgx_editing        = -1 : EndIf
        
        ; transform window to taskbar button
        sgx(id)\w = 100
        sgx(id)\h = 20
        sgx(id)\x = sgx_xMinimizedWins
        sgx(id)\y = sgx_dimensions\h-2-20
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
        sgx_RefreshWinBar()
        sgxRefresh(id)
        
        ; restore alpha
        sgx(id)\alpha = sgx(id)\alpha2
        ; restore child alpha/show individually
        If sgx(id)\hasChilds
          skipNode=#False
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = sgx(*it\id)\alpha2
              sgx(*it\id)\show = sgx(*it\id)\show2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
        
        ; hide childs
        sgx_HideChildsOf(id, #False, #True)
        
        ; remove animation
        DeleteMapElement(sgx_animations(), Str(id))
        *animation = 0
      EndIf
      
    ; ------------------------------------------------------
    ; restoring window
    ElseIf sgx(id)\state = #sgxWinStateRestoring
      
      ; animate
      If sgx_animStyle_restoring & #sgxAnimRoll
        sgxMove(id, sgx(id)\x, *animation\startY + fraction * (*animation\endY - *animation\startY), #False )
      ElseIf sgx_animStyle_restoring & #sgxAnimZoom
        sgx(id)\x = *animation\startX + fraction * (*animation\endX - *animation\startX)
        sgx(id)\y = *animation\startY - fraction * (*animation\startY - *animation\endY)
        
        sgx(id)\w = *animation\startW + fraction * (*animation\endW - *animation\startW)
        If sgx(id)\w < 1
          sgx(id)\w = 1
        EndIf
        sgx(id)\h = *animation\startH + fraction * (*animation\endH - *animation\startH)
        If sgx(id)\h < 1
          sgx(id)\h = 1
        EndIf
        sgxRefresh(id)
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
      EndIf
      If sgx_animStyle_restoring & #sgxAnimFade
        ;sgxSetAlpha(*animation\startAlpha + fraction * (*animation\endAlpha - *animation\startAlpha), id, #True)
        
        ; animating alpha individually
        sgx(id)\alpha = fraction * sgx(id)\alpha2
        If sgx(id)\hasChilds
          skipNode=#False
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = fraction * sgx(*it\id)\alpha2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
      EndIf
      
      ; finish restoring
      If time >= sgxAnimTime
        
        ; set state
        sgx(id)\state = #sgxWinStateNormal
        
        ; restore properties (resetting x,w,h and refresh might be redundant for 'roll')
        sgx(id)\x = sgx(id)\x2
        sgx(id)\y = sgx(id)\y2
        sgx(id)\w = sgx(id)\w2
        sgx(id)\h = sgx(id)\h2
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
        sgxRefresh(id)
        
        ; restore alpha
        sgx(id)\alpha = sgx(id)\alpha2
        ; restore child alpha/show individually
        If sgx(id)\hasChilds
          skipNode=#False
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = sgx(*it\id)\alpha2
              sgx(*it\id)\show = sgx(*it\id)\show2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
        
        ; show childs (should be already if size is not animated)
        ;sgx_HideChildsOf(id, #True)
        
        ; prepare event triggering
        AddElement(sgx_pendingEvents())
        sgx_pendingEvents()\id = id
        sgx_pendingEvents()\resized = 1
        
        sgxActiveWin = id
        
        ; remove animation
        DeleteMapElement(sgx_animations(), Str(id))
        *animation = 0
      EndIf
      
    ; ------------------------------------------------------
    ; closing window
    ElseIf sgx(id)\state = #sgxWinStateClosing
      
      ; animate
      If sgx_animStyle_closing & #sgxAnimSizeW
        sgx(id)\w = *animation\startW - fraction * (*animation\startW - *animation\endW)
        If sgx(id)\w < 1
          sgx(id)\w = 1
        EndIf
        sgx(id)\x = *animation\startX + *animation\startW/2 - sgx(id)\w/2
      EndIf
      If sgx_animStyle_closing & #sgxAnimSizeH
        sgx(id)\h = *animation\startH - fraction * (*animation\startH - *animation\endH)
        If sgx(id)\h < 1
          sgx(id)\h = 1
        EndIf
        sgx(id)\y = *animation\startY + *animation\startH/2 - sgx(id)\h/2
      EndIf
      If sgx_animStyle_closing & #sgxAnimSize
        sgxRefresh(id)
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
      EndIf
      If sgx_animStyle_closing & #sgxAnimFade
        ;sgxSetAlpha(*animation\startAlpha - fraction * (*animation\startAlpha - *animation\endAlpha), id, #True)
        
        ; animating alpha individually
        sgx(id)\alpha = sgx(id)\alpha2 - fraction * sgx(id)\alpha2
        If sgx(id)\hasChilds
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            sgx(*it\id)\alpha = sgx(*it\id)\alpha2 - fraction * sgx(*it\id)\alpha2
          sgx_llNextRecursive(*it)
        EndIf
      EndIf
      
      ; finish closing
      If time >= sgxAnimTime
        
        ; remove element
        sgxFree(id)
        
        ; remove animation
        DeleteMapElement(sgx_animations(), Str(id))
        *animation = 0
        
        ; tell the caller the element has been destroyed
        ProcedureReturn 1
      EndIf
      
    ; ------------------------------------------------------
    ; presenting window
    ElseIf sgx(id)\state = #sgxWinStatePresenting
      
      ;Debug "id:"+Str(id)+" x,y:"+Str(sgx(id)\x)+","+Str(sgx(id)\y)+" w,h:"+Str(sgx(id)\w)+","+Str(sgx(id)\h)+", a:"+Str(sgx(id)\alpha)+", sh:"+Str(sgx(id)\show)+", ss:"+Str(sgx(id)\state)
      
      ; animate
      If sgx_animStyle_presenting & #sgxAnimSizeW
        sgx(id)\w = *animation\startW - fraction * (*animation\startW - *animation\endW)
        If sgx(id)\w < 1
          sgx(id)\w = 1
        EndIf
        sgx(id)\x = *animation\startX + *animation\endW/2 - sgx(id)\w/2
      EndIf
      If sgx_animStyle_presenting & #sgxAnimSizeH
        sgx(id)\h = *animation\startH - fraction * (*animation\startH - *animation\endH)
        If sgx(id)\h < 1
          sgx(id)\h = 1
        EndIf
        sgx(id)\y = *animation\startY + *animation\endH/2 - sgx(id)\h/2
      EndIf
      If sgx_animStyle_presenting & #sgxAnimSize ; if size is animated
        sgxRefresh(id)
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
      EndIf
      If sgx_animStyle_presenting & #sgxAnimFade
        ;sgxSetAlpha(*animation\startAlpha - fraction * (*animation\startAlpha - *animation\endAlpha), id, #True)
        
        ; animating alpha individually
        sgx(id)\alpha = fraction * sgx(id)\alpha2
        If sgx(id)\hasChilds
          skipNode=#False
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = fraction * sgx(*it\id)\alpha2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
      EndIf
      
      ;Debug "id:"+Str(id)+" x,y:"+Str(sgx(id)\x)+","+Str(sgx(id)\y)+" w,h:"+Str(sgx(id)\w)+","+Str(sgx(id)\h)+", a:"+Str(sgx(id)\alpha)+", sh:"+Str(sgx(id)\show)+", ss:"+Str(sgx(id)\state)
      
      ; finish presenting
      If time >= sgxAnimTime
        
        ; set state
        sgx(id)\state = #sgxWinStateNormal
        
        ; restore properties
        sgx(id)\x = sgx(id)\x2
        sgx(id)\y = sgx(id)\y2
        sgx(id)\w = sgx(id)\w2
        sgx(id)\h = sgx(id)\h2
        sgxMove(id, sgx(id)\x, sgx(id)\y, #False)
        sgxRefresh(id)
        
        ; restore alpha
        sgx(id)\alpha = sgx(id)\alpha2
        ; restore child alpha/show individually
        sgx(id)\alpha = sgx(id)\alpha2
        If sgx(id)\hasChilds
          skipNode=#False
          sgx_llIteratorRecursive(*it, sgx(id)\treeElem\node)
            ; constrain recursion to non-window childs
            If sgx(*it\id)\type = #sgxTypeWin
              skipNode = #True
            Else
              skipNode = #False
              sgx(*it\id)\alpha = sgx(*it\id)\alpha2
              sgx(*it\id)\show = sgx(*it\id)\show2
            EndIf
          sgx_llNextRecursive(*it, skipNode)
        EndIf
        
        ; prepare event triggering
        AddElement(sgx_pendingEvents())
        sgx_pendingEvents()\id = id
        sgx_pendingEvents()\resized = 1
        
        sgxActiveWin = id
        
        ; show childs  
        ;sgx_HideChildsOf(id, #True)  
        
        ; remove animation
        DeleteMapElement(sgx_animations(), Str(id))
        *animation = 0
      EndIf
    EndIf
  EndIf
  
  ; everything is normal
  ProcedureReturn 0;
EndProcedure


;** sgxSetWinAnimStyle
;* configures window animations. _
;* animation of size will make a window hide its childs during the animation. animations 'zoom' and 'roll' only work for minimizing and restoring of windows.
;** .winState     : the type of animation you want to configure: #sgxWinStateMinimizing, #sgxWinStateRestoring, #sgxWinStateClosing or #sgxWinStatePresenting
;** .winAnimStyle : combination of animation styles (you can combine them with '|' (bitwise OR)): _
;*                  #sgxAnimFade : animate the elements alpha value (transparency) _ 
;*                  #sgxAnimSizeW : collapse / expand the width _ 
;*                  #sgxAnimSizeH : collapse / expand the height _ 
;*                  #sgxAnimSize : collapse / expand width and height _ 
;*                  #sgxAnimZoom : zoom windows into / out of the taskbar _
;*                  #sgxAnimRoll : roll windows down to / up from the taskbar _
Procedure sgxSetWinAnimStyle(winState, winAnimStyle)
  Select winState
    Case #sgxWinStateMinimizing
      sgx_animStyle_minimizing = winAnimStyle
    Case #sgxWinStateRestoring
      sgx_animStyle_restoring = winAnimStyle
    Case #sgxWinStateClosing
      sgx_animStyle_closing = winAnimStyle
    Case #sgxWinStatePresenting
      sgx_animStyle_presenting = winAnimStyle
  EndSelect
EndProcedure


;** sgxSetTextcursorType
;* changes the type of the textcursor used by sgxEdit elements. call this function before creating sgxEdit elements, otherwise the change takes effect with next element refresh.
;** .textcursorType   : one of these values: _
;*                      #sgxTextcursorTypeIBeam (I-Beam type cursor) _
;*                      #sgxTextcursorTypeTeeth (something like an open I-Beam cursor) _
;*                      #sgxTextcursorTypeLine (vertical line) _
;*                      #sgxTextcursorTypeLine2 (thicker vertical line/bar) _
;*                      #sgxTextcursorTypeLine3 (vertical line/bar with some alpha blending) _
;*                      #sgxTextcursorTypeCaret (caret type cursor) _
Procedure sgxSetTextcursorType(textcursorType)
  Select textcursorType
    Case #sgxTextcursorTypeIBeam, #sgxTextcursorTypeTeeth, 
         #sgxTextcursorTypeLine, #sgxTextcursorTypeLine2, #sgxTextcursorTypeLine3,
         #sgxTextcursorTypeCaret
      sgx_textcursorType = textcursorType
  EndSelect
EndProcedure


;** sgxSetText
;* changes the text of an sgx element and refreshes it. _
;* this function may trigger the 'changed' event for sgxEdit elements which can be received after 
;* the next call of <a href=#f_sgxexamine>sgxExamine</a>. _
;** .id   : ID of the sgx element whose text is to be changed.
;** .text : new text.
Procedure sgxSetText(id, text.s)
  Static textPrevious.s
  If sgx(id)
    If sgx(id)\type = #sgxTypeText
      ; we don't check text change for event triggering, since text could be change by style/wordwrap etc.
      ; we _could_ check the new text against the current origText though i guess.
      sgx(id)\origText = text
    ElseIf sgx(id)\type = #sgxTypeEdit
      textPrevious = sgx(id)\text
    EndIf
    sgx(id)\text = text
    sgxRefresh(id)
    If sgx(id)\type = #sgxTypeEdit
      If sgx(id)\text <> textPrevious
        AddElement(sgx_pendingEvents())
        sgx_pendingEvents()\id = id
        sgx_pendingEvents()\changed = 1
      EndIf
    EndIf
  EndIf
  textPrevious = ""
EndProcedure


;** sgxSetResizable
;* make an element resizeable via the mouse. _
;* sgxTable elements determine their size by their childs and cannot be resized directly. _
;* sgxCheckbox elements resize only their knob (w,h) but their overall size (w2,h2) might be influenced by this too. _
;* scrollbars/trackbars will resize only their bar and not their knob. _
;* use <a href=#f_sgxsetminsize>sgxSetMinSize</a> to ensure a minimum size. _
;* the element's 'resized' field will be triggered every time the size changes.
;** .id        : ID of the sgx element.
;** .resizable : #True (default) to make the element resizable. #False to disable resizing via mouse.
Procedure sgxSetResizable(id, resizable=#True)
  If sgx(id) And sgx(id)\type <> #sgxTypeTable
    If resizable
      sgx(id)\resizable = 1
    Else
      sgx(id)\resizable = 0
    EndIf
  EndIf
EndProcedure


;** sgxSetMinSize
;* set the minimum size allowed for manually resizing elements via mouse. _
;* the default minimum size (if you don't call this function) is the size of the resize gadget.
;** .id          : ID of the sgx element.
;** .minWidth.i  : the smallest width allowed for resizing. must be greater 0.
;** .minHeight.i : the smallest height allowed for resizing. must be greater 0.
Procedure sgxSetMinSize(id, minWidth, minHeight)
  If sgx(id)
    If minWidth < 1
      minWidth = 1
    EndIf
    If minHeight < 1
      minHeight = 1
    EndIf
    sgx(id)\minWidth = minWidth
    sgx(id)\minHeight = minHeight
  EndIf
EndProcedure


;** sgxSetScrollMax
;* change the range of a scrollbar/trackbar. _
;* this will update the element's state if the new maximum is lower than its current state and updates the knob position.
;* the element's 'changed' event might be triggered if the state changes.
;** .id  : ID of the sgx scrollbar/trackbar element.
;** .max : new maximum possible scroll state (minimum is 0). this must be greater than 0 and will be corrected to 1 
;*         <span></span> automatically if necessary.
Procedure sgxSetScrollMax(id, max)
  Static state
  If sgx(id) And sgx(id)\type & (#sgxTypeScrollbar|#sgxTypeTrackbar)
    If max < 1
      max = 1
    EndIf
    state = sgx(id)\state
    If state > max
      state = max
    EndIf
    sgx(id)\scrollpos=0
    sgx(id)\max = max
    sgxSetState(id, state)
  EndIf
EndProcedure


;** sgx_SetScrollPos
;* translates a pixel position on scrollbar/trackbar into its state and updates the knob position and the 'state' and 'changed' fields (directly without using pending events, so it should only be called during <a href=#f_sgxexamine>sgxExamine</a>).
;** .id        : ID of the sgx element.
;** .scrollpos : pixel position on the bar. will be automatically clipped into the valid range.
Procedure sgx_SetScrollPos(id, scrollpos)
  Protected tmp
  If sgx(id)
    Select sgx(id)\type
      Case #sgxTypeScrollbarVer, #sgxTypeTrackbarVer
        sgx(id)\scrollpos = scrollpos
        If sgx(id)\scrollpos < sgx(id)\width/2
          sgx(id)\scrollpos = sgx(id)\width/2
        ElseIf sgx(id)\scrollpos > sgx(id)\h-sgx(id)\width/2
          sgx(id)\scrollpos = sgx(id)\h-sgx(id)\width/2
        EndIf
        tmp = sgx(id)\max * (sgx(id)\scrollpos-sgx(id)\width/2) / (sgx(id)\h-sgx(id)\width)
        ; trackbar default is 0 at the bottom. for scrollbars only when reversed.
        If (sgx(id)\type = #sgxTypeTrackbarVer)  XOr  (sgx(id)\style & #sgxStyleReverse)
          tmp = sgx(id)\max - tmp
        EndIf
        sgx(id)\changed = tmp - sgx(id)\state
        sgx(id)\state = tmp
        sgx(id)\y2 = sgx(id)\scrollpos - sgx(id)\width/2

      Case #sgxTypeScrollbarHor, #sgxTypeTrackbarHor
        sgx(id)\scrollpos = scrollpos
        If sgx(id)\scrollpos < sgx(id)\width/2
          sgx(id)\scrollpos = sgx(id)\width/2
        ElseIf sgx(id)\scrollpos > sgx(id)\w-sgx(id)\width/2
          sgx(id)\scrollpos = sgx(id)\w-sgx(id)\width/2
        EndIf
        tmp = sgx(id)\max * (sgx(id)\scrollpos-sgx(id)\width/2) / (sgx(id)\w-sgx(id)\width)
        ; default is 0 at the left. at the right when reversed.
        If (sgx(id)\style & #sgxStyleReverse)
          tmp = sgx(id)\max - tmp
        EndIf
        sgx(id)\changed = tmp - sgx(id)\state
        sgx(id)\state = tmp
        sgx(id)\x2 = sgx(id)\scrollpos - sgx(id)\width/2
    EndSelect
  EndIf
EndProcedure


;** sgxSetState
;* changes the state of an sgx element and refreshes it if necessary. _
;* this function may trigger the 'changed' event for the element (or for other elements in a radiogroup) which can be
;* received after the next call of <a href=#f_sgxexamine>sgxExamine</a>.
;** .id    : ID of the sgx element whose state is to be changed.
;** .state : the new state (don't ever use #sgxState.. values here because these are used only during element creation.). _
;* for scrollbars and trackbars the state will not be changed if it's lower than 0 or greater than the maximum. _
;* for toggle buttons and checkboxes specify a state of 1 for toggled/checked or 0 for not toggled/checked. _
;* for combos the state must be in the range of 1 to the number of entries (both inclusive) otherwise the state will not be changed. _
;* for sprite gadgets the parameter 'state' must be a valid PB sprite number or 0 to detach the current sprite. this will also update the element's size according to the size of the sprite. if you specify 0 as the sprite then the element size will be zero and you won't receive any mouse events! _
;* to change the state of a window use <a href=#f_sgxpresentwin>sgxPresentWin</a>, <a href=#f_sgxminimizewin>sgxMinimizeWin</a>, <a href=#f_sgxrestorewin>sgxRestoreWin</a> and <a href=#f_sgxclosewin>sgxCloseWin</a>. _
;* _
;** .handleRadioGroups : #True (default) to also handle other element's state in a possibly assigned radiogroup accordingly.
;** .*changed : used internally by <a href=#f_sgxexamine>sgxExamine</a> to correctly set the 'changed' flag for the other radiogroup members.
Procedure sgxSetState(id, state, handleRadioGroups=#True, *changed.sgxS_ListWrapper=0)
  Static groupId
  Static scrollpos
  Static previousState
  If sgx(id)
    Select sgx(id)\type
        
        ; SCROLLBARS, TRACKBARS
      Case #sgxTypeTrackbarHor, #sgxTypeScrollbarHor
        If state>=0 And state<=sgx(id)\max
          ; default is 0 at the left. at the right when reversed.
          If (sgx(id)\style & #sgxStyleReverse)
            scrollpos = sgx(id)\width/2 + (sgx(id)\w-sgx(id)\width) * (sgx(id)\max - state) / (sgx(id)\max)
          Else
            scrollpos = sgx(id)\width/2 + (sgx(id)\w-sgx(id)\width) * (              state) / (sgx(id)\max)
          EndIf
          previousState = sgx(id)\state
          ; update knob position
          sgx_SetScrollPos(id, scrollpos)
          sgx(id)\state = state
          ; prepare event triggering
          If sgx(id)\state <> previousState
            AddElement(sgx_pendingEvents())
            sgx_pendingEvents()\id = id
            sgx_pendingEvents()\changed = sgx(id)\state - previousState
          EndIf
        EndIf
      Case #sgxTypeTrackbarVer, #sgxTypeScrollbarVer
        If state>=0 And state<=sgx(id)\max
          ; trackbar default is 0 at the bottom. for scrollbars only when reversed.
          If (sgx(id)\type = #sgxTypeTrackbarVer)  XOr  (sgx(id)\style & #sgxStyleReverse)
            scrollpos = sgx(id)\width/2 + (sgx(id)\h-sgx(id)\width) * (sgx(id)\max - state) / (sgx(id)\max)
          Else
            scrollpos = sgx(id)\width/2 + (sgx(id)\h-sgx(id)\width) * (              state) / (sgx(id)\max)
          EndIf
          previousState = sgx(id)\state
          ; update knob position
          sgx_SetScrollPos(id, scrollpos)
          sgx(id)\state = state
          ; prepare event triggering
          If sgx(id)\state <> previousState
            AddElement(sgx_pendingEvents())
            sgx_pendingEvents()\id = id
            sgx_pendingEvents()\changed = sgx(id)\state - previousState
          EndIf
        EndIf
        
        ; TOGGLEBUTTONS, CHECKBOXES
      Case #sgxTypeButtonToggle, #sgxTypeCheckbox
        
        If state >= 1
          state = 1
        Else
          state = 0
        EndIf
        
        If handleRadioGroups
          
          ; get possibly attached group
          groupId = sgxGetGroup(id)
          If groupId = -1 ; no group
            
            ; set state
            previousState = sgx(id)\state
            sgx(id)\state = state
            
            ; set 'changed'
            If sgx(id)\state <> previousState
              ; add a pending 'changed' event or add it to the list passed by sgxExamine
              If *changed
                AddElement(*changed\list_())
                *changed\list_() = id
              Else
                AddElement(sgx_pendingEvents())
                sgx_pendingEvents()\id = id
                sgx_pendingEvents()\changed = 1
              EndIf
            EndIf
            
          ElseIf groupId >= 0
            ForEach sgxGroups()
              If sgxGroups()\groupID = groupId
                previousState = sgx(sgxGroups()\id)\state
                ; set state
                If sgxGroups()\id = id
                  sgx(sgxGroups()\id)\state = state   ; our element
                Else
                  sgx(sgxGroups()\id)\state = state!1 ; other elements
                EndIf
                If previousState <> sgx(sgxGroups()\id)\state
                  ; add a pending 'changed' event or add it to the list passed by sgxExamine
                  If *changed
                    AddElement(*changed\list_())
                    *changed\list_() = sgxGroups()\id
                  Else
                    AddElement(sgx_pendingEvents())
                    sgx_pendingEvents()\id = sgxGroups()\id
                    sgx_pendingEvents()\changed = 1
                  EndIf
                EndIf
              EndIf
            Next
          EndIf
        Else
          ; only set element's state but do not modify other group members
          
          ; set state
          previousState = sgx(id)\state
          sgx(id)\state = state
          
          ; set 'changed'
          If sgx(id)\state <> previousState
            ; add a pending 'changed' event or add it to the list passed by sgxExamine
            If *changed
              AddElement(*changed\list_())
              *changed\list_() = id
            Else
              AddElement(sgx_pendingEvents())
              sgx_pendingEvents()\id = id
              sgx_pendingEvents()\changed = 1
            EndIf
          EndIf
        EndIf
        
      ; SPRITEGADGET
    Case #sgxTypeSpriteGadget
      previousState = sgx(id)\state
      ; spritegadget's state is a sprite number
      If IsSprite(state)
        sgx(id)\w = SpriteWidth(state)
        sgx(id)\h = SpriteHeight(state)
        sgx(id)\state = state
        sgx(id)\w2 = sgx(id)\w ; - not really needed but thats the expected default
        sgx(id)\h2 = sgx(id)\h ; /
      ElseIf state=0
        sgx(id)\w = 0
        sgx(id)\h = 0
        sgx(id)\state = 0
        sgx(id)\w2 = sgx(id)\w ; - not really needed but thats the expected default
        sgx(id)\h2 = sgx(id)\h ; /
      Else
        ; no change
      EndIf
      ; prepare event triggering
      If sgx(id)\state <> previousState
        AddElement(sgx_pendingEvents())
        sgx_pendingEvents()\id = id
        sgx_pendingEvents()\changed = 1
      EndIf
      
      ; COMBO
    Case #sgxTypeCombo
      previousState = sgx(id)\state
      If state >= 1 And state <= (CountString(sgx(id)\text,#LF$) + 1)
        sgx(id)\state = state
      EndIf
      ; prepare event triggering
      If sgx(id)\state <> previousState
        AddElement(sgx_pendingEvents())
        sgx_pendingEvents()\id = id
        sgx_pendingEvents()\changed = 1
        sgxRefresh(id)
      EndIf
      
      ; OTHER TYPES
    Default
      ;previousState = sgx(id)\state
      ;sgx(id)\state = state
      ;If sgx(id)\state <> previousState
      ;AddElement(sgx_pendingEvents())
      ;sgx_pendingEvents()\id = id
      ;sgx_pendingEvents()\changed = 1
      ;EndIf
    EndSelect
    
  EndIf
EndProcedure


;** sgx_setParentsHovered
;* makes all parents of the element up to the first window hover. _
;* this includes tables elements and it stops with the window type element.
;** .id : ID of the sgx element whichs parents are to be set hovered.
Procedure sgx_setParentWindowHovered(id)
  Static parent
  parent = sgx(id)\parent
  While parent <> -1
    sgx(parent)\hover = 1
    ; stop when first window reached
    If sgx(id)\type = #sgxTypeWin
      Break
    EndIf
    parent = sgx(parent)\parent
  Wend
EndProcedure


;** sgxSetEmsContainer
;* tell sgx about your 'ems' variable.
;* since it's likely that you've got already a variable holding some 'ElapsedMilliseconds()'-like value, _
;* you can let sgx access that data. usefull if you have better timing resolution. otherwise if you don't call this procedure then sgx will inquire PB's ElapsedMilliseconds() by itself (default). _
;* you need to call that procedure once only.
;** .*emsContainer : a pointer to your long-variable (use @).
Procedure sgxSetEmsContainer(*emsContainer.Integer)
  *sgx_emsContainer = *emsContainer
EndProcedure


;** sgxSetDesign
;* set the design for coming creations of new sgx elements, or change the design of an sgx element.
;** .*design : pointer to a loaded design (return value of <a href=#f_sgxloaddesign>sgxLoadDesign</a> or one of the sgxDesign() list elements).
;** .id      : per default (-1), the from now on used design is set to *design. if an ID is passed, only the design of the sgx element is changed wich takes effect with the next element refresh which is not done automatically.
Procedure sgxSetDesign(*design.sgxS_Design, id=-1)
  If *design
    If id=-1
      *sgx_CurrentDesign = *design
    ElseIf sgxInBounds(id) And sgx(id)
      sgx(id)\design = *design
    EndIf
  EndIf
EndProcedure


;** sgxSetAlpha
;* set the alpha value for coming creations of new sgx elements (default alpha is 255, no transparency), or change the alpha value of an sgx element.
;** .alpha     : alpha value in the range of 0 (invisible) to 255 (fully opaque / no tranparency)
;** .id        : if ignored (default/-1), the from now on used default value is set to alpha. if an ID is passed, only the alpha value of the sgx element is changed. no refresh of that element is necessary, since the value is only used for display.
;** .recursive : #False per default. if set to #True, the alpha value of the childs of the element will also be changed unless they are windows.
Procedure sgxSetAlpha(alpha, id=-1, recursive=#False)
  If alpha < 0
    alpha = 0
  ElseIf alpha > 255
    alpha = 255
  EndIf
  If id=-1
    sgx_defaultAlpha = alpha
  ElseIf sgxInBounds(id) And sgx(id)
    sgx(id)\alpha = alpha
    If recursive And sgx(id)\hasChilds
      sgx_llIterator(Protected *it, sgx(id)\treeElem\node)
        If sgx(*it\id)\type <> #sgxTypeWin
          sgxSetAlpha(alpha, *it\id, #True)
        EndIf
      sgx_llNext(*it)
    EndIf
  EndIf
EndProcedure


;** sgxCell
;* use this macro to access the structure of your sgx elements if they are cells of a table and you want to access them via their position in the table. you can also access them the normal way via <a href=#f_sgx>sgx</a> though. _
;** .table : ID of an sgx table element (#sgxTypeTable)
;** .i     : column (starting with 0)
;** .k     : line (starting with 0)
Macro sgxCell(table, i, k)
  sgx( sgxCellId(table, i, k) )
EndMacro


;** sgxCellId
;* returns the ID of a table-cell, or 0 for empty cells or if it fails, which happens if table is not a valid sgx table element or if the coordinates are out of the table's dimensions.
;** .table : ID of an sgx table element (#sgxTypeTable)
;** .i     : column (starting with 0)
;** .k     : line (starting with 0)
Procedure sgxCellId(table, i, k)
  Static offset, *p
  If sgx(table)  And  sgx(table)\type = #sgxTypeTable
    If i>=0 And i<sgx(table)\table\w And k>=0 And k<sgx(table)\table\h
      ; note: gives an 'too complex expression' error if written as a one-liner
      offset = (i + k*sgx(table)\table\w) * SizeOf(Long)
      *p = sgx(table)\table\cells + offset
      ProcedureReturn PeekL( *p )
    EndIf
  EndIf
  ProcedureReturn 0
EndProcedure




;** sgxCellAssign
;* assigns an sgx element to a cell of a table or removes it. that table must either be the current parent or must be specified by parameter. the element will be removed from its current parent's child list and becomes a child of the table. it returns the same ID as passed, or 0 if assignment failed. it fails if the table is not a valid sgx table element, or if i/k are out of the bounds of the table's columns/lines. _
;* it's recommended to create and assign the table's child elements between the table creation with <a href=#f_sgxtable>sgxTable</a> and it's associated call of <a href=#f_sgxcloselevel>sgxCloseLevel</a>. since table cells and their assigned elements can influence each other's dimensions, they are all refreshed once with the call of sgxCloseLevel. but it's generally possible to create the childs before or after and only assign them during the creation of the table or later, though there might happen redundant double refreshing of elements. _
;* if an id of 0 is specified, the cell will be cleared and becomes empty. in any case a possibly already assigned element at that position will be removed and freed. _
;* _
;* sgxCellAssign should be used in one of the following ways: _
;*  _
;* table creation -> child creation and assignment -> parent level closing: _
;* <pre> 
;* t=sgxTable(-1, 10,10, 4,4, 6) _
;* <span></span>  b=sgxButton(-1, 4,4, 100,20, "button") _
;* <span></span>  sgxCellAssign(0,0, b) _
;* sgxCloseLevel() _
;* </pre> 
;* or if you need to create childs later then like this.. _
;* table creation and parent level closing -> child creation and assignment with table parameter -> table refresh _
;* <pre> 
;* t=sgxTable(-1, 10,10, 4,4, 6) _
;* sgxCloseLevel() _
;* b=sgxButton(-1, 4,4, 100,20, "button") _
;* sgxCellAssign(0,0, b, t) ; <- table parameter specified _
;* sgxRefresh(t) _
;* </pre> 
;* ..or like this.. _
;*   table creation and parent level closing -> child creation -> setting the current parent -> cell assignment -> parent level closing _
;* <pre> 
;* t=sgxTable(-1, 10,10, 4,4, 6) _
;* sgxCloseLevel() _
;* b=sgxButton(-1, 4,4, 100,20, "button") _
;* sgxSetCurrentParent(t) _
;* <span></span>  sgxCellAssign(0,0, b) _
;* sgxCloseLevel() _
;* </pre> 
;*
;** .i  : column. (starting with 0)
;** .k  : line (starting with 0)
;** .id : ID of a valid and existing sgx element or 0 if you want to clear the cell. the x/y-position of that element will be overwritten according to the position in table. the w/h dimensions of the element might be overwritten according to the table style.
;** .table : -1 (default) if the current parent should be used as the table. otherwise specify the id of the table you want to assign to.
Procedure sgxCellAssign(i, k, id, table=-1)
  Static *p, currentCellId
  If table = -1
    table = sgx_CurrentParent
  EndIf
  If table<>-1  And  sgx(table)  And  sgx(table)\type = #sgxTypeTable
    If i>=0 And i<sgx(table)\table\w And k>=0 And k<sgx(table)\table\h
      *p = sgx(table)\table\cells + i*SizeOf(Long) + k*sgx(table)\table\w*SizeOf(Long)
      If sgx(id)
        ; make the element a child of the table
        sgxSetParent(id, table)
        currentCellId = PeekL(*p)
        ; free the old element of the cell, if its not the same
        If id <> currentCellId
          sgxFree(currentCellId)
          ; store the id
          PokeL( *p , id)
        EndIf
      ElseIf id=0
        ; free the old element of the cell, if one has been assigned
        currentCellId = PeekL(*p)
        If sgx(currentCellId)
            sgxFree(currentCellId)
        EndIf
        ; reset the stored id
        PokeL( *p , 0)
      EndIf
      ProcedureReturn id
    Else
      sgx_err("the table (ID="+Str(table)+") does not have that cell (i="+Str(i)+" k="+Str(k)+")")
    EndIf
  EndIf
  ProcedureReturn 0
EndProcedure


;** sgx_ArrangeTable
;* scans the cells of a table to calculate size of columns, rows as well as the final table's size and may overwrite
;* cell element positions and sizes according to the table style but does not refresh elements. _
;** .id : a valid sgx table element id.
Procedure sgx_ArrangeTable(id) ; valid data asumed! no checks
  Static i, k, cellid, cellw, cellh, temp, *tmp
  Static wColumn, hLine, currentW, currentH, x
  
  ; we will add each colum's width to this to get the full table width
  currentW = sgx(id)\margin
  
  ; foreach colum go through all column cells/lines to get max column width
  For i=0 To sgx(id)\table\w-1
    wColumn=0
    For k=0 To sgx(id)\table\h-1
      cellid = sgxCellId(id,i,k)
      If sgx(cellid)
        
        If sgx(cellid)\type = #sgxTypeCheckbox
          cellw = sgx(cellid)\w2
        Else
          cellw = sgx(cellid)\w
        EndIf
        
        ; just use cell width if cell element is currently resized manually
        If cellid = sgx_resizing  And  sgx(id)\style & #sgxStyleFitCellW
          wColumn = cellw
          Break
        ; get max column width
        ElseIf cellw>wColumn
          wColumn = cellw
        EndIf
        
      EndIf
    Next
    
    For k=0 To sgx(id)\table\h-1 ; (reusing k here is not a problem)
      cellid = sgxCellId(id,i,k)
      If sgx(cellid)
        
        x = currentW
        If sgx(cellid)\type = #sgxTypeCheckbox And sgx(cellid)\textalign = #sgxAlignCheckboxTextLeft
          ; get position of knob, aligned to right cell edge (colwidth - knobwidth)
          x = currentW + ( (sgx(id)\margin + wColumn) - (sgx(id)\margin + sgx(cellid)\w) )
        EndIf
        
        ; positioning cell element x (y ignored for now)
        sgxMove(cellid, x, sgx(cellid)\yToParent)
        
      EndIf
    Next
    
    If wColumn
      currentW + sgx(id)\margin + wColumn + sgx(id)\margin
      
      ; store current x for later vertical grid drawing
      PokeL( sgx(id)\table\gridx + i*SizeOf(Long), currentW - sgx(id)\margin)
      
      ; overwrite cell element width
      If sgx(id)\style & #sgxStyleFitCellW
        For k=0 To sgx(id)\table\h-1 ; (reusing k here is not a problem)
          cellid = sgxCellId(id,i,k)
          If sgx(cellid)
            If sgx(cellid)\type & (#sgxTypeScrollbarVer | #sgxTypeTrackbarVer)
              ; don't change with of vertical scrollbars/trackbars
            ElseIf sgx(cellid)\type = #sgxTypeCheckbox
              ; don't change with of checkboxes (they are sized by their label; and their knob size should not change)
            ElseIf sgx(cellid)\type = #sgxTypeText And sgx(cellid)\origW = -1
              ; don't change with of text elements if they have autowidth
            Else
              sgx(cellid)\w = wColumn
              ;sgxRefresh(cellid) ; (done later since we still might overwrite cell h)
            EndIf
          EndIf
        Next
      EndIf
    Else
      ; store x=0 to skip this vertical grid line drawing later if column is empty
      PokeL( sgx(id)\table\gridx + i*SizeOf(Long), 0 )
    EndIf
  Next
  
  ; we will add each line's height to this to get the full table height
  currentH = sgx(id)\margin
  
  ; foreach row go through all row cells to get max row height
  For k=0 To sgx(id)\table\h-1
    hLine=0
    For i=0 To sgx(id)\table\w-1
      cellid = sgxCellId(id,i,k)
      If sgx(cellid)
        
        If sgx(cellid)\type = #sgxTypeCheckbox
          cellh = sgx(cellid)\h2
        Else
          cellh = sgx(cellid)\h
        EndIf
        
        ; positioning cell element y (x ignored since we've set that already)
        sgxMove(cellid, sgx(cellid)\xToParent, currentH)
        
        ; just use cell height if cell element is currently resized manually
        If cellid = sgx_resizing  And  sgx(id)\style & #sgxStyleFitCellH
          hLine = cellh
          Break
        ; get max column width
        ElseIf cellh>hLine
          hLine = cellh
        EndIf
      EndIf
    Next
    
    If hLine
      currentH + sgx(id)\margin + hLine + sgx(id)\margin
      
      ; store current y for later horizontal grid drawing
      PokeL( sgx(id)\table\gridy + k*SizeOf(Long), currentH - sgx(id)\margin)
      
      ; overwrite cell element height
      If sgx(id)\style & #sgxStyleFitCellH
        For i=0 To sgx(id)\table\w-1 ; (reusing i here is not a problem)
          cellid = sgxCellId(id,i,k)
          If sgx(cellid)
            If sgx(cellid)\type & (#sgxTypeScrollbarHor | #sgxTypeTrackbarHor)
              ; don't change height of horizontal scrollbars/trackbars
            ElseIf sgx(cellid)\type = #sgxTypeCheckbox
              ; don't change height of checkboxes (they are sized by their label; and their knob size should not change)
            ElseIf sgx(cellid)\type = #sgxTypeText And sgx(cellid)\origH = -1
              ; don't change height of text elements if they have autoheight
            Else
              sgx(cellid)\h = hLine
              ;sgxRefresh(cellid) ; (done later)
            EndIf
          EndIf
        Next
      EndIf
    Else
      ; store y=0 to skip this horizontal grid line drawing later if row is empty
      PokeL( sgx(id)\table\gridy + k*SizeOf(Long), 0 )
    EndIf
  Next
  
  ; set table size to the sum of column widths / row heights
  sgx(id)\w = currentW - sgx(id)\margin
  If sgx(id)\w < 1
    sgx(id)\w = 1
  EndIf
  sgx(id)\h = currentH - sgx(id)\margin
  If sgx(id)\h < 1
    sgx(id)\h = 1
  EndIf
EndProcedure


;** sgx_textWidthLF
;* returns the width of the longest line in the text, that is to say the width of the complete textblock. _
;* must be called inside a StartDrawing()/StopDrawing() block.
;** .text : (multiline) text. use #LF$ / Chr(10) for linebreaks.
Procedure sgx_textWidthLF(text.s)
  Protected max,i,tw,maxtw
  max = CountString(text,#LF$)+1
  For i=1 To max
    tw = TextWidth(StringField(text,i,#LF$))
    If tw > maxtw
      maxtw = tw
    EndIf
  Next
  ProcedureReturn maxtw
EndProcedure


; [next line resets the jaPBDoc documentation target]
;** 
Global sgx_drawTextLF_EndX ;* x-position where the last call of <a href=#f_sgx_drawtextlf>sgx_drawTextLF</a> has finished (right edge of drawn text).
Global sgx_drawTextLF_EndY ;* y-position where the last call of <a href=#f_sgx_drawtextlf>sgx_drawTextLF</a> has finished (top edge of drawn text).

;** sgx_drawTextLF
;* draws multiline text to the current drawing output. _
;* the variables sgx_drawTextLF_EndX and sgx_drawTextLF_EndY can be used to get the position where the drawing finished in case you want to continue drawing some text later.
;** .x               : starting x-position.
;** .y               : starting y-position.
;** .text            : (multiline) text to be drawn.
;** .color           : textcolor.
;** .xWrapTo         : x-position of further drawing after occurrence of linebreaks. per default (-1) the specified 'x' parameter is used for this.
;** .lineSeperator$  : the string that is used in 'text' as line seperator (default value is #LF$ / Chr(10))
;** .textAlign       : one of these values (aligments that need a width will use the longest line for that): _
;*                    #sgxAlignTextLeft _
;*                    #sgxAlignTextRight _
;*                    #sgxAlignTextCenter _
;*                    #sgxAlignTextJustifySpaces _
;*                    #sgxAlignTextJustifyCharacters _
Procedure sgx_drawTextLF(x, y, text.s, color, xWrapTo=-1, lineSeperator$=#LF$, textAlign=#sgxAlignTextLeft)
  Static yPitch
  Static xPitch
  Static line.s
  Static l, nbLines, c, lineLen, *c.Character, charWidth.f, xf.f
  Static maxLinewWidth.f, lineWidth, lineWidthNoSpaces, nbSpaces.f, spaceWidth.f
  
  Select textAlign
    Case #sgxAlignTextRight, #sgxAlignTextCenter, #sgxAlignTextJustifySpaces, #sgxAlignTextJustifyCharacters
      ; get longest line width if needed
      maxLinewWidth = sgx_textWidthLF(text)
  EndSelect
  If xWrapTo=-1
    xWrapTo=x
  EndIf
  xPitch = x
  yPitch = TextHeight("X")
  nbLines = CountString(text,lineSeperator$)
  For l=0 To nbLines
    line = StringField(text,l+1,lineSeperator$)
    lineWidth = 0;
    
    ; right
    If textAlign = #sgxAlignTextRight
      lineWidth = TextWidth(line)
      xPitch = DrawText( x+maxLinewWidth-lineWidth, y+l*yPitch, line, color)
      
    ; center
    ElseIf textAlign = #sgxAlignTextCenter
      lineWidth = TextWidth(line)
      xPitch = DrawText( x+maxLinewWidth/2-lineWidth/2, y+l*yPitch, line, color)
      
    ; justify (spaces)
    ElseIf textAlign = #sgxAlignTextJustifySpaces
      ; auto word wrap may have put a newline after a space
      line = RTrim(line)
      
      lineWidth = TextWidth(line)
      lineLen = Len(Line)
      *c = @line
      ; get factor to stretch/shrink current line
      xf = maxLinewWidth/lineWidth
      charWidth = 0
      ; only before last line
      If l<nbLines
        
        ; get line width without spaces
        lineWidthNoSpaces = TextWidth(ReplaceString(line," ", ""))
        nbSpaces = CountString(Line, " ")
        ; get necessary width per space
        spaceWidth = (maxLinewWidth - lineWidthNoSpaces) / nbSpaces
        
        For c=0 To lineLen-1
          If (*c\c = 32)
            ; draw space and add translated width
            xPitch = DrawText( x + spaceWidth, y+l*yPitch, Chr(*c\c), color)
            xPitch = x + spaceWidth
            charWidth + spaceWidth
          Else
            ; draw char and add real width
            xPitch = DrawText( x + charWidth , y+l*yPitch, Chr(*c\c), color)
            charWidth + TextWidth(Chr(*c\c))
          EndIf
          *c + SizeOf(Character)
        Next
      Else
        ; no hassle with last line
        xPitch = DrawText( x, y+l*yPitch, line, color)
      EndIf
      
    ; justify (chars)
    ElseIf textAlign = #sgxAlignTextJustifyCharacters
      ; auto word wrap may have put a newline after a space
      line = RTrim(line)
      
      lineWidth = TextWidth(line)
      lineLen = Len(Line)
      *c = @line
      ; get factor to stretch/shrink current line
      xf = maxLinewWidth/lineWidth
      charWidth = 0
      ; only before last line
      If l<nbLines
        For c=0 To lineLen-1
          ; draw current char at translated x position
          xPitch = DrawText( x + charWidth * xf , y+l*yPitch, Chr(*c\c), color)
          charWidth + TextWidth(Chr(*c\c))
          *c + SizeOf(Character)
        Next
      Else
        ; no hassle with last line
        xPitch = DrawText( x, y+l*yPitch, line, color)
      EndIf
      
    ; left
    Else
      xPitch = DrawText( x, y+l*yPitch, line, color)
      If l=0
        x=xWrapTo
      EndIf
    EndIf

  Next
  sgx_drawTextLF_EndX = xPitch
  sgx_drawTextLF_EndY = y+(l-1)*yPitch
EndProcedure































;- *** COMMON ***




;** sgx_max
;* returns 'a' if its greater that 'b', otherwise returns 'b'.
;** .a : an integer value
;** .b : an integer value
Procedure sgx_max(a, b)
  If a>b
    ProcedureReturn a
  Else
    ProcedureReturn b
  EndIf
EndProcedure


;** sgx_fade
;* returns a new color with different brightness derived from 'color' according to the value of 'fade'. the alpha will not change.
;** .color : some RGBA value
;** .fade  :  0: no change _
;*           negative value: darken (value -1000 = black) _
;*           positive value: brighten (value 1000 = white) _
Procedure sgx_fade(color, fade)
  Protected r
  Protected g
  Protected b
  Protected a
  If fade<0
    If fade<-1000 : fade=0
    Else          : fade+1000
    EndIf
    If fade>1000 : fade=1000 : EndIf
    r= (color & $ff) *fade/1000
    If r>255 : r=255 : EndIf
    g= ((color & $ff00) >>8) *fade/1000
    If g>255 : g=255 : EndIf
    b= ((color & $ff0000) >>16) *fade/1000
    If b>255 : b=255 : EndIf
    ;a= ((color & $ff000000) >>24) *fade/1000
    ;If a>255 : a=255 : EndIf
    a= (color & $ff000000)
    ProcedureReturn ( (r) | (g<<8) | (b<<16) | (a) )
  ElseIf fade>0
    If fade>1000 : fade=0
    Else         : fade=1000-fade
    EndIf
    r= 255- ( 255-(color & $ff) ) *fade/1000
    g= 255- ( 255-((color & $ff00) >>8) ) *fade/1000
    b= 255- ( 255-((color & $ff0000) >>16) ) *fade/1000
    ;a= 255- ( 255-((color & $ff000000) >>24) ) *fade/1000
    a= (color & $ff000000)
    ProcedureReturn ( (r) | (g<<8) | (b<<16) | (a) )
  Else;[if fade=0]
    ProcedureReturn color
  EndIf
EndProcedure


; Procedure sgx_debugColorP(text.s, x,y)
;   Debug text + ": " + Red(Point(x,y)) + ","+Green(Point(x,y))+","+Blue(Point(x,y))+","+Alpha(Point(x,y))
; EndProcedure


; Procedure sgx_debugColorC(text.s, color)
;   Debug text + ": " + Red(color) + ","+Green(color)+","+Blue(color)+","+Alpha(color)
; EndProcedure


; Procedure sgx_debugColorSD(text.s, img, x,y)
;   StartDrawing(ImageOutput(img))
;     DrawingMode(#PB_2DDrawing_AllChannels)
;     Debug text + ": " + Red(Point(x,y)) + ","+Green(Point(x,y))+","+Blue(Point(x,y))+","+Alpha(Point(x,y))
;   StopDrawing()
; EndProcedure








; *** SPECIAL ***




;{ --- defines

;** s sgx_S_key
;* used per key in an keyboard layout (<a href=#s_sgx_s_keyboardlayout>sgx_S_keyboardLayout</a>)
Structure sgx_S_key
  pbid.i         ;* a PB key like #PB_Key_Up or #PB_Key_Escape
  chr.s[3]       ;* the characters that should result from the key per key combination: 0 = normal, 1 = shift, 2 = alt-gr
  timer.i        ;* individual timer per key for keystroke delays
  delaySwitch.i  ;* a switch between first keystroke delay and continuous keypush interval
EndStructure

;** s sgx_S_keyboardLayout
;* a keyboard layout consisting of key definitions for all the supported keys
Structure sgx_S_keyboardLayout
  key.sgx_S_key[101]  ;* array of key definitions
EndStructure

; [next line resets the jaPBDoc documentation target]
;** 

Global Dim sgx_keyLay.sgx_S_keyboardLayout(1)  ;* array of keyboard layouts
Global sgx_keyLayout=0                  ;* currently used keyboard layout. can be set via <a href=#f_sgxsetkeyboardlayout>sgxSetKeyboardLayout</a>
Global sgx_keystrokeDelay_1=280         ;* the keystroke delay after a first key-push. can be set via <a href=#f_sgxsetkeyboardlayout>sgxSetKeyboardLayout</a>
Global sgx_keystrokeDelay_2=40          ;* the keystroke delay for continuous key-push. can be set via <a href=#f_sgxsetkeyboardlayout>sgxSetKeyboardLayout</a>
Global sgx_keyboardEdit_lastTextPos     ;* see <a href=#f_sgx_keyboardedit>sgx_keyboardEdit</a>
Global sgx_keyboardEdit_TextModified    ;* see <a href=#f_sgx_keyboardedit>sgx_keyboardEdit</a>

;}
;  ----------


; there seems to be no way to get the
; pipe symbol/key triggered with the
; pb keyboard lib with a german keyboard


;{ ---------- define table 0 - qwerty / us ???
;sgx_keyLay(0)         pbid                       ---    chr[0] / mode 0 / normal       ---  chr[1] / mode 1 / shift          ---  chr[2] / mode 2 / alt-gr

sgx_keyLay(0)\key[000]\pbid=#PB_Key_1             :  sgx_keyLay(0)\key[000]\chr[0] = "1"  :  sgx_keyLay(0)\key[000]\chr[1] = "!"  :  sgx_keyLay(0)\key[000]\chr[2] = ""
sgx_keyLay(0)\key[001]\pbid=#PB_Key_2             :  sgx_keyLay(0)\key[001]\chr[0] = "2"  :  sgx_keyLay(0)\key[001]\chr[1] = "@"  :  sgx_keyLay(0)\key[001]\chr[2] = ""
sgx_keyLay(0)\key[002]\pbid=#PB_Key_3             :  sgx_keyLay(0)\key[002]\chr[0] = "3"  :  sgx_keyLay(0)\key[002]\chr[1] = "#"  :  sgx_keyLay(0)\key[002]\chr[2] = ""
sgx_keyLay(0)\key[003]\pbid=#PB_Key_4             :  sgx_keyLay(0)\key[003]\chr[0] = "4"  :  sgx_keyLay(0)\key[003]\chr[1] = "$"  :  sgx_keyLay(0)\key[003]\chr[2] = ""
sgx_keyLay(0)\key[004]\pbid=#PB_Key_5             :  sgx_keyLay(0)\key[004]\chr[0] = "5"  :  sgx_keyLay(0)\key[004]\chr[1] = "%"  :  sgx_keyLay(0)\key[004]\chr[2] = ""
sgx_keyLay(0)\key[005]\pbid=#PB_Key_6             :  sgx_keyLay(0)\key[005]\chr[0] = "6"  :  sgx_keyLay(0)\key[005]\chr[1] = "^"  :  sgx_keyLay(0)\key[005]\chr[2] = ""
sgx_keyLay(0)\key[006]\pbid=#PB_Key_7             :  sgx_keyLay(0)\key[006]\chr[0] = "7"  :  sgx_keyLay(0)\key[006]\chr[1] = "&"  :  sgx_keyLay(0)\key[006]\chr[2] = ""
sgx_keyLay(0)\key[007]\pbid=#PB_Key_8             :  sgx_keyLay(0)\key[007]\chr[0] = "8"  :  sgx_keyLay(0)\key[007]\chr[1] = "*"  :  sgx_keyLay(0)\key[007]\chr[2] = ""
sgx_keyLay(0)\key[008]\pbid=#PB_Key_9             :  sgx_keyLay(0)\key[008]\chr[0] = "9"  :  sgx_keyLay(0)\key[008]\chr[1] = "("  :  sgx_keyLay(0)\key[008]\chr[2] = ""
sgx_keyLay(0)\key[009]\pbid=#PB_Key_0             :  sgx_keyLay(0)\key[009]\chr[0] = "0"  :  sgx_keyLay(0)\key[009]\chr[1] = ")"  :  sgx_keyLay(0)\key[009]\chr[2] = ""

sgx_keyLay(0)\key[010]\pbid=#PB_Key_A             :  sgx_keyLay(0)\key[010]\chr[0] = "a"  :  sgx_keyLay(0)\key[010]\chr[1] = "A"  :  sgx_keyLay(0)\key[010]\chr[2] = ""
sgx_keyLay(0)\key[011]\pbid=#PB_Key_B             :  sgx_keyLay(0)\key[011]\chr[0] = "b"  :  sgx_keyLay(0)\key[011]\chr[1] = "B"  :  sgx_keyLay(0)\key[011]\chr[2] = ""
sgx_keyLay(0)\key[012]\pbid=#PB_Key_C             :  sgx_keyLay(0)\key[012]\chr[0] = "c"  :  sgx_keyLay(0)\key[012]\chr[1] = "C"  :  sgx_keyLay(0)\key[012]\chr[2] = ""
sgx_keyLay(0)\key[013]\pbid=#PB_Key_D             :  sgx_keyLay(0)\key[013]\chr[0] = "d"  :  sgx_keyLay(0)\key[013]\chr[1] = "D"  :  sgx_keyLay(0)\key[013]\chr[2] = ""
sgx_keyLay(0)\key[014]\pbid=#PB_Key_E             :  sgx_keyLay(0)\key[014]\chr[0] = "e"  :  sgx_keyLay(0)\key[014]\chr[1] = "E"  :  sgx_keyLay(0)\key[014]\chr[2] = ""
sgx_keyLay(0)\key[015]\pbid=#PB_Key_F             :  sgx_keyLay(0)\key[015]\chr[0] = "f"  :  sgx_keyLay(0)\key[015]\chr[1] = "F"  :  sgx_keyLay(0)\key[015]\chr[2] = ""
sgx_keyLay(0)\key[016]\pbid=#PB_Key_G             :  sgx_keyLay(0)\key[016]\chr[0] = "g"  :  sgx_keyLay(0)\key[016]\chr[1] = "G"  :  sgx_keyLay(0)\key[016]\chr[2] = ""
sgx_keyLay(0)\key[017]\pbid=#PB_Key_H             :  sgx_keyLay(0)\key[017]\chr[0] = "h"  :  sgx_keyLay(0)\key[017]\chr[1] = "H"  :  sgx_keyLay(0)\key[017]\chr[2] = ""
sgx_keyLay(0)\key[018]\pbid=#PB_Key_I             :  sgx_keyLay(0)\key[018]\chr[0] = "i"  :  sgx_keyLay(0)\key[018]\chr[1] = "I"  :  sgx_keyLay(0)\key[018]\chr[2] = ""
sgx_keyLay(0)\key[019]\pbid=#PB_Key_J             :  sgx_keyLay(0)\key[019]\chr[0] = "j"  :  sgx_keyLay(0)\key[019]\chr[1] = "J"  :  sgx_keyLay(0)\key[019]\chr[2] = ""
sgx_keyLay(0)\key[020]\pbid=#PB_Key_K             :  sgx_keyLay(0)\key[020]\chr[0] = "k"  :  sgx_keyLay(0)\key[020]\chr[1] = "K"  :  sgx_keyLay(0)\key[020]\chr[2] = ""
sgx_keyLay(0)\key[021]\pbid=#PB_Key_L             :  sgx_keyLay(0)\key[021]\chr[0] = "l"  :  sgx_keyLay(0)\key[021]\chr[1] = "L"  :  sgx_keyLay(0)\key[021]\chr[2] = ""
sgx_keyLay(0)\key[022]\pbid=#PB_Key_M             :  sgx_keyLay(0)\key[022]\chr[0] = "m"  :  sgx_keyLay(0)\key[022]\chr[1] = "M"  :  sgx_keyLay(0)\key[022]\chr[2] = ""
sgx_keyLay(0)\key[023]\pbid=#PB_Key_N             :  sgx_keyLay(0)\key[023]\chr[0] = "n"  :  sgx_keyLay(0)\key[023]\chr[1] = "N"  :  sgx_keyLay(0)\key[023]\chr[2] = ""
sgx_keyLay(0)\key[024]\pbid=#PB_Key_O             :  sgx_keyLay(0)\key[024]\chr[0] = "o"  :  sgx_keyLay(0)\key[024]\chr[1] = "O"  :  sgx_keyLay(0)\key[024]\chr[2] = ""
sgx_keyLay(0)\key[025]\pbid=#PB_Key_P             :  sgx_keyLay(0)\key[025]\chr[0] = "p"  :  sgx_keyLay(0)\key[025]\chr[1] = "P"  :  sgx_keyLay(0)\key[025]\chr[2] = ""
sgx_keyLay(0)\key[026]\pbid=#PB_Key_Q             :  sgx_keyLay(0)\key[026]\chr[0] = "q"  :  sgx_keyLay(0)\key[026]\chr[1] = "Q"  :  sgx_keyLay(0)\key[026]\chr[2] = ""
sgx_keyLay(0)\key[027]\pbid=#PB_Key_R             :  sgx_keyLay(0)\key[027]\chr[0] = "r"  :  sgx_keyLay(0)\key[027]\chr[1] = "R"  :  sgx_keyLay(0)\key[027]\chr[2] = ""
sgx_keyLay(0)\key[028]\pbid=#PB_Key_S             :  sgx_keyLay(0)\key[028]\chr[0] = "s"  :  sgx_keyLay(0)\key[028]\chr[1] = "S"  :  sgx_keyLay(0)\key[028]\chr[2] = ""
sgx_keyLay(0)\key[029]\pbid=#PB_Key_T             :  sgx_keyLay(0)\key[029]\chr[0] = "t"  :  sgx_keyLay(0)\key[029]\chr[1] = "T"  :  sgx_keyLay(0)\key[029]\chr[2] = ""
sgx_keyLay(0)\key[030]\pbid=#PB_Key_U             :  sgx_keyLay(0)\key[030]\chr[0] = "u"  :  sgx_keyLay(0)\key[030]\chr[1] = "U"  :  sgx_keyLay(0)\key[030]\chr[2] = ""
sgx_keyLay(0)\key[031]\pbid=#PB_Key_V             :  sgx_keyLay(0)\key[031]\chr[0] = "v"  :  sgx_keyLay(0)\key[031]\chr[1] = "V"  :  sgx_keyLay(0)\key[031]\chr[2] = ""
sgx_keyLay(0)\key[032]\pbid=#PB_Key_W             :  sgx_keyLay(0)\key[032]\chr[0] = "w"  :  sgx_keyLay(0)\key[032]\chr[1] = "W"  :  sgx_keyLay(0)\key[032]\chr[2] = ""
sgx_keyLay(0)\key[033]\pbid=#PB_Key_X             :  sgx_keyLay(0)\key[033]\chr[0] = "x"  :  sgx_keyLay(0)\key[033]\chr[1] = "X"  :  sgx_keyLay(0)\key[033]\chr[2] = ""
sgx_keyLay(0)\key[034]\pbid=#PB_Key_Y             :  sgx_keyLay(0)\key[034]\chr[0] = "y"  :  sgx_keyLay(0)\key[034]\chr[1] = "Y"  :  sgx_keyLay(0)\key[034]\chr[2] = ""
sgx_keyLay(0)\key[035]\pbid=#PB_Key_Z             :  sgx_keyLay(0)\key[035]\chr[0] = "z"  :  sgx_keyLay(0)\key[035]\chr[1] = "Z"  :  sgx_keyLay(0)\key[035]\chr[2] = ""

sgx_keyLay(0)\key[036]\pbid=#PB_Key_Escape        :  sgx_keyLay(0)\key[036]\chr[0] = ""   :  sgx_keyLay(0)\key[036]\chr[1] = ""   :  sgx_keyLay(0)\key[036]\chr[2] = ""
sgx_keyLay(0)\key[037]\pbid=#PB_Key_Minus         :  sgx_keyLay(0)\key[037]\chr[0] = "-"  :  sgx_keyLay(0)\key[037]\chr[1] = "_"  :  sgx_keyLay(0)\key[037]\chr[2] = ""
sgx_keyLay(0)\key[038]\pbid=#PB_Key_Equals        :  sgx_keyLay(0)\key[038]\chr[0] = "="  :  sgx_keyLay(0)\key[038]\chr[1] = "+"  :  sgx_keyLay(0)\key[038]\chr[2] = ""
sgx_keyLay(0)\key[039]\pbid=#PB_Key_Back          :  sgx_keyLay(0)\key[039]\chr[0] = ""   :  sgx_keyLay(0)\key[039]\chr[1] = ""   :  sgx_keyLay(0)\key[039]\chr[2] = ""
sgx_keyLay(0)\key[040]\pbid=#PB_Key_Tab           :  sgx_keyLay(0)\key[040]\chr[0] = ""   :  sgx_keyLay(0)\key[040]\chr[1] = ""   :  sgx_keyLay(0)\key[040]\chr[2] = ""
sgx_keyLay(0)\key[041]\pbid=#PB_Key_LeftBracket   :  sgx_keyLay(0)\key[041]\chr[0] = "["  :  sgx_keyLay(0)\key[041]\chr[1] = "{"  :  sgx_keyLay(0)\key[041]\chr[2] = ""
sgx_keyLay(0)\key[042]\pbid=#PB_Key_RightBracket  :  sgx_keyLay(0)\key[042]\chr[0] = "]"  :  sgx_keyLay(0)\key[042]\chr[1] = "}"  :  sgx_keyLay(0)\key[042]\chr[2] = ""
sgx_keyLay(0)\key[043]\pbid=#PB_Key_Return        :  sgx_keyLay(0)\key[043]\chr[0] = ""   :  sgx_keyLay(0)\key[043]\chr[1] = ""   :  sgx_keyLay(0)\key[043]\chr[2] = ""
sgx_keyLay(0)\key[044]\pbid=#PB_Key_LeftControl   :  sgx_keyLay(0)\key[044]\chr[0] = ""   :  sgx_keyLay(0)\key[044]\chr[1] = ""   :  sgx_keyLay(0)\key[044]\chr[2] = ""
sgx_keyLay(0)\key[045]\pbid=#PB_Key_SemiColon     :  sgx_keyLay(0)\key[045]\chr[0] = ";"  :  sgx_keyLay(0)\key[045]\chr[1] = ":"  :  sgx_keyLay(0)\key[045]\chr[2] = ""
sgx_keyLay(0)\key[046]\pbid=#PB_Key_Apostrophe    :  sgx_keyLay(0)\key[046]\chr[0] = "'"  :  sgx_keyLay(0)\key[046]\chr[1]=Chr(34):  sgx_keyLay(0)\key[046]\chr[2] = ""
sgx_keyLay(0)\key[047]\pbid=#PB_Key_Grave         :  sgx_keyLay(0)\key[047]\chr[0] = "`"  :  sgx_keyLay(0)\key[047]\chr[1] = "~"  :  sgx_keyLay(0)\key[047]\chr[2] = ""
sgx_keyLay(0)\key[048]\pbid=#PB_Key_LeftShift     :  sgx_keyLay(0)\key[048]\chr[0] = ""   :  sgx_keyLay(0)\key[048]\chr[1] = ""   :  sgx_keyLay(0)\key[048]\chr[2] = ""
sgx_keyLay(0)\key[049]\pbid=#PB_Key_BackSlash     :  sgx_keyLay(0)\key[049]\chr[0] = "\"  :  sgx_keyLay(0)\key[049]\chr[1] = "|"  :  sgx_keyLay(0)\key[049]\chr[2] = ""
sgx_keyLay(0)\key[050]\pbid=#PB_Key_Comma         :  sgx_keyLay(0)\key[050]\chr[0] = ","  :  sgx_keyLay(0)\key[050]\chr[1] = "<"  :  sgx_keyLay(0)\key[050]\chr[2] = ""
sgx_keyLay(0)\key[051]\pbid=#PB_Key_Period        :  sgx_keyLay(0)\key[051]\chr[0] = "."  :  sgx_keyLay(0)\key[051]\chr[1] = ">"  :  sgx_keyLay(0)\key[051]\chr[2] = ""
sgx_keyLay(0)\key[052]\pbid=#PB_Key_Slash         :  sgx_keyLay(0)\key[052]\chr[0] = "/"  :  sgx_keyLay(0)\key[052]\chr[1] = "?"  :  sgx_keyLay(0)\key[052]\chr[2] = ""
sgx_keyLay(0)\key[053]\pbid=#PB_Key_RightShift    :  sgx_keyLay(0)\key[053]\chr[0] = ""   :  sgx_keyLay(0)\key[053]\chr[1] = ""   :  sgx_keyLay(0)\key[053]\chr[2] = ""
sgx_keyLay(0)\key[054]\pbid=#PB_Key_Multiply      :  sgx_keyLay(0)\key[054]\chr[0] = "*"  :  sgx_keyLay(0)\key[054]\chr[1] = "*"  :  sgx_keyLay(0)\key[054]\chr[2] = ""
sgx_keyLay(0)\key[055]\pbid=#PB_Key_LeftAlt       :  sgx_keyLay(0)\key[055]\chr[0] = ""   :  sgx_keyLay(0)\key[055]\chr[1] = ""   :  sgx_keyLay(0)\key[055]\chr[2] = ""
sgx_keyLay(0)\key[056]\pbid=#PB_Key_Space         :  sgx_keyLay(0)\key[056]\chr[0] = " "  :  sgx_keyLay(0)\key[056]\chr[1] = " "  :  sgx_keyLay(0)\key[056]\chr[2] = ""
sgx_keyLay(0)\key[057]\pbid=#PB_Key_Capital       :  sgx_keyLay(0)\key[057]\chr[0] = ""   :  sgx_keyLay(0)\key[057]\chr[1] = ""   :  sgx_keyLay(0)\key[057]\chr[2] = ""

sgx_keyLay(0)\key[058]\pbid=#PB_Key_F1            :  sgx_keyLay(0)\key[058]\chr[0] = ""   :  sgx_keyLay(0)\key[058]\chr[1] = ""   :  sgx_keyLay(0)\key[058]\chr[2] = ""
sgx_keyLay(0)\key[059]\pbid=#PB_Key_F2            :  sgx_keyLay(0)\key[059]\chr[0] = ""   :  sgx_keyLay(0)\key[059]\chr[1] = ""   :  sgx_keyLay(0)\key[059]\chr[2] = ""
sgx_keyLay(0)\key[060]\pbid=#PB_Key_F3            :  sgx_keyLay(0)\key[060]\chr[0] = ""   :  sgx_keyLay(0)\key[060]\chr[1] = ""   :  sgx_keyLay(0)\key[060]\chr[2] = ""
sgx_keyLay(0)\key[061]\pbid=#PB_Key_F4            :  sgx_keyLay(0)\key[061]\chr[0] = ""   :  sgx_keyLay(0)\key[061]\chr[1] = ""   :  sgx_keyLay(0)\key[061]\chr[2] = ""
sgx_keyLay(0)\key[062]\pbid=#PB_Key_F5            :  sgx_keyLay(0)\key[062]\chr[0] = ""   :  sgx_keyLay(0)\key[062]\chr[1] = ""   :  sgx_keyLay(0)\key[062]\chr[2] = ""
sgx_keyLay(0)\key[063]\pbid=#PB_Key_F6            :  sgx_keyLay(0)\key[063]\chr[0] = ""   :  sgx_keyLay(0)\key[063]\chr[1] = ""   :  sgx_keyLay(0)\key[063]\chr[2] = ""
sgx_keyLay(0)\key[064]\pbid=#PB_Key_F7            :  sgx_keyLay(0)\key[064]\chr[0] = ""   :  sgx_keyLay(0)\key[064]\chr[1] = ""   :  sgx_keyLay(0)\key[064]\chr[2] = ""
sgx_keyLay(0)\key[065]\pbid=#PB_Key_F8            :  sgx_keyLay(0)\key[065]\chr[0] = ""   :  sgx_keyLay(0)\key[065]\chr[1] = ""   :  sgx_keyLay(0)\key[065]\chr[2] = ""
sgx_keyLay(0)\key[066]\pbid=#PB_Key_F9            :  sgx_keyLay(0)\key[066]\chr[0] = ""   :  sgx_keyLay(0)\key[066]\chr[1] = ""   :  sgx_keyLay(0)\key[066]\chr[2] = ""
sgx_keyLay(0)\key[067]\pbid=#PB_Key_F10           :  sgx_keyLay(0)\key[067]\chr[0] = ""   :  sgx_keyLay(0)\key[067]\chr[1] = ""   :  sgx_keyLay(0)\key[067]\chr[2] = ""
sgx_keyLay(0)\key[068]\pbid=#PB_Key_F11           :  sgx_keyLay(0)\key[068]\chr[0] = ""   :  sgx_keyLay(0)\key[068]\chr[1] = ""   :  sgx_keyLay(0)\key[068]\chr[2] = ""
sgx_keyLay(0)\key[069]\pbid=#PB_Key_F12           :  sgx_keyLay(0)\key[069]\chr[0] = ""   :  sgx_keyLay(0)\key[069]\chr[1] = ""   :  sgx_keyLay(0)\key[069]\chr[2] = ""

sgx_keyLay(0)\key[070]\pbid=#PB_Key_NumLock       :  sgx_keyLay(0)\key[070]\chr[0] = ""   :  sgx_keyLay(0)\key[070]\chr[1] = ""   :  sgx_keyLay(0)\key[070]\chr[2] = ""
sgx_keyLay(0)\key[071]\pbid=#PB_Key_Scroll        :  sgx_keyLay(0)\key[071]\chr[0] = ""   :  sgx_keyLay(0)\key[071]\chr[1] = ""   :  sgx_keyLay(0)\key[071]\chr[2] = ""
sgx_keyLay(0)\key[072]\pbid=#PB_Key_Pad0          :  sgx_keyLay(0)\key[072]\chr[0] = "0"  :  sgx_keyLay(0)\key[072]\chr[1] = "0"  :  sgx_keyLay(0)\key[072]\chr[2] = ""
sgx_keyLay(0)\key[073]\pbid=#PB_Key_Pad1          :  sgx_keyLay(0)\key[073]\chr[0] = "1"  :  sgx_keyLay(0)\key[073]\chr[1] = "1"  :  sgx_keyLay(0)\key[073]\chr[2] = ""
sgx_keyLay(0)\key[074]\pbid=#PB_Key_Pad2          :  sgx_keyLay(0)\key[074]\chr[0] = "2"  :  sgx_keyLay(0)\key[074]\chr[1] = "2"  :  sgx_keyLay(0)\key[074]\chr[2] = ""
sgx_keyLay(0)\key[075]\pbid=#PB_Key_Pad3          :  sgx_keyLay(0)\key[075]\chr[0] = "3"  :  sgx_keyLay(0)\key[075]\chr[1] = "3"  :  sgx_keyLay(0)\key[075]\chr[2] = ""
sgx_keyLay(0)\key[076]\pbid=#PB_Key_Pad4          :  sgx_keyLay(0)\key[076]\chr[0] = "4"  :  sgx_keyLay(0)\key[076]\chr[1] = "4"  :  sgx_keyLay(0)\key[076]\chr[2] = ""
sgx_keyLay(0)\key[077]\pbid=#PB_Key_Pad5          :  sgx_keyLay(0)\key[077]\chr[0] = "5"  :  sgx_keyLay(0)\key[077]\chr[1] = "5"  :  sgx_keyLay(0)\key[077]\chr[2] = ""
sgx_keyLay(0)\key[078]\pbid=#PB_Key_Pad6          :  sgx_keyLay(0)\key[078]\chr[0] = "6"  :  sgx_keyLay(0)\key[078]\chr[1] = "6"  :  sgx_keyLay(0)\key[078]\chr[2] = ""
sgx_keyLay(0)\key[079]\pbid=#PB_Key_Pad7          :  sgx_keyLay(0)\key[079]\chr[0] = "7"  :  sgx_keyLay(0)\key[079]\chr[1] = "7"  :  sgx_keyLay(0)\key[079]\chr[2] = ""
sgx_keyLay(0)\key[080]\pbid=#PB_Key_Pad8          :  sgx_keyLay(0)\key[080]\chr[0] = "8"  :  sgx_keyLay(0)\key[080]\chr[1] = "8"  :  sgx_keyLay(0)\key[080]\chr[2] = ""
sgx_keyLay(0)\key[081]\pbid=#PB_Key_Pad9          :  sgx_keyLay(0)\key[081]\chr[0] = "9"  :  sgx_keyLay(0)\key[081]\chr[1] = "9"  :  sgx_keyLay(0)\key[081]\chr[2] = ""

sgx_keyLay(0)\key[082]\pbid=#PB_Key_Add           :  sgx_keyLay(0)\key[082]\chr[0] = "+"  :  sgx_keyLay(0)\key[082]\chr[1] = "+"  :  sgx_keyLay(0)\key[082]\chr[2] = ""
sgx_keyLay(0)\key[083]\pbid=#PB_Key_Subtract      :  sgx_keyLay(0)\key[083]\chr[0] = "-"  :  sgx_keyLay(0)\key[083]\chr[1] = "-"  :  sgx_keyLay(0)\key[083]\chr[2] = ""
sgx_keyLay(0)\key[084]\pbid=#PB_Key_Decimal       :  sgx_keyLay(0)\key[084]\chr[0] = "."  :  sgx_keyLay(0)\key[084]\chr[1] = ""   :  sgx_keyLay(0)\key[084]\chr[2] = ""
sgx_keyLay(0)\key[085]\pbid=#PB_Key_PadEnter      :  sgx_keyLay(0)\key[085]\chr[0] = ""   :  sgx_keyLay(0)\key[085]\chr[1] = ""   :  sgx_keyLay(0)\key[085]\chr[2] = ""
sgx_keyLay(0)\key[086]\pbid=#PB_Key_RightControl  :  sgx_keyLay(0)\key[086]\chr[0] = ""   :  sgx_keyLay(0)\key[086]\chr[1] = ""   :  sgx_keyLay(0)\key[086]\chr[2] = ""
sgx_keyLay(0)\key[087]\pbid=#PB_Key_PadComma      :  sgx_keyLay(0)\key[087]\chr[0] = "."  :  sgx_keyLay(0)\key[087]\chr[1] = ""   :  sgx_keyLay(0)\key[087]\chr[2] = ""
sgx_keyLay(0)\key[088]\pbid=#PB_Key_Divide        :  sgx_keyLay(0)\key[088]\chr[0] = "/"  :  sgx_keyLay(0)\key[088]\chr[1] = "/"  :  sgx_keyLay(0)\key[088]\chr[2] = ""
sgx_keyLay(0)\key[089]\pbid=#PB_Key_RightAlt      :  sgx_keyLay(0)\key[089]\chr[0] = ""   :  sgx_keyLay(0)\key[089]\chr[1] = ""   :  sgx_keyLay(0)\key[089]\chr[2] = ""
sgx_keyLay(0)\key[090]\pbid=#PB_Key_Pause         :  sgx_keyLay(0)\key[090]\chr[0] = ""   :  sgx_keyLay(0)\key[090]\chr[1] = ""   :  sgx_keyLay(0)\key[090]\chr[2] = ""
sgx_keyLay(0)\key[091]\pbid=#PB_Key_Home          :  sgx_keyLay(0)\key[091]\chr[0] = ""   :  sgx_keyLay(0)\key[091]\chr[1] = ""   :  sgx_keyLay(0)\key[091]\chr[2] = ""
sgx_keyLay(0)\key[092]\pbid=#PB_Key_Up            :  sgx_keyLay(0)\key[092]\chr[0] = ""   :  sgx_keyLay(0)\key[092]\chr[1] = ""   :  sgx_keyLay(0)\key[092]\chr[2] = ""
sgx_keyLay(0)\key[093]\pbid=#PB_Key_Down          :  sgx_keyLay(0)\key[093]\chr[0] = ""   :  sgx_keyLay(0)\key[093]\chr[1] = ""   :  sgx_keyLay(0)\key[093]\chr[2] = ""
sgx_keyLay(0)\key[094]\pbid=#PB_Key_Left          :  sgx_keyLay(0)\key[094]\chr[0] = ""   :  sgx_keyLay(0)\key[094]\chr[1] = ""   :  sgx_keyLay(0)\key[094]\chr[2] = ""
sgx_keyLay(0)\key[095]\pbid=#PB_Key_Right         :  sgx_keyLay(0)\key[095]\chr[0] = ""   :  sgx_keyLay(0)\key[095]\chr[1] = ""   :  sgx_keyLay(0)\key[095]\chr[2] = ""
sgx_keyLay(0)\key[096]\pbid=#PB_Key_End           :  sgx_keyLay(0)\key[096]\chr[0] = ""   :  sgx_keyLay(0)\key[096]\chr[1] = ""   :  sgx_keyLay(0)\key[096]\chr[2] = ""
sgx_keyLay(0)\key[097]\pbid=#PB_Key_PageUp        :  sgx_keyLay(0)\key[097]\chr[0] = ""   :  sgx_keyLay(0)\key[097]\chr[1] = ""   :  sgx_keyLay(0)\key[097]\chr[2] = ""
sgx_keyLay(0)\key[098]\pbid=#PB_Key_PageDown      :  sgx_keyLay(0)\key[098]\chr[0] = ""   :  sgx_keyLay(0)\key[098]\chr[1] = ""   :  sgx_keyLay(0)\key[098]\chr[2] = ""
sgx_keyLay(0)\key[099]\pbid=#PB_Key_Insert        :  sgx_keyLay(0)\key[099]\chr[0] = ""   :  sgx_keyLay(0)\key[099]\chr[1] = ""   :  sgx_keyLay(0)\key[099]\chr[2] = ""
sgx_keyLay(0)\key[100]\pbid=#PB_Key_Delete        :  sgx_keyLay(0)\key[100]\chr[0] = ""   :  sgx_keyLay(0)\key[100]\chr[1] = ""   :  sgx_keyLay(0)\key[100]\chr[2] = ""
;}
;  ----------


;{ ---------- define table 1 - qwertz / german
;sgx_keyLay(1)             pbid                       ---    chr[0] / mode 0 / normal           ---  chr[1] / mode 1 / shift              ---  chr[2] / mode 2 / alt-gr


sgx_keyLay(1)\key[000]\pbid=#PB_Key_1             :  sgx_keyLay(1)\key[000]\chr[0] = "1"  :  sgx_keyLay(1)\key[000]\chr[1] = "!"  :  sgx_keyLay(1)\key[000]\chr[2] = ""
sgx_keyLay(1)\key[001]\pbid=#PB_Key_2             :  sgx_keyLay(1)\key[001]\chr[0] = "2"  :  sgx_keyLay(1)\key[001]\chr[1]=Chr(34):  sgx_keyLay(1)\key[001]\chr[2] = "²"
sgx_keyLay(1)\key[002]\pbid=#PB_Key_3             :  sgx_keyLay(1)\key[002]\chr[0] = "3"  :  sgx_keyLay(1)\key[002]\chr[1] = "§"  :  sgx_keyLay(1)\key[002]\chr[2] = "³"
sgx_keyLay(1)\key[003]\pbid=#PB_Key_4             :  sgx_keyLay(1)\key[003]\chr[0] = "4"  :  sgx_keyLay(1)\key[003]\chr[1] = "$"  :  sgx_keyLay(1)\key[003]\chr[2] = ""
sgx_keyLay(1)\key[004]\pbid=#PB_Key_5             :  sgx_keyLay(1)\key[004]\chr[0] = "5"  :  sgx_keyLay(1)\key[004]\chr[1] = "%"  :  sgx_keyLay(1)\key[004]\chr[2] = ""
sgx_keyLay(1)\key[005]\pbid=#PB_Key_6             :  sgx_keyLay(1)\key[005]\chr[0] = "6"  :  sgx_keyLay(1)\key[005]\chr[1] = "&"  :  sgx_keyLay(1)\key[005]\chr[2] = ""
sgx_keyLay(1)\key[006]\pbid=#PB_Key_7             :  sgx_keyLay(1)\key[006]\chr[0] = "7"  :  sgx_keyLay(1)\key[006]\chr[1] = "/"  :  sgx_keyLay(1)\key[006]\chr[2] = "{"
sgx_keyLay(1)\key[007]\pbid=#PB_Key_8             :  sgx_keyLay(1)\key[007]\chr[0] = "8"  :  sgx_keyLay(1)\key[007]\chr[1] = "("  :  sgx_keyLay(1)\key[007]\chr[2] = "["
sgx_keyLay(1)\key[008]\pbid=#PB_Key_9             :  sgx_keyLay(1)\key[008]\chr[0] = "9"  :  sgx_keyLay(1)\key[008]\chr[1] = ")"  :  sgx_keyLay(1)\key[008]\chr[2] = "]"
sgx_keyLay(1)\key[009]\pbid=#PB_Key_0             :  sgx_keyLay(1)\key[009]\chr[0] = "0"  :  sgx_keyLay(1)\key[009]\chr[1] = "="  :  sgx_keyLay(1)\key[009]\chr[2] = "}"

sgx_keyLay(1)\key[010]\pbid=#PB_Key_A             :  sgx_keyLay(1)\key[010]\chr[0] = "a"  :  sgx_keyLay(1)\key[010]\chr[1] = "A"  :  sgx_keyLay(1)\key[010]\chr[2] = ""
sgx_keyLay(1)\key[011]\pbid=#PB_Key_B             :  sgx_keyLay(1)\key[011]\chr[0] = "b"  :  sgx_keyLay(1)\key[011]\chr[1] = "B"  :  sgx_keyLay(1)\key[011]\chr[2] = ""
sgx_keyLay(1)\key[012]\pbid=#PB_Key_C             :  sgx_keyLay(1)\key[012]\chr[0] = "c"  :  sgx_keyLay(1)\key[012]\chr[1] = "C"  :  sgx_keyLay(1)\key[012]\chr[2] = ""
sgx_keyLay(1)\key[013]\pbid=#PB_Key_D             :  sgx_keyLay(1)\key[013]\chr[0] = "d"  :  sgx_keyLay(1)\key[013]\chr[1] = "D"  :  sgx_keyLay(1)\key[013]\chr[2] = ""
sgx_keyLay(1)\key[014]\pbid=#PB_Key_E             :  sgx_keyLay(1)\key[014]\chr[0] = "e"  :  sgx_keyLay(1)\key[014]\chr[1] = "E"  :  sgx_keyLay(1)\key[014]\chr[2] = ""
sgx_keyLay(1)\key[015]\pbid=#PB_Key_F             :  sgx_keyLay(1)\key[015]\chr[0] = "f"  :  sgx_keyLay(1)\key[015]\chr[1] = "F"  :  sgx_keyLay(1)\key[015]\chr[2] = ""
sgx_keyLay(1)\key[016]\pbid=#PB_Key_G             :  sgx_keyLay(1)\key[016]\chr[0] = "g"  :  sgx_keyLay(1)\key[016]\chr[1] = "G"  :  sgx_keyLay(1)\key[016]\chr[2] = ""
sgx_keyLay(1)\key[017]\pbid=#PB_Key_H             :  sgx_keyLay(1)\key[017]\chr[0] = "h"  :  sgx_keyLay(1)\key[017]\chr[1] = "H"  :  sgx_keyLay(1)\key[017]\chr[2] = ""
sgx_keyLay(1)\key[018]\pbid=#PB_Key_I             :  sgx_keyLay(1)\key[018]\chr[0] = "i"  :  sgx_keyLay(1)\key[018]\chr[1] = "I"  :  sgx_keyLay(1)\key[018]\chr[2] = ""
sgx_keyLay(1)\key[019]\pbid=#PB_Key_J             :  sgx_keyLay(1)\key[019]\chr[0] = "j"  :  sgx_keyLay(1)\key[019]\chr[1] = "J"  :  sgx_keyLay(1)\key[019]\chr[2] = ""
sgx_keyLay(1)\key[020]\pbid=#PB_Key_K             :  sgx_keyLay(1)\key[020]\chr[0] = "k"  :  sgx_keyLay(1)\key[020]\chr[1] = "K"  :  sgx_keyLay(1)\key[020]\chr[2] = ""
sgx_keyLay(1)\key[021]\pbid=#PB_Key_L             :  sgx_keyLay(1)\key[021]\chr[0] = "l"  :  sgx_keyLay(1)\key[021]\chr[1] = "L"  :  sgx_keyLay(1)\key[021]\chr[2] = ""
sgx_keyLay(1)\key[022]\pbid=#PB_Key_M             :  sgx_keyLay(1)\key[022]\chr[0] = "m"  :  sgx_keyLay(1)\key[022]\chr[1] = "M"  :  sgx_keyLay(1)\key[022]\chr[2] = "µ"
sgx_keyLay(1)\key[023]\pbid=#PB_Key_N             :  sgx_keyLay(1)\key[023]\chr[0] = "n"  :  sgx_keyLay(1)\key[023]\chr[1] = "N"  :  sgx_keyLay(1)\key[023]\chr[2] = ""
sgx_keyLay(1)\key[024]\pbid=#PB_Key_O             :  sgx_keyLay(1)\key[024]\chr[0] = "o"  :  sgx_keyLay(1)\key[024]\chr[1] = "O"  :  sgx_keyLay(1)\key[024]\chr[2] = ""
sgx_keyLay(1)\key[025]\pbid=#PB_Key_P             :  sgx_keyLay(1)\key[025]\chr[0] = "p"  :  sgx_keyLay(1)\key[025]\chr[1] = "P"  :  sgx_keyLay(1)\key[025]\chr[2] = ""
sgx_keyLay(1)\key[026]\pbid=#PB_Key_Q             :  sgx_keyLay(1)\key[026]\chr[0] = "q"  :  sgx_keyLay(1)\key[026]\chr[1] = "Q"  :  sgx_keyLay(1)\key[026]\chr[2] = "@"
sgx_keyLay(1)\key[027]\pbid=#PB_Key_R             :  sgx_keyLay(1)\key[027]\chr[0] = "r"  :  sgx_keyLay(1)\key[027]\chr[1] = "R"  :  sgx_keyLay(1)\key[027]\chr[2] = ""
sgx_keyLay(1)\key[028]\pbid=#PB_Key_S             :  sgx_keyLay(1)\key[028]\chr[0] = "s"  :  sgx_keyLay(1)\key[028]\chr[1] = "S"  :  sgx_keyLay(1)\key[028]\chr[2] = ""
sgx_keyLay(1)\key[029]\pbid=#PB_Key_T             :  sgx_keyLay(1)\key[029]\chr[0] = "t"  :  sgx_keyLay(1)\key[029]\chr[1] = "T"  :  sgx_keyLay(1)\key[029]\chr[2] = ""
sgx_keyLay(1)\key[030]\pbid=#PB_Key_U             :  sgx_keyLay(1)\key[030]\chr[0] = "u"  :  sgx_keyLay(1)\key[030]\chr[1] = "U"  :  sgx_keyLay(1)\key[030]\chr[2] = ""
sgx_keyLay(1)\key[031]\pbid=#PB_Key_V             :  sgx_keyLay(1)\key[031]\chr[0] = "v"  :  sgx_keyLay(1)\key[031]\chr[1] = "V"  :  sgx_keyLay(1)\key[031]\chr[2] = ""
sgx_keyLay(1)\key[032]\pbid=#PB_Key_W             :  sgx_keyLay(1)\key[032]\chr[0] = "w"  :  sgx_keyLay(1)\key[032]\chr[1] = "W"  :  sgx_keyLay(1)\key[032]\chr[2] = ""
sgx_keyLay(1)\key[033]\pbid=#PB_Key_X             :  sgx_keyLay(1)\key[033]\chr[0] = "x"  :  sgx_keyLay(1)\key[033]\chr[1] = "X"  :  sgx_keyLay(1)\key[033]\chr[2] = ""
sgx_keyLay(1)\key[034]\pbid=#PB_Key_Y             :  sgx_keyLay(1)\key[034]\chr[0] = "z"  :  sgx_keyLay(1)\key[034]\chr[1] = "Z"  :  sgx_keyLay(1)\key[034]\chr[2] = ""
sgx_keyLay(1)\key[035]\pbid=#PB_Key_Z             :  sgx_keyLay(1)\key[035]\chr[0] = "y"  :  sgx_keyLay(1)\key[035]\chr[1] = "Y"  :  sgx_keyLay(1)\key[035]\chr[2] = ""

sgx_keyLay(1)\key[036]\pbid=#PB_Key_Escape        :  sgx_keyLay(1)\key[036]\chr[0] = ""   :  sgx_keyLay(1)\key[036]\chr[1] = ""   :  sgx_keyLay(1)\key[036]\chr[2] = ""
sgx_keyLay(1)\key[037]\pbid=#PB_Key_Minus         :  sgx_keyLay(1)\key[037]\chr[0] = "ß"  :  sgx_keyLay(1)\key[037]\chr[1] = "?"  :  sgx_keyLay(1)\key[037]\chr[2] = "\"
sgx_keyLay(1)\key[038]\pbid=#PB_Key_Equals        :  sgx_keyLay(1)\key[038]\chr[0] = "´"  :  sgx_keyLay(1)\key[038]\chr[1] = "`"  :  sgx_keyLay(1)\key[038]\chr[2] = ""
sgx_keyLay(1)\key[039]\pbid=#PB_Key_Back          :  sgx_keyLay(1)\key[039]\chr[0] = ""   :  sgx_keyLay(1)\key[039]\chr[1] = ""   :  sgx_keyLay(1)\key[039]\chr[2] = ""
sgx_keyLay(1)\key[040]\pbid=#PB_Key_Tab           :  sgx_keyLay(1)\key[040]\chr[0] = ""   :  sgx_keyLay(1)\key[040]\chr[1] = ""   :  sgx_keyLay(1)\key[040]\chr[2] = ""
sgx_keyLay(1)\key[041]\pbid=#PB_Key_LeftBracket   :  sgx_keyLay(1)\key[041]\chr[0] = "ü"  :  sgx_keyLay(1)\key[041]\chr[1] = "Ü"  :  sgx_keyLay(1)\key[041]\chr[2] = ""
sgx_keyLay(1)\key[042]\pbid=#PB_Key_RightBracket  :  sgx_keyLay(1)\key[042]\chr[0] = "+"  :  sgx_keyLay(1)\key[042]\chr[1] = "*"  :  sgx_keyLay(1)\key[042]\chr[2] = "~"
sgx_keyLay(1)\key[043]\pbid=#PB_Key_Return        :  sgx_keyLay(1)\key[043]\chr[0] = ""   :  sgx_keyLay(1)\key[043]\chr[1] = ""   :  sgx_keyLay(1)\key[043]\chr[2] = ""
sgx_keyLay(1)\key[044]\pbid=#PB_Key_LeftControl   :  sgx_keyLay(1)\key[044]\chr[0] = ""   :  sgx_keyLay(1)\key[044]\chr[1] = ""   :  sgx_keyLay(1)\key[044]\chr[2] = ""
sgx_keyLay(1)\key[045]\pbid=#PB_Key_SemiColon     :  sgx_keyLay(1)\key[045]\chr[0] = "ö"  :  sgx_keyLay(1)\key[045]\chr[1] = "Ö"  :  sgx_keyLay(1)\key[045]\chr[2] = ""
sgx_keyLay(1)\key[046]\pbid=#PB_Key_Apostrophe    :  sgx_keyLay(1)\key[046]\chr[0] = "ä"  :  sgx_keyLay(1)\key[046]\chr[1] = "Ä"  :  sgx_keyLay(1)\key[046]\chr[2] = ""
sgx_keyLay(1)\key[047]\pbid=#PB_Key_Grave         :  sgx_keyLay(1)\key[047]\chr[0] = "^"  :  sgx_keyLay(1)\key[047]\chr[1] = "°"  :  sgx_keyLay(1)\key[047]\chr[2] = ""
sgx_keyLay(1)\key[048]\pbid=#PB_Key_LeftShift     :  sgx_keyLay(1)\key[048]\chr[0] = ""   :  sgx_keyLay(1)\key[048]\chr[1] = ""   :  sgx_keyLay(1)\key[048]\chr[2] = ""
sgx_keyLay(1)\key[049]\pbid=#PB_Key_BackSlash     :  sgx_keyLay(1)\key[049]\chr[0] = "#"  :  sgx_keyLay(1)\key[049]\chr[1] = "'"  :  sgx_keyLay(1)\key[049]\chr[2] = ""
sgx_keyLay(1)\key[050]\pbid=#PB_Key_Comma         :  sgx_keyLay(1)\key[050]\chr[0] = ","  :  sgx_keyLay(1)\key[050]\chr[1] = ";"  :  sgx_keyLay(1)\key[050]\chr[2] = "<"
sgx_keyLay(1)\key[051]\pbid=#PB_Key_Period        :  sgx_keyLay(1)\key[051]\chr[0] = "."  :  sgx_keyLay(1)\key[051]\chr[1] = ":"  :  sgx_keyLay(1)\key[051]\chr[2] = ">"
sgx_keyLay(1)\key[052]\pbid=#PB_Key_Slash         :  sgx_keyLay(1)\key[052]\chr[0] = "-"  :  sgx_keyLay(1)\key[052]\chr[1] = "_"  :  sgx_keyLay(1)\key[052]\chr[2] = "|"
sgx_keyLay(1)\key[053]\pbid=#PB_Key_RightShift    :  sgx_keyLay(1)\key[053]\chr[0] = ""   :  sgx_keyLay(1)\key[053]\chr[1] = ""   :  sgx_keyLay(1)\key[053]\chr[2] = ""
sgx_keyLay(1)\key[054]\pbid=#PB_Key_Multiply      :  sgx_keyLay(1)\key[054]\chr[0] = "*"  :  sgx_keyLay(1)\key[054]\chr[1] = "*"  :  sgx_keyLay(1)\key[054]\chr[2] = ""
sgx_keyLay(1)\key[055]\pbid=#PB_Key_LeftAlt       :  sgx_keyLay(1)\key[055]\chr[0] = ""   :  sgx_keyLay(1)\key[055]\chr[1] = ""   :  sgx_keyLay(1)\key[055]\chr[2] = ""
sgx_keyLay(1)\key[056]\pbid=#PB_Key_Space         :  sgx_keyLay(1)\key[056]\chr[0] = " "  :  sgx_keyLay(1)\key[056]\chr[1] = " "  :  sgx_keyLay(1)\key[056]\chr[2] = ""
sgx_keyLay(1)\key[057]\pbid=#PB_Key_Capital       :  sgx_keyLay(1)\key[057]\chr[0] = ""   :  sgx_keyLay(1)\key[057]\chr[1] = ""   :  sgx_keyLay(1)\key[057]\chr[2] = ""

sgx_keyLay(1)\key[058]\pbid=#PB_Key_F1            :  sgx_keyLay(1)\key[058]\chr[0] = ""   :  sgx_keyLay(1)\key[058]\chr[1] = ""   :  sgx_keyLay(1)\key[058]\chr[2] = ""
sgx_keyLay(1)\key[059]\pbid=#PB_Key_F2            :  sgx_keyLay(1)\key[059]\chr[0] = ""   :  sgx_keyLay(1)\key[059]\chr[1] = ""   :  sgx_keyLay(1)\key[059]\chr[2] = ""
sgx_keyLay(1)\key[060]\pbid=#PB_Key_F3            :  sgx_keyLay(1)\key[060]\chr[0] = ""   :  sgx_keyLay(1)\key[060]\chr[1] = ""   :  sgx_keyLay(1)\key[060]\chr[2] = ""
sgx_keyLay(1)\key[061]\pbid=#PB_Key_F4            :  sgx_keyLay(1)\key[061]\chr[0] = ""   :  sgx_keyLay(1)\key[061]\chr[1] = ""   :  sgx_keyLay(1)\key[061]\chr[2] = ""
sgx_keyLay(1)\key[062]\pbid=#PB_Key_F5            :  sgx_keyLay(1)\key[062]\chr[0] = ""   :  sgx_keyLay(1)\key[062]\chr[1] = ""   :  sgx_keyLay(1)\key[062]\chr[2] = ""
sgx_keyLay(1)\key[063]\pbid=#PB_Key_F6            :  sgx_keyLay(1)\key[063]\chr[0] = ""   :  sgx_keyLay(1)\key[063]\chr[1] = ""   :  sgx_keyLay(1)\key[063]\chr[2] = ""
sgx_keyLay(1)\key[064]\pbid=#PB_Key_F7            :  sgx_keyLay(1)\key[064]\chr[0] = ""   :  sgx_keyLay(1)\key[064]\chr[1] = ""   :  sgx_keyLay(1)\key[064]\chr[2] = ""
sgx_keyLay(1)\key[065]\pbid=#PB_Key_F8            :  sgx_keyLay(1)\key[065]\chr[0] = ""   :  sgx_keyLay(1)\key[065]\chr[1] = ""   :  sgx_keyLay(1)\key[065]\chr[2] = ""
sgx_keyLay(1)\key[066]\pbid=#PB_Key_F9            :  sgx_keyLay(1)\key[066]\chr[0] = ""   :  sgx_keyLay(1)\key[066]\chr[1] = ""   :  sgx_keyLay(1)\key[066]\chr[2] = ""
sgx_keyLay(1)\key[067]\pbid=#PB_Key_F10           :  sgx_keyLay(1)\key[067]\chr[0] = ""   :  sgx_keyLay(1)\key[067]\chr[1] = ""   :  sgx_keyLay(1)\key[067]\chr[2] = ""
sgx_keyLay(1)\key[068]\pbid=#PB_Key_F11           :  sgx_keyLay(1)\key[068]\chr[0] = ""   :  sgx_keyLay(1)\key[068]\chr[1] = ""   :  sgx_keyLay(1)\key[068]\chr[2] = ""
sgx_keyLay(1)\key[069]\pbid=#PB_Key_F12           :  sgx_keyLay(1)\key[069]\chr[0] = ""   :  sgx_keyLay(1)\key[069]\chr[1] = ""   :  sgx_keyLay(1)\key[069]\chr[2] = ""

sgx_keyLay(1)\key[070]\pbid=#PB_Key_NumLock       :  sgx_keyLay(1)\key[070]\chr[0] = ""   :  sgx_keyLay(1)\key[070]\chr[1] = ""   :  sgx_keyLay(1)\key[070]\chr[2] = ""
sgx_keyLay(1)\key[071]\pbid=#PB_Key_Scroll        :  sgx_keyLay(1)\key[071]\chr[0] = ""   :  sgx_keyLay(1)\key[071]\chr[1] = ""   :  sgx_keyLay(1)\key[071]\chr[2] = ""
sgx_keyLay(1)\key[072]\pbid=#PB_Key_Pad0          :  sgx_keyLay(1)\key[072]\chr[0] = "0"  :  sgx_keyLay(1)\key[072]\chr[1] = "0"  :  sgx_keyLay(1)\key[072]\chr[2] = ""
sgx_keyLay(1)\key[073]\pbid=#PB_Key_Pad1          :  sgx_keyLay(1)\key[073]\chr[0] = "1"  :  sgx_keyLay(1)\key[073]\chr[1] = "1"  :  sgx_keyLay(1)\key[073]\chr[2] = ""
sgx_keyLay(1)\key[074]\pbid=#PB_Key_Pad2          :  sgx_keyLay(1)\key[074]\chr[0] = "2"  :  sgx_keyLay(1)\key[074]\chr[1] = "2"  :  sgx_keyLay(1)\key[074]\chr[2] = ""
sgx_keyLay(1)\key[075]\pbid=#PB_Key_Pad3          :  sgx_keyLay(1)\key[075]\chr[0] = "3"  :  sgx_keyLay(1)\key[075]\chr[1] = "3"  :  sgx_keyLay(1)\key[075]\chr[2] = ""
sgx_keyLay(1)\key[076]\pbid=#PB_Key_Pad4          :  sgx_keyLay(1)\key[076]\chr[0] = "4"  :  sgx_keyLay(1)\key[076]\chr[1] = "4"  :  sgx_keyLay(1)\key[076]\chr[2] = ""
sgx_keyLay(1)\key[077]\pbid=#PB_Key_Pad5          :  sgx_keyLay(1)\key[077]\chr[0] = "5"  :  sgx_keyLay(1)\key[077]\chr[1] = "5"  :  sgx_keyLay(1)\key[077]\chr[2] = ""
sgx_keyLay(1)\key[078]\pbid=#PB_Key_Pad6          :  sgx_keyLay(1)\key[078]\chr[0] = "6"  :  sgx_keyLay(1)\key[078]\chr[1] = "6"  :  sgx_keyLay(1)\key[078]\chr[2] = ""
sgx_keyLay(1)\key[079]\pbid=#PB_Key_Pad7          :  sgx_keyLay(1)\key[079]\chr[0] = "7"  :  sgx_keyLay(1)\key[079]\chr[1] = "7"  :  sgx_keyLay(1)\key[079]\chr[2] = ""
sgx_keyLay(1)\key[080]\pbid=#PB_Key_Pad8          :  sgx_keyLay(1)\key[080]\chr[0] = "8"  :  sgx_keyLay(1)\key[080]\chr[1] = "8"  :  sgx_keyLay(1)\key[080]\chr[2] = ""
sgx_keyLay(1)\key[081]\pbid=#PB_Key_Pad9          :  sgx_keyLay(1)\key[081]\chr[0] = "9"  :  sgx_keyLay(1)\key[081]\chr[1] = "9"  :  sgx_keyLay(1)\key[081]\chr[2] = ""

sgx_keyLay(1)\key[082]\pbid=#PB_Key_Add           :  sgx_keyLay(1)\key[082]\chr[0] = "+"  :  sgx_keyLay(1)\key[082]\chr[1] = "+"  :  sgx_keyLay(1)\key[082]\chr[2] = ""
sgx_keyLay(1)\key[083]\pbid=#PB_Key_Subtract      :  sgx_keyLay(1)\key[083]\chr[0] = "-"  :  sgx_keyLay(1)\key[083]\chr[1] = "-"  :  sgx_keyLay(1)\key[083]\chr[2] = ""
sgx_keyLay(1)\key[084]\pbid=#PB_Key_Decimal       :  sgx_keyLay(1)\key[084]\chr[0] = ","  :  sgx_keyLay(1)\key[084]\chr[1] = ","  :  sgx_keyLay(1)\key[084]\chr[2] = ""
sgx_keyLay(1)\key[085]\pbid=#PB_Key_PadEnter      :  sgx_keyLay(1)\key[085]\chr[0] = ""   :  sgx_keyLay(1)\key[085]\chr[1] = ""   :  sgx_keyLay(1)\key[085]\chr[2] = ""
sgx_keyLay(1)\key[086]\pbid=#PB_Key_RightControl  :  sgx_keyLay(1)\key[086]\chr[0] = ""   :  sgx_keyLay(1)\key[086]\chr[1] = ""   :  sgx_keyLay(1)\key[086]\chr[2] = ""
sgx_keyLay(1)\key[087]\pbid=#PB_Key_PadComma      :  sgx_keyLay(1)\key[087]\chr[0] = ","  :  sgx_keyLay(1)\key[087]\chr[1] = ""   :  sgx_keyLay(1)\key[087]\chr[2] = ""
sgx_keyLay(1)\key[088]\pbid=#PB_Key_Divide        :  sgx_keyLay(1)\key[088]\chr[0] = "/"  :  sgx_keyLay(1)\key[088]\chr[1] = "/"  :  sgx_keyLay(1)\key[088]\chr[2] = ""
sgx_keyLay(1)\key[089]\pbid=#PB_Key_RightAlt      :  sgx_keyLay(1)\key[089]\chr[0] = ""   :  sgx_keyLay(1)\key[089]\chr[1] = ""   :  sgx_keyLay(1)\key[089]\chr[2] = ""
sgx_keyLay(1)\key[090]\pbid=#PB_Key_Pause         :  sgx_keyLay(1)\key[090]\chr[0] = ""   :  sgx_keyLay(1)\key[090]\chr[1] = ""   :  sgx_keyLay(1)\key[090]\chr[2] = ""
sgx_keyLay(1)\key[091]\pbid=#PB_Key_Home          :  sgx_keyLay(1)\key[091]\chr[0] = ""   :  sgx_keyLay(1)\key[091]\chr[1] = ""   :  sgx_keyLay(1)\key[091]\chr[2] = ""
sgx_keyLay(1)\key[092]\pbid=#PB_Key_Up            :  sgx_keyLay(1)\key[092]\chr[0] = ""   :  sgx_keyLay(1)\key[092]\chr[1] = ""   :  sgx_keyLay(1)\key[092]\chr[2] = ""
sgx_keyLay(1)\key[093]\pbid=#PB_Key_Down          :  sgx_keyLay(1)\key[093]\chr[0] = ""   :  sgx_keyLay(1)\key[093]\chr[1] = ""   :  sgx_keyLay(1)\key[093]\chr[2] = ""
sgx_keyLay(1)\key[094]\pbid=#PB_Key_Left          :  sgx_keyLay(1)\key[094]\chr[0] = ""   :  sgx_keyLay(1)\key[094]\chr[1] = ""   :  sgx_keyLay(1)\key[094]\chr[2] = ""
sgx_keyLay(1)\key[095]\pbid=#PB_Key_Right         :  sgx_keyLay(1)\key[095]\chr[0] = ""   :  sgx_keyLay(1)\key[095]\chr[1] = ""   :  sgx_keyLay(1)\key[095]\chr[2] = ""
sgx_keyLay(1)\key[096]\pbid=#PB_Key_End           :  sgx_keyLay(1)\key[096]\chr[0] = ""   :  sgx_keyLay(1)\key[096]\chr[1] = ""   :  sgx_keyLay(1)\key[096]\chr[2] = ""
sgx_keyLay(1)\key[097]\pbid=#PB_Key_PageUp        :  sgx_keyLay(1)\key[097]\chr[0] = ""   :  sgx_keyLay(1)\key[097]\chr[1] = ""   :  sgx_keyLay(1)\key[097]\chr[2] = ""
sgx_keyLay(1)\key[098]\pbid=#PB_Key_PageDown      :  sgx_keyLay(1)\key[098]\chr[0] = ""   :  sgx_keyLay(1)\key[098]\chr[1] = ""   :  sgx_keyLay(1)\key[098]\chr[2] = ""
sgx_keyLay(1)\key[099]\pbid=#PB_Key_Insert        :  sgx_keyLay(1)\key[099]\chr[0] = ""   :  sgx_keyLay(1)\key[099]\chr[1] = ""   :  sgx_keyLay(1)\key[099]\chr[2] = ""
sgx_keyLay(1)\key[100]\pbid=#PB_Key_Delete        :  sgx_keyLay(1)\key[100]\chr[0] = ""   :  sgx_keyLay(1)\key[100]\chr[1] = ""   :  sgx_keyLay(1)\key[100]\chr[2] = ""

;}
;  ----------

        

;** sgxSetKeyboardLayout:
;* configure keyboard layout and keystroke delay used by sgxEdit elements (via <a href=#f_sgx_keyboardedit>sgx_keyboardEdit</a>). _
;* when using qwerty layout the characters '<', '>' (angle brackets) and '|' (pipe) can be accessed via 'alt-gr' + ',' / '.' / '-' (comma, dot and hyphen).
;** .layout           : #sgxKeyLayQwerty (default) for qwerty / US keyboard layout. #sgxKeyLayQwertz for qwertz / DE
;** .keystrokeDelay_1 : the keystroke delay after a first key-push in milliseconds (default 280)
;** .keystrokeDelay_2 : the keystroke delay for continuous key-push in milliseconds (default 40)
Procedure sgxSetKeyboardLayout(layout=#sgxKeyLayQwerty, keystrokeDelay_1=280, keystrokeDelay_2=40)
  If layout >= 0 And layout <= ArraySize(sgx_keyLay())
    sgx_keyLayout = layout
  EndIf
  sgx_keystrokeDelay_1 = keystrokeDelay_1
  sgx_keystrokeDelay_2 = keystrokeDelay_2
EndProcedure


;** sgx_keyboardEdit
;* defines string operations on keyboard data. (text editing) _
;* basic usage: _
;* <pre>
;* sgxSetKeyboardLayout() _
;* Repeat _
;* <span></span>  ExamineKeyboard() _
;* <span></span>  text = sgx_keyboardEdit(text, textpos) _
;* <span></span>  textpos = keyboardEdit_lastTextPos _
;* <span></span>  if sgx_keyboardEdit_TextModified _
;* <span></span>    ; text or textpos changed _
;* <span></span>  ;... _
;* </pre>
;* if after a call of this function 'sgx_keyboardEdit_TextModified' is #True then the text or the textpos has changed. it will be #False if no change occured. _
;* the possibly changed text is returned and 'sgx_keyboardEdit_lastTextPos' will be set to the current textpos. _
;* you can configure keyboard layout and keystroke delay via <a href=#f_sgxsetkeyboardlayout>sgxSetKeyboardLayout</a>
;** .text            : the text to be edited.
;** .textpos         : the initial cursor position in characters including linebreaks. -1 (default) means beginning of text. the position might change during the call i.e. if cursor keys have been used ot text has been entered. use sgx_keyboardEdit_lastTextPos to get the updated value after a call.
;** .maxLines        : the maximum lines allowed. -1 (default) means no limit.
Procedure.s sgx_keyboardEdit(text.s, textpos=-1, maxLines=-1)
  Static mode
  Static caps
  Static cntrl
  Static textPartA.s
  Static textPartB.s
  Static ems
  Static k
  Static i
  Static timeout
  Static temp
  Static textlen
  
  DisableDebugger
  
  sgx_keyboardEdit_TextModified = #False
  
  If textpos<0
    textpos=0
  EndIf
  If textpos>Len(text)
    textpos=Len(text)
  EndIf
  If maxLines>0 And CountString(text,#LF$)+1>maxLines
    textPartA=""
    For i=1 To maxLines
      textPartA + StringField(text,i,#LF$) + #LF$
    Next
    text = Left(textPartA, Len(textPartA)-1)
    sgx_keyboardEdit_TextModified = #True
  EndIf
  
  textPartA = Mid(text,1,textpos)
  textPartB = Mid(text,textpos+1,Len(text))
  
  ems=ElapsedMilliseconds()
  
  
  For k=0 To 100
    If KeyboardReleased(sgx_keyLay(sgx_keyLayout)\key[k]\pbid)
      sgx_keyLay(sgx_keyLayout)\key[k]\timer = 0
      sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
    EndIf
  Next
  
  caps = #False
  If (KeyboardPushed(#PB_Key_LeftShift) Or KeyboardPushed(#PB_Key_RightShift))  And  (Not KeyboardPushed(#PB_Key_Capital))
    caps = #True
  ElseIf Not (KeyboardPushed(#PB_Key_LeftShift) Or KeyboardPushed(#PB_Key_RightShift))  And  KeyboardPushed(#PB_Key_Capital)
    caps = #True
  EndIf
  
  If KeyboardPushed(#PB_Key_All)
    
    If KeyboardPushed(#PB_Key_RightAlt)
      mode = 2
    ElseIf caps
      mode = 1
    Else
      mode = 0
    EndIf

    If KeyboardPushed(#PB_Key_LeftControl) Or KeyboardPushed(#PB_Key_RightControl)
      cntrl = 1
    Else
      cntrl = 0
    EndIf
    
  
    For k=0 To 100
      
      If KeyboardPushed(sgx_keyLay(sgx_keyLayout)\key[k]\pbid)
        
        ;[-keystroke-delayed-]
        
        If sgx_keyLay(sgx_keyLayout)\key[k]\timer < ems             ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          timeout=1
          
          ;{ BACK
          If sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Back
            textPartA = LSet( textPartA, Len(textPartA)-1 )
            textpos = Len(textPartA)
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
            ;}
          
          ;{ DEL  
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Delete
            textPartB = Right( textPartB, Len(textPartB)-1 )
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
            ;}
            
          ;{ RETURN
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Return Or sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_PadEnter
            If maxLines<1  Or  CountString(text,#LF$)+1<maxLines
              textPartA + #LF$
              textpos = Len(textPartA)
              If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
                sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
                sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
                sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
              EndIf
            EndIf
            ;}
            
          ;{ LEFT
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Left
            textpos-1
            If textpos<0 : textpos=0 : EndIf
            textPartA = Mid(text,1,textpos)
            textPartB = Mid(text,textpos+1,Len(text))
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
            ;}
            
          ;{ RIGHT
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Right
            textpos+1
            If textpos>=Len(text) : textpos=Len(text) : EndIf
            textPartA = Mid(text,1,textpos)
            textPartB = Mid(text,textpos+1,Len(text))
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
            ;}
          
          ;{ UP
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Up
            If Mid(text,textpos,1) = #LF$
              textpos-1
              While textpos>0  And  Mid(text,textpos,1) <> #LF$
                textpos-1
              Wend
            Else
              temp = textpos
              While textpos>0  And  Mid(text,textpos,1) <> #LF$
                textpos-1
              Wend
              If textpos=0
                textpos=temp
              Else
                temp - textpos
                textpos-1
                While textpos>0  And  Mid(text,textpos,1) <> #LF$
                  textpos-1
                Wend
                i=1
                While (Mid(text,textpos+i,1) <> #LF$) And (i < temp)
                  i+1
                Wend
                textpos + i
                If Mid(text, textpos, 1) = #LF$
                  textpos-1
                EndIf
              EndIf
            EndIf
            
            textPartA = Mid(text,1,textpos)
            textPartB = Mid(text,textpos+1,Len(text))
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
            ;}
          
          ;{ DOWN
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Down
            i = FindString(text,#LF$,textpos)
            If i>0
              textlen = Len(text)
              If Mid(text,textpos,1) = #LF$
                textpos+1

                While textpos<textlen  And  Mid(text,textpos,1) <> #LF$
                  textpos+1
                Wend
              Else
                temp = textpos
                While textpos>0  And  Mid(text,textpos,1) <> #LF$
                  textpos-1
                Wend
                temp - textpos
                textpos = i
                While (i-textpos)<temp And Mid(text,i+1,1) <> #LF$
                  i+1
                Wend
                textpos = i
              EndIf
              textPartA = Mid(text,1,textpos)
              textPartB = Mid(text,textpos+1,textlen)
              If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
                sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
                sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
                sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
              EndIf
            EndIf
            ;}
          
            
          ;{ <CHARACTERS>
          ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\chr[mode]<>""
            textPartA + sgx_keyLay(sgx_keyLayout)\key[k]\chr[mode]
            textpos + Len( sgx_keyLay(sgx_keyLayout)\key[k]\chr[mode] )
            If sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 0
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_1
              sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
            ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\delaySwitch = 1
              sgx_keyLay(sgx_keyLayout)\key[k]\timer = ems + sgx_keystrokeDelay_2
            EndIf
          EndIf
          ;}
        EndIf;
  
  
        ;[-delay-independent-]
        
        ;{ HOME
        If sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_Home
          If cntrl=1
            textpos=0
          EndIf
          While textpos>0  And  Mid(text,textpos,1) <> #LF$
            textpos-1
          Wend
          textPartA = Mid(text,1,textpos)
          textPartB = Mid(text,textpos+1,Len(text))
          ;}
          
        ;{ END
        ElseIf sgx_keyLay(sgx_keyLayout)\key[k]\pbid = #PB_Key_End
          textpos = FindString(text,#LF$,textpos+1)-1
          If textpos=-1 Or cntrl=1
            textpos=Len(text)
          EndIf
          textPartA = Mid(text,1,textpos)
          textPartB = Mid(text,textpos+1,Len(text))
        EndIf ;}
        
        
        If text <> textPartA+textPartB
          text = textPartA+textPartB
          sgx_keyboardEdit_TextModified = #True
        EndIf
        
      EndIf
    Next;k
    
  EndIf;KeyPushed_ALL
  
  
  If sgx_keyboardEdit_lastTextPos <> textpos
    sgx_keyboardEdit_TextModified = #True
    sgx_keyboardEdit_lastTextPos = textpos
  EndIf
  ProcedureReturn (textPartA + textPartB)
  
  EnableDebugger
EndProcedure


; init defaults
sgxSetKeyboardLayout()




; IDE Options = PureBasic 5.50 beta 1 (Windows - x64)
; CursorPosition = 1841
; FirstLine = 1819
; Folding = -----------6--
; Markers = 1264,1396,1495,1650,1791
; UseMainFile = demo.pb
; CompileSourceDirectory